local mod_storage_save, mod_storage_load = mod_storage_save, mod_storage_load


local currentSubmenu = {}

local selectedOption = 1

local selectedSubmenuOption = 1

local isSubmenuShown = false

local menu = false

local initCharCurValue = 'None'
local initArmorCurValue = 'None'
local initColorCurValue = 'Default'
local initSoundsCurValue = 'On'
local initMenuCurValue = 'DPAD UP and CMD'
local menuToggle = 'dpadup'

function unusedStorage()
    if (mod_storage_load('MmxChar') and mod_storage_load('MmxArmor')) then
        local mschar = mod_storage_load('MmxChar')
        local msarmor = mod_storage_load('MmxArmor')
        if (mschar == 'x' and msarmor == '0') then
            initCharCurValue = 'X'
        elseif (mschar == 'x' and msarmor == '1') then
            initCharCurValue = 'X - First Armor'
        elseif (mschar == 'vile') then
            initCharCurValue = 'Vile'
        elseif (mschar == 'none') then
            initCharCurValue = 'None'
        end
    end
    
    if (mod_storage_load('MmxColor')) then
        local mscolor = mod_storage_load('MmxColor')
        if (mscolor == 'true') then
            initColorCurValue = 'Default'
        else
            initColorCurValue = 'Palette'
        end
    end
    
    if (mod_storage_load('MmxMenu')) then
        local msmenu = mod_storage_load('MmxMenu')
        if (msmenu == 'dpadup') then
            menuToggle = 'dpadup'
            initMenuCurValue = 'DPAD UP and CMD'
        elseif (msmenu == 'cmd') then
            menuToggle = 'cmd'
            initMenuCurValue = 'CMD only'
        end
    else
        mod_storage_save('MmxMenu', 'dpadup')
    end
end

local function hideSubmenu()
    isSubmenuShown = false
    currentSubmenu = {}
    selectedSubmenuOption = 1
end

local function showSubmenu(submenu)
    isSubmenuShown = true
    currentSubmenu = submenu
    selectedSubmenuOption = 1
end

local function resetColor()
    for i = 0, PLAYER_PART_MAX - 1 do
        local color = {r = 0, g = 0, b = 0}
        network_player_get_palette_color(nil, i, color)
        network_player_set_override_palette_color(gNetworkPlayers[0], i, color)
    end
end

local function cycleChar(call)
    local s = gPlayerSyncTable[0]
    local currentStatus = call
    if (currentStatus == 'X') then
        s.character = 'zero'
        --mod_storage_save('MmxChar', 'x')
        --mod_storage_save('MmxArmor', '1')
    elseif (currentStatus == 'Zero') then
        s.character = 'vile'
        --mod_storage_save('MmxChar', 'vile')
    elseif (currentStatus == 'Vile') then
        s.character = 'none'
        s.palette_reset_signal = true
        --mod_storage_save('MmxChar', 'none')
        if (gMarioStates[0].action == ACT_IDLE) then
            set_mario_animation(gMarioStates[0], MARIO_ANIM_IDLE_HEAD_CENTER)
        end
    elseif (currentStatus == 'None') then
        s.character = 'x'
        --mod_storage_save('MmxChar', 'x')
        --mod_storage_save('MmxArmor', '0')
    end
    s.x_shooting = 0
    s.vile_shooting = 0
    resetColor()
end

local function cycleArmor(call)
    local s = gPlayerSyncTable[0]
    local currentStatus = call
    if (currentStatus == 'None') then
        s.x_armor = 1
    elseif (currentStatus == 'First Armor') then
        s.x_armor = 2
    elseif (currentStatus == 'Second Armor') then
        s.x_armor = 0
    end
end

local function setColor(call)
    local s = gPlayerSyncTable[0]
    local currentStatus = call
    s.palette_reset_signal = true
    if (currentStatus == 'Palette') then
        s.enable_color = true
        --mod_storage_save('MmxColor', 'true')
    else
        s.enable_color = false
        --mod_storage_save('MmxColor', 'false')
    end
    resetColor()
end

local function setSounds(call)
    local currentStatus = call
    if (currentStatus == 'Off') then
        enable_sounds = true
    else
        enable_sounds = false
    end
end

local function toggleModel(call)
    local s = gPlayerSyncTable[0]
    local currentStatus = call
    if (currentStatus == 'On') then
        s.enable_model = false    
    else
        s.enable_model = true
    end
    resetColor()
end

local function toggleMenu(call)
    local s = gPlayerSyncTable[0]
    local currentStatus = call
    if (currentStatus == 'CMD only') then
        menuToggle = 'dpadup'
        --mod_storage_save('MmxMenu', 'dpadup')
    elseif (currentStatus == 'DPAD UP and CMD') then
        menuToggle = 'cmd'
        --mod_storage_save('MmxMenu', 'cmd')
    end
end

local subMenu1 = {
    { text = "OPTION 1",       func = function() end,              currentStatus = "TEST 1",   status = { "TEST 1", "TEST 2", "TEST 3", "TEST 4" } },
    { text = "OPTION 2",       func = function() end,              currentStatus = "TEST 1",   status = { "TEST 1", "TEST 2" } },
    { text = "BACK",           func = function() hideSubmenu() end },
}

local subMenu2 = {
    { text = "OPTION 1",       func = function() end,              currentStatus = "ON", status = { "ON", "OFF" } },
    { text = "OPTION 2",       func = function() end,              currentStatus = "ON", status = { "ON", "OFF" } },
    { text = "OPTION 3",       func = function() end,              currentStatus = "ON", status = { "ON", "OFF" } },
    { text = "BACK",           func = function() hideSubmenu() end },
}

local subMenu3 = {
    { text = "OPTION 1",         func = function() end,              currentStatus = "TEST 1", status = { "TEST 1", "TEST 2", "TEST 3", "TEST 4" } },
    { text = "OPTION 2",         func = function() end,              currentStatus = "TEST 1", status = { "TEST 1", "TEST 2" } },
    { text = "OPTION 3",         func = function() end,              currentStatus = "TEST 1", status = { "TEST 1", "TEST 2", "TEST 3", "TEST 4" } },
    { text = "OPTION 4",         func = function() end,              currentStatus = "TEST 1",  status = { "TEST 1", "TEST 2" } },
    { text = "OPTION 5",         func = function() end,              currentStatus = "TEST 1",  status = { "TEST 1", "TEST 2", "TEST 3", "TEST 4" } },
    { text = "BACK",             func = function() hideSubmenu() end },
}

local menuOptions = {
    { text = "Char", func = function(call) cycleChar(call) end, currentStatus = initCharCurValue, status = { "X", "Zero" , "Vile", "None" }},
    { text = "Armor", func = function(call) cycleArmor(call) end, currentStatus = initArmorCurValue, status = { "None", "First Armor", "Second Armor" }},
    { text = "Color", func = function(call) setColor(call) end, currentStatus = initColorCurValue, status = { "Palette", "Default" }},
    { text = "Sounds", func = function(call) setSounds(call) end, currentStatus = initSoundsCurValue, status = { "On", "Off" }},
    { text = "Menu", func = function(call) toggleMenu(call) end, currentStatus = initMenuCurValue, status = { "DPAD UP and CMD", "CMD only" }},
    --{ text = "Model", func = function(call) toggleModel(call) end, currentStatus = "On", status = { "On", "Off" }}
}
if _G.charSelectExists then
    menuOptions = {
        { text = "Color", func = function(call) setColor(call) end, currentStatus = initColorCurValue, status = { "Palette", "Default" }},
        { text = "Sounds", func = function(call) setSounds(call) end, currentStatus = initSoundsCurValue, status = { "On", "Off" }},
        { text = "Menu", func = function(call) toggleMenu(call) end, currentStatus = initMenuCurValue, status = { "DPAD UP and CMD", "CMD only" }},
        --{ text = "Model", func = function(call) toggleModel(call) end, currentStatus = "On", status = { "On", "Off" }}
    }
end

local function adapt_to_screen(position, resolution, isWidth)
    local screenWidth, screenHeight = djui_hud_get_screen_width(), djui_hud_get_screen_height()
    if resolution == RESOLUTION_N64 then
        if isWidth then
            return (position / 320) * screenWidth
        else
            return (position / 240) * screenHeight
        end
    else
        if isWidth then
            return (position / 1920) * screenWidth
        else
            return (position / 1080) * screenHeight
        end
    end
end

local function render_menu()
    -- Print menu options
    djui_hud_print_text("Mega Man X - Menu", adapt_to_screen(20, RESOLUTION_N64, true), adapt_to_screen(30, RESOLUTION_N64, false), 1)
    for i, option in ipairs(menuOptions) do
        local s = gPlayerSyncTable[0]
        local yOffset = 55 + (i - 1) * 15
        local color = (i == selectedOption) and { 255, 255, 255, 255 } or { 170, 170, 170, 255 }

        if (option.text ~= 'Armor' or s.character == 'x') then
            djui_hud_set_color(color[1], color[2], color[3], color[4])
            local statusText = option.currentStatus or ""
            djui_hud_print_text(option.text, adapt_to_screen(35, RESOLUTION_N64, true),
                adapt_to_screen(yOffset, RESOLUTION_N64, false), 1)
            djui_hud_print_text(statusText, adapt_to_screen(120, RESOLUTION_N64, true),
                adapt_to_screen(yOffset, RESOLUTION_N64, false), 1)
        end
    end

    if isSubmenuShown then
        local maxVisibleOptions = 10
        local startOption = math.max(1, selectedSubmenuOption - maxVisibleOptions + 1)
        local endOption = math.min(#currentSubmenu, startOption + maxVisibleOptions - 1)

        for i = startOption, endOption do
            local yOffset = 55 + (i - startOption) * 15
            local color = (i == selectedSubmenuOption) and { 255, 255, 255, 255 } or { 170, 170, 170, 255 }

            djui_hud_set_color(color[1], color[2], color[3], color[4])
            local statusText = currentSubmenu[i].currentStatus or ""
            djui_hud_print_text(currentSubmenu[i].text, adapt_to_screen(120, RESOLUTION_N64, true),
                adapt_to_screen(yOffset, RESOLUTION_N64, false), 1)
            djui_hud_print_text(statusText, adapt_to_screen(220, RESOLUTION_N64, true), yOffset, 1)
        end
    end
end

local function cycleStatus(option)
    if option.status then
        if not option.currentStatus then
            option.currentStatus = option.status[1]
        else
            local currentIndex
            for i, status in ipairs(option.status) do
                if status == option.currentStatus then
                    currentIndex = i
                    break
                end
            end

            currentIndex = currentIndex % #option.status + 1
            option.currentStatus = option.status[currentIndex]
        end
    end
end

local cooldown = 5
local cooldownCounter = 0

local savedStickY = 0
local savedPress = 0
local menuFrameUpdate = 0
local function menu_controls()
    local stickY = savedStickY
    local s = gPlayerSyncTable[0]

    if not isSubmenuShown then
        if selectedOption < 1 then
            selectedOption = #menuOptions
        elseif selectedOption > #menuOptions then
            selectedOption = 1
        end

        if cooldownCounter > 0 then
            cooldownCounter = cooldownCounter - 1
        else
            if stickY > 0.5 then
                if (selectedOption > 1 and s.character ~= 'x') then
                    local option = menuOptions[selectedOption - 1]
                    if (option.text == 'Armor') then
                        selectedOption = selectedOption - 2
                    else
                        selectedOption = selectedOption - 1
                    end
                else
                    selectedOption = selectedOption - 1
                end
                play_sound(SOUND_MENU_CHANGE_SELECT, gMarioStates[0].pos)
                cooldownCounter = cooldown
            elseif stickY < -0.5 then
                if (selectedOption + 1 <= #menuOptions and s.character ~= 'x') then
                    local option = menuOptions[selectedOption + 1]
                    if (option.text == 'Armor') then
                        selectedOption = selectedOption + 2
                    else
                        selectedOption = selectedOption + 1
                    end
                else
                    selectedOption = selectedOption + 1
                end
                play_sound(SOUND_MENU_CHANGE_SELECT, gMarioStates[0].pos)
                cooldownCounter = cooldown
            elseif savedPress & A_BUTTON ~= 0 then
                play_sound(SOUND_MENU_CLICK_FILE_SELECT, gMarioStates[0].pos)
                local option = menuOptions[selectedOption]
                option.func(option.currentStatus)

                cycleStatus(option)
            end
        end
    else
        if not currentSubmenu then
            currentSubmenu = {}
        end

        if selectedSubmenuOption < 1 then
            selectedSubmenuOption = #currentSubmenu
        elseif selectedSubmenuOption > #currentSubmenu then
            selectedSubmenuOption = 1
        end

        if cooldownCounter > 0 then
            cooldownCounter = cooldownCounter - 1
        else
            if stickY > 0.5 then
                selectedSubmenuOption = selectedSubmenuOption - 1
                play_sound(SOUND_MENU_CHANGE_SELECT, gMarioStates[0].pos)
                cooldownCounter = cooldown
            elseif stickY < -0.5 then
                selectedSubmenuOption = selectedSubmenuOption + 1
                play_sound(SOUND_MENU_CHANGE_SELECT, gMarioStates[0].pos)
                cooldownCounter = cooldown
            elseif savedPress & A_BUTTON ~= 0 then
                play_sound(SOUND_MENU_CLICK_FILE_SELECT, gMarioStates[0].pos)
                local option = currentSubmenu[selectedSubmenuOption]
                option.func(option.currentStatus)

                cycleStatus(option)
            end
        end
    end
    menuFrameUpdate = 1
end

local function on_hud_render()
    djui_hud_set_resolution(RESOLUTION_N64)
    djui_hud_set_font(FONT_HUD)
    if menu then
        djui_hud_set_color(0, 0, 0, 110)
        djui_hud_render_rect(0, 0, djui_hud_get_screen_width() + 10, djui_hud_get_screen_height())
        djui_hud_set_color(255, 255, 255, 255)
        render_menu()
        menu_controls()
    end
end

local function before_update(m)
    local s = gPlayerSyncTable[0]
    if (m.playerIndex == 0) then
        if m.controller.buttonPressed & U_JPAD ~= 0 and menuToggle == 'dpadup' then
            selectedOption = 1
            menu = not menu
            s.menu_open = menu
            m.controller.buttonPressed = m.controller.buttonPressed & ~U_JPAD
        end
        if menu then
            if m.controller.buttonPressed & START_BUTTON ~= 0 or m.controller.buttonPressed & B_BUTTON ~= 0 then
                selectedOption = 1
                menu = not menu
                s.menu_open = menu
                m.controller.buttonPressed = m.controller.buttonPressed & ~START_BUTTON & ~B_BUTTON
            end
            if (menuFrameUpdate == 1) then
                menuFrameUpdate = 0
                savedStickY = m.controller.stickY
                savedPress = m.controller.buttonPressed
            end
            m.controller.buttonPressed = 0
            m.controller.stickX = 0
            m.controller.stickY = 0
            m.controller.stickMag = 0
        end
    end
end

function open_menu_command()
    local s = gPlayerSyncTable[0]
    selectedOption = 1
    menu = not menu
    s.menu_open = menu
    return true
end

hook_event(HOOK_ON_HUD_RENDER, on_hud_render)
hook_event(HOOK_BEFORE_MARIO_UPDATE, before_update)

hook_chat_command('mmx', "Toggle the MMX menu\n", open_menu_command)
