-- MODELS
E_model_charge_pre = smlua_model_util_get_id("charge_pre_geo")
E_model_charge2 = smlua_model_util_get_id("charge2_geo")
E_model_charge2_front = smlua_model_util_get_id("charge2_front_geo")
E_model_charge2_back = smlua_model_util_get_id("charge2_back_geo")
E_model_charge3_front_lightarmor = smlua_model_util_get_id("charge3_front_lightarmor_geo")
E_model_charge3_back_lightarmor = smlua_model_util_get_id("charge3_back_lightarmor_geo")
E_model_energy_charge1 = smlua_model_util_get_id("energy_charge1_geo")
E_model_energy_charge2 = smlua_model_util_get_id("energy_charge2_geo")
E_model_energy_charge3_lightarmor = smlua_model_util_get_id("energy_charge3_lightarmor_geo")
E_model_shot1 = smlua_model_util_get_id("shot1_geo")
E_model_shot2 = smlua_model_util_get_id("shot2_geo")
E_model_shot3 = smlua_model_util_get_id("shot3_geo")
E_model_shot3_particle = smlua_model_util_get_id("shot3_particle_geo")
E_model_shot_max = smlua_model_util_get_id("shot_max_geo")
E_model_giga_pink_shot = smlua_model_util_get_id("giga_pink_shot_geo")
E_model_shot3_ring = smlua_model_util_get_id("shot3_ring_geo")
E_model_shot_max_bubble = smlua_model_util_get_id("shot_max_bubble_geo")
E_model_wallspark = smlua_model_util_get_id("wallspark_geo")
E_model_shot_dmg = smlua_model_util_get_id("shot_dmg_geo")
E_model_saber_dmg = smlua_model_util_get_id("saber_dmg_geo")
E_model_vulcan_shot = smlua_model_util_get_id("vulcan_shot_geo")
E_model_cannon_shot = smlua_model_util_get_id("cannon_shot_geo")
E_model_leg_napalm = smlua_model_util_get_id("leg_napalm_geo")

-- SOUNDS
SOUND_X_CHARGE = audio_sample_load("x_charge.mp3")
SOUND_X_LAND = audio_sample_load("x_land.mp3")
SOUND_X_DASH = audio_sample_load("x_dash.mp3")
SOUND_X_WALLHIT = audio_sample_load("x_wallhit.mp3")
SOUND_X_WALLKICK = audio_sample_load("x_wallkick.mp3")
SOUND_X_SHOT1 = audio_sample_load("x_shot1.mp3")
SOUND_X_SHOT2 = audio_sample_load("x_shot2.mp3")
SOUND_X_SHOT3 = audio_sample_load("x_shot3.mp3")
SOUND_X_SHOT_MAX = audio_sample_load("x_shot_max.mp3")
SOUND_X_CHARGE_BEGIN = audio_sample_load("x_charge_begin.mp3")
SOUND_X_CHARGE_LOOP = audio_sample_load("x_charge_loop.mp3")
SOUND_X_CHARGE_MAX_BEGIN = audio_sample_load("x_charge_max_begin.mp3")
SOUND_X_CHARGE_MAX_LOOP = audio_sample_load("x_charge_max_loop.mp3")
SOUND_X_GIGA_CHARGE_HOLD = audio_sample_load("x_giga_charge_hold.mp3")
SOUND_X_JUMP = audio_sample_load("x_sfx_jump.mp3")

SOUND_SHOT_HIT = audio_sample_load("shot_hit.mp3")
SOUND_CLANK_HIT = audio_sample_load("clank_hit.mp3")
SOUND_SHOT_DESTROY = audio_sample_load("shot_destroy.mp3")

SOUND_VILE_SHOT = audio_sample_load("vile_shot.mp3")
SOUND_VILE_CANNON = audio_sample_load("vile_cannon.mp3")
SOUND_VILE_STEP = audio_sample_load("vile_step.mp3")
SOUND_VILE_JUMP = audio_sample_load("vile_sfx_jump.mp3")
SOUND_VILE_NAPALM_SHOT = audio_sample_load("vile_napalm_shot.mp3")
SOUND_VILE_NAPALM_EXPLODE = audio_sample_load("vile_napalm_explode.mp3")
SOUND_VILE_DASH = audio_sample_load("vile_dash.mp3")

SOUND_ZERO_RAIKOUSEN = audio_sample_load("zero_raikousen.mp3")
SOUND_ZERO_SLASH1 = audio_sample_load("zero_slash1.mp3")
SOUND_ZERO_SLASH2 = audio_sample_load("zero_slash2.mp3")
SOUND_ZERO_SLASH3 = audio_sample_load("zero_slash3.mp3")
SOUND_ZERO_RYUENJIN = audio_sample_load("zero_ryuenjin.mp3")
SOUND_ZERO_DASH = audio_sample_load("zero_dash.mp3")
SOUND_ZERO_JUMP = audio_sample_load("zero_sfx_jump.mp3")
SOUND_ZERO_KICK_WALL = audio_sample_load("zero_kick_wall.mp3")
--SOUND_ZERO_HIT_WALL = audio_sample_load("zero_hit_wall.mp3")
SOUND_ZERO_SABER_HIT = audio_sample_load("zero_saber_hit.mp3")
SOUND_ZERO_SABER_DESTROY = audio_sample_load("saber_destroy.mp3")
SOUND_ZERO_HYOURETSUZAN_IMPACT = audio_sample_load("zero_hyouretsuzan_impact.mp3")
SOUND_ZERO_LAND = audio_sample_load("zero_land.mp3")
SOUND_ZERO_SENTSUIZAN_LAND = audio_sample_load("zero_sentsuizan_land.mp3")

-- CONSTANTS
MODEL_Y_OFFSET = 31
DEFAULTHANDS_TABLE = {
    [ACT_JUMBO_STAR_CUTSCENE] = true,
    [ACT_STAR_DANCE_EXIT] = true,
    [ACT_STAR_DANCE_NO_EXIT] = true,
    [ACT_STAR_DANCE_WATER] = true,
    [ACT_END_PEACH_CUTSCENE] = true,
    [ACT_END_WAVING_CUTSCENE] = true,
}

GROUND_ACTIONS_TABLE = {
    [ACT_IDLE] = true,
    [ACT_WALKING] = true,
    [ACT_DECELERATING] = true,
    [ACT_BRAKING] = true,
    [ACT_BRAKING_STOP] = true,
    [ACT_TURNING_AROUND] = true,
    [ACT_PANTING] = true,
    [ACT_STANDING_AGAINST_WALL] = true,
    [ACT_CROUCHING] = true,
    [ACT_CROUCH_SLIDE] = true,
    [ACT_START_CROUCHING] = true,
    [ACT_STOP_CROUCHING] = true,
    [ACT_FREEFALL_LAND_STOP] = true,
    [ACT_JUMP_LAND] = true,
    [ACT_FREEFALL_LAND] = true,
}

GROUND_HOLD_ACTIONS_TABLE = {
    [ACT_HOLD_IDLE] = true,
    [ACT_HOLD_WALKING] = true,
    [ACT_HOLD_DECELERATING] = true,
}

define_custom_obj_fields({
    oOwner = 'u32',
    oShotType = 'f32',
    oOwnerChar = 'u32',  -- 0 is X, 1 is Vile
    oShotOffset = 'u32',
    oShotDestroyNextFrame = 'u32',
    oChargeSize = 'f32',
    -- Also used for light armor shot initial phase
    oChargeRot = 'u32',
    oChargeMinSize = 'f32',
    oChargeScaleDownFactor = 'f32',
    oChargeIndex = 'u32',
    oFurthestHitbox = 'u32',
    oSaberIndex = 'u32',
    oIsMultiHit = 'u32',
    oMmxAtkDmg = 'f32',
    oMmxHealth = 'f32',
    oMmxInitialHealth = 'f32',
})