function bhv_custom_bowser_loop(obj)
    -- make goombas leap instead of just jump
    if obj.oAction == 4 and obj.oMmxHealth <= 0 then
        obj.oForwardVel = 0
    end
end

-- hook the behavior
id_bhvCustomBowser = hook_behavior(id_bhvBowser, OBJ_LIST_GENACTOR, false, nil, bhv_custom_bowser_loop)

healthtable = {
    -- BOB
    [id_bhvGoomba] = 1.5, 
    [id_bhvKoopa] = 1.5,
    [id_bhvBobomb] = 1.5,
    [id_bhvChainChomp] = 50,
    [id_bhvChainChompGate] = 50,
    [id_bhvWaterBomb] = 2,
    [id_bhvKingBobomb] = 40,
    [id_bhvBreakableBox] = 7,
    [id_bhvBreakableBoxSmall] = 3,
    [id_bhvExclamationBox] = 2,
    [id_bhvBowlingBall] = 8,
    [id_bhvPitBowlingBall] = 8,
    [id_bhvFreeBowlingBall] = 8,
    -- WF
    [id_bhvKickableBoard] = 10,
    [id_bhvWfBreakableWallLeft] = 25,
    [id_bhvWfBreakableWallRight] = 25,
    [id_bhvSmallWhomp] = 7,
    [id_bhvWhompKingBoss] = 40,
    [id_bhvPiranhaPlant] = 7,
    [id_bhvBulletBill] = 5,
    --[id_bhvThwomp] = 90,
    --[id_bhvThwomp2] = 90,
    -- CM
    [id_bhvSpindrift] = 4,
    [id_bhvMrBlizzard] = 20,
    -- BBH
    [id_bhvBoo] = 3,
    [id_bhvGhostHuntBoo] = 3,
    [id_bhvFlyingBookend] = 1,
    [id_bhvHauntedChair] = 1,
    [id_bhvBooInCastle] = 3,
    [id_bhvBooWithCage] = 3,
    [id_bhvMerryGoRoundBoo] = 3,
    [id_bhvBalconyBigBoo] = 10,
    [id_bhvGhostHuntBigBoo] = 10,
    [id_bhvMerryGoRoundBigBoo] = 10,
    [id_bhvMadPiano] = 40,
    -- LLL
    [id_bhvMrI] = 30,
    [id_bhvSmallBully] = 30,
    [id_bhvBigBully] = 100,
    [id_bhvBigBullyWithMinions] = 100,
    -- SSL
    [id_bhvPokey] = 2,
    [id_bhvPokeyBodyPart] = 2,
    [id_bhvKlepto] = 1,
    [id_bhvFlyGuy] = 1,
    [id_bhvEyerokHand] = 30,
    [id_bhvJumpingBox] = 3,
    -- HMC
    [id_bhvScuttlebug] = 4,
    [id_bhvSnufit] = 1,
    [id_bhvSwoop] = 1,
    [id_bhvBigBoulder] = 8,
    -- THI
    [id_bhvFirePiranhaPlant] = 1,
    [id_bhvChuckya] = 17,
    [id_bhvEnemyLakitu] = 1,
    [id_bhvSpiny] = 2,
    [id_bhvWigglerBody] = 0,
    [id_bhvWigglerHead] = 5,
    -- TTM
    [id_bhvMontyMole] = 1,
    -- WDW
    [id_bhvSkeeter] = 1,
    -- SL
    [id_bhvSmallChillBully] = 30,
    [id_bhvBigChillBully] = 100,
    [id_bhvMoneybag] = 4,
    -- BOWSER
    [id_bhvBowser] = 70,
    [id_bhvCustomBowser] = 70,
    [id_bhvBowserBomb] = 10
}

hook_event(HOOK_ON_OBJECT_LOAD, function(o)
    if healthtable[get_id_from_behavior(o.behavior)] then
        o.oMmxHealth = healthtable[get_id_from_behavior(o.behavior)]
        o.oMmxInitialHealth = healthtable[get_id_from_behavior(o.behavior)]
    end
end)