--From here on this is all SMS Alfredo's custom voice resource

--How many snores the sleep-talk has, or rather, how long the sleep-talk lasts
--If you omit the sleep-talk you can ignore this
local SLEEP_TALK_SNORES = 8

--Define what actions play what voice clips
--If an action has more than one voice clip, put those clips inside a table
--CHAR_SOUND_SNORING3 requires two or three voice clips to work properly...
--but you can omit it if your character does not sleep-talk
X_CUSTOM_VOICETABLE = {
    [CHAR_SOUND_ATTACKED] = {'x_hurt1.mp3', 'x_hurt2.mp3'},
    [CHAR_SOUND_DOH] = 'x_hurt7.mp3',
    [CHAR_SOUND_DYING] = {'x_dead.mp3'},
    [CHAR_SOUND_GAME_OVER] = {'silent.mp3'},
    [CHAR_SOUND_GROUND_POUND_WAH] = {'x_groundpound.mp3'},
    [CHAR_SOUND_HAHA] = 'x_longjump.mp3',
    [CHAR_SOUND_HAHA_2] = 'x_alright.mp3',
    [CHAR_SOUND_HERE_WE_GO] = {'x_missionaccomplished.mp3',},
    [CHAR_SOUND_HOOHOO] = 'x_doublejump.mp3',
    [CHAR_SOUND_HRMM] = 'x_ledge.mp3',
    [CHAR_SOUND_IMA_TIRED] = 'x_tired.mp3',
    [CHAR_SOUND_LETS_A_GO] = 'x_herewego.mp3',
    [CHAR_SOUND_MAMA_MIA] = 'x_notdoneyet.mp3',
    [CHAR_SOUND_ON_FIRE] = {'x_hurt5.mp3',},
    [CHAR_SOUND_OOOF] = 'x_hurt1.mp3',
    [CHAR_SOUND_OOOF2] = 'x_hurt6.mp3',
    [CHAR_SOUND_PUNCH_HOO] = {'x_attack3.mp3',},
    [CHAR_SOUND_PUNCH_WAH] = 'x_attack2.mp3',
    [CHAR_SOUND_PUNCH_YAH] = 'x_doublejump.mp3',
    [CHAR_SOUND_SO_LONGA_BOWSER] = {'x_timetogohome.mp3'},
    [CHAR_SOUND_TWIRL_BOUNCE] = {'x_triplejump.mp3'},
    [CHAR_SOUND_UH] = 'x_hurt3.mp3',
    [CHAR_SOUND_UH2] = {'x_jump1.mp3',},
    [CHAR_SOUND_UH2_2] = 'x_hurt7.mp3',
    [CHAR_SOUND_WAAAOOOW] = 'x_fall2.mp3',
    [CHAR_SOUND_WAH2] = 'x_jump1.mp3',
    [CHAR_SOUND_WHOA] = 'x_ledge.mp3',
    [CHAR_SOUND_YAHOO] = {'x_longjump.mp3',},
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'x_triplejump.mp3', 'x_longjump.mp3'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'x_jump1.mp3', 'x_jump2.mp3'},
}


ZERO_CUSTOM_VOICETABLE = {
    [CHAR_SOUND_ATTACKED] = {'zero_oof.mp3', 'zero_ouch.mp3'},
    [CHAR_SOUND_DOH] = 'zero_bonk.mp3', -- Bonk into walls
    [CHAR_SOUND_DYING] = {'zero_death.mp3'},
    [CHAR_SOUND_GROUND_POUND_WAH] = {'zero_ha.mp3'},
    [CHAR_SOUND_HAHA] = 'zero_ha.mp3', -- Landing after backflip
    [CHAR_SOUND_HAHA_2] = 'zero_hya.mp3', -- Landing on Water after a fall
    [CHAR_SOUND_HERE_WE_GO] = {'zero_pieceofcake.mp3',}, -- Star Get + Obtaining Power-up
    [CHAR_SOUND_HOOHOO] = 'zero_mhx_hya.mp3', -- 2nd Jump + Dive Attack
    [CHAR_SOUND_HRMM] = 'zero_mhx_ha.mp3', -- Object Pick-up
    [CHAR_SOUND_LETS_A_GO] = 'zero_mhx_hereigo.mp3', -- Level Select
    [CHAR_SOUND_MAMA_MIA] = 'zero_mhx_gah.mp3', -- Getting up after thrown out of level
    [CHAR_SOUND_ON_FIRE] = {'zero_burned.mp3',}, -- Touch Fire
    [CHAR_SOUND_OOOF] = 'zero_oof.mp3',
    [CHAR_SOUND_OOOF2] = 'zero_oof.mp3', -- Landing After a Bonk + Thrown out of level
    [CHAR_SOUND_PUNCH_HOO] = {'zero_yaa.mp3',}, -- Kick
    [CHAR_SOUND_PUNCH_WAH] = 'zero_ha.mp3', --2nd Punch
    [CHAR_SOUND_PUNCH_YAH] = 'zero_ya.mp3', -- 1st Punch
    [CHAR_SOUND_SNORING1] = 'zero_hya.mp3',
    [CHAR_SOUND_SNORING2] = 'zero_hiya.mp3',
    [CHAR_SOUND_SNORING3] = {'zero_mhx_hya.mp3'},
    [CHAR_SOUND_SO_LONGA_BOWSER] = {'zero_mhx_takethis.mp3'}, --Bowser Throw
    [CHAR_SOUND_TWIRL_BOUNCE] = {'zero_hya.mp3'}, -- Boing
    [CHAR_SOUND_UH] = 'zero_oof.mp3', --Drop off of ledge
    [CHAR_SOUND_UH2] = {'zero_mhx_ha.mp3',}, -- Throw Object (?) + Quick get up ledge
    [CHAR_SOUND_UH2_2] = 'zero_phew.mp3', -- Landing after Long Jump
    [CHAR_SOUND_WAAAOOOW] = 'zero_mhx_death.mp3', -- Falling
    [CHAR_SOUND_WAH2] = 'zero_ya.mp3',
    [CHAR_SOUND_WHOA] = 'zero_phew.mp3', -- Ledge Grab
    [CHAR_SOUND_YAHOO] = {'zero_mhx_hya.mp3'}, -- Long Jump
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'zero_hiya2.mp3', 'zero_hya2.mp3'}, -- 3rd Jump(s)
    [CHAR_SOUND_YAH_WAH_HOO] = {'zero_mhx_ha.mp3', 'zero_ha.mp3'}, -- 1st Jump(s)
}



VILE_CUSTOM_VOICETABLE = {
    [CHAR_SOUND_ATTACKED] = {'vile_mhx_dmg.mp3', 'vile_mhx_dmg2.mp3'},
    [CHAR_SOUND_DOH] = 'vile_oof.mp3', -- Bonk into walls
    [CHAR_SOUND_DYING] = {'vile_choke.mp3'},
    [CHAR_SOUND_EEUH] = {'vile_mhx_uh.mp3',}, -- Slow Get up from ledge
    [CHAR_SOUND_GROUND_POUND_WAH] = {'vile_ha.mp3'},
    [CHAR_SOUND_HAHA] = 'vile_haha.mp3', -- Landing after backflip
    [CHAR_SOUND_HAHA_2] = 'vile_hahahaa.mp3', -- Landing on Water after a fall
    [CHAR_SOUND_HERE_WE_GO] = {'vile_ahahaha.mp3',}, -- Star Get + Obtaining Power-up
    [CHAR_SOUND_HOOHOO] = 'vile_hiya.mp3', -- 2nd Jump + Dive Attack
    [CHAR_SOUND_HRMM] = 'vile_mhx_grunt2.mp3', -- Object Pick-up
    [CHAR_SOUND_LETS_A_GO] = 'vile_letshavesomefun.mp3', -- Level Select
    [CHAR_SOUND_MAMA_MIA] = 'vile_mhx_dmg.mp3', -- Getting up after thrown out of level
    [CHAR_SOUND_ON_FIRE] = {'vile_ugh.mp3',}, -- Touch Fire
    [CHAR_SOUND_OOOF] = 'vile_mhx_dmg.mp3',
    [CHAR_SOUND_OOOF2] = 'vile_mhx_dmg2.mp3', -- Landing After a Bonk + Thrown out of level
    [CHAR_SOUND_PUNCH_HOO] = {'vile_mhx_eatthis.mp3',}, -- Kick
    [CHAR_SOUND_PUNCH_WAH] = 'vile_mhx_takethis.mp3', --2nd Punch
    [CHAR_SOUND_PUNCH_YAH] = 'vile_mhx_grunt1.mp3', -- 1st Punch
    [CHAR_SOUND_SNORING1] = 'vile_mhx_here.mp3',
    [CHAR_SOUND_SNORING2] = 'vile_mhx_haa.mp3',
    [CHAR_SOUND_SO_LONGA_BOWSER] = {'vile_mhx_maniaclaugh.mp3'}, --Bowser Throw
    [CHAR_SOUND_TWIRL_BOUNCE] = {'vile_hahahaa.mp3'}, -- Boing
    [CHAR_SOUND_UH] = 'vile_oof.mp3', --Drop off of ledge
    [CHAR_SOUND_UH2] = {'vile_mhx_grunt1.mp3',}, -- Throw Object (?) + Quick get up ledge
    [CHAR_SOUND_UH2_2] = 'vile_mhx_uh.mp3', -- Landing after Long Jump
    [CHAR_SOUND_WAAAOOOW] = 'vile_fall.mp3', -- Falling
    [CHAR_SOUND_WAH2] = 'vile_mhx_grunt1.mp3',
    [CHAR_SOUND_WHOA] = 'vile_mhx_uh.mp3', -- Ledge Grab
    [CHAR_SOUND_YAHOO] = {'vile_hiya.mp3',}, -- Long Jump
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'vile_yeah.mp3', 'vile_hahahaa.mp3'}, -- 3rd Jump(s)
    [CHAR_SOUND_YAH_WAH_HOO] = {'vile_mhx_grunt1.mp3', 'vile_mhx_grunt2.mp3', 'vile_mhx_atk1.mp3'}, -- 1st Jump(s)
}

-- Rest of code not executed of CS is loaded
if _G.charSelectExists then return 0 end


--Define the table of samples that will be used for each player
--Global so if multiple mods use this they won't create unneeded samples
--DON'T MODIFY THIS SINCE IT'S GLOBAL FOR USE BY OTHER MODS!
gCustomVoiceSamples = {}
gCustomVoiceStream = nil

--Get the player's sample, stop whatever sound
--it's playing if it doesn't match the provided sound
--DON'T MODIFY THIS SINCE IT'S GLOBAL FOR USE BY OTHER MODS!
--- @param m MarioState
function stop_custom_character_sound(m, sound)
    local voice_sample = gCustomVoiceSamples[m.playerIndex]
    if voice_sample == nil or not voice_sample.loaded then
        return
    end

    audio_sample_stop(voice_sample)
    if voice_sample.file.relativePath:match('^.+/(.+)$') == sound then
        return voice_sample
    end
    --audio_sample_destroy(voice_sample)
end

--Play a custom character's sound
--DON'T MODIFY THIS SINCE IT'S GLOBAL FOR USE BY OTHER MODS!
--- @param m MarioState
function play_custom_character_sound(m, voice, characterSound)
    --Get sound, if it's a table, get a random entry from it
    local sound
    if type(voice) == "table" then
        sound = voice[math.random(#voice)]
    else
        sound = voice
    end
    if sound == nil then return 0 end

    --Get current sample and stop it
    local voice_sample = stop_custom_character_sound(m, sound)

    --If the new sound isn't a string, let's assume it's
    --a number to return to the character sound hook
    if type(sound) ~= "string" then
        return sound
    end

    --Load a new sample and play it! Don't make a new one if we don't need to
    if (m.area == nil or m.area.camera == nil) and m.playerIndex == 0 then
        if gCustomVoiceStream ~= nil then
            audio_stream_stop(gCustomVoiceStream)
            --audio_stream_destroy(gCustomVoiceStream)
        end
        gCustomVoiceStream = audio_stream_load(sound)
        audio_stream_play(gCustomVoiceStream, true, 1)
    else
        if voice_sample == nil then
            voice_sample = audio_sample_load(sound)
        end
        if characterSound == CHAR_SOUND_SNORING1 or characterSound == CHAR_SOUND_SNORING2 or characterSound == CHAR_SOUND_SNORING3 then
            mmx_play_sound(voice_sample, m.pos, 0.5)
        else
            mmx_play_sound(voice_sample, m.pos, 1)
        end

        gCustomVoiceSamples[m.playerIndex] = voice_sample
    end
    return 0
end

--Main character sound hook
--This hook is freely modifiable in case you want to make any specific exceptions
--- @param m MarioState
local function custom_character_sound(m, characterSound)
    local s = gPlayerSyncTable[m.playerIndex]
    if (s.character == 'none' or s.enable_model == false or not enable_sounds) then return end
    if characterSound == CHAR_SOUND_HAHA and m.hurtCounter > 0 then return 0 end

    local voice_sample = gCustomVoiceSamples[m.playerIndex]
    if not (voice_sample == nil or not voice_sample.loaded) then
        audio_sample_stop(voice_sample)
        --audio_sample_destroy(voice_sample)
    end

    if s.character == 'x' then
        local voice = X_CUSTOM_VOICETABLE[characterSound]
        if voice ~= nil then
            return play_custom_character_sound(m, voice, characterSound)
        end
    elseif s.character == 'zero' then
        local voice = ZERO_CUSTOM_VOICETABLE[characterSound]
        if voice ~= nil then
            return play_custom_character_sound(m, voice, characterSound)
        end
    elseif s.character == 'vile' then
        local voice = VILE_CUSTOM_VOICETABLE[characterSound]
        if voice ~= nil then
            return play_custom_character_sound(m, voice, characterSound)
        end
    end
    
    return 0
end
hook_event(HOOK_CHARACTER_SOUND, custom_character_sound)