-----------------------------------------------------------------
----- LOCALIZED FUNCTIONS ---------------------------------------
-----------------------------------------------------------------
local sins, coss, cur_obj_resolve_wall_collisions, obj_mark_for_deletion, network_player_from_global_index,
 obj_scale, calculate_pitch, obj_move_xyz, spawn_non_sync_object, atan2s, obj_scale_xyz, obj_build_transform_relative_to_parent,
 obj_set_throw_matrix_from_transform = 
sins, coss, cur_obj_resolve_wall_collisions, obj_mark_for_deletion, network_player_from_global_index,
 obj_scale, calculate_pitch, obj_move_xyz, spawn_non_sync_object, atan2s, obj_scale_xyz, obj_build_transform_relative_to_parent,
 obj_set_throw_matrix_from_transform

-----------------------------------------------------------
--- MODELS ------------------------------------------------
-----------------------------------------------------------
E_model_zsaber_base = smlua_model_util_get_id("zero_zsaber_base_geo")

E_model_raikousen = smlua_model_util_get_id("zero_raikousen1_geo")
E_model_raikousen2 = smlua_model_util_get_id("zero_raikousen2_geo")
E_model_raikousen_blade = smlua_model_util_get_id("zero_raikousen_blade_geo")
E_model_lslash1 = smlua_model_util_get_id("zero_lslash1_geo")
E_model_lslash2 = smlua_model_util_get_id("zero_lslash2_geo")
E_model_lslash3 = smlua_model_util_get_id("zero_lslash3_geo")
E_model_lslash4 = smlua_model_util_get_id("zero_lslash4_geo")
E_model_lslash5 = smlua_model_util_get_id("zero_lslash5_geo")
E_model_lslash6 = smlua_model_util_get_id("zero_lslash6_geo")
E_model_lslash7 = smlua_model_util_get_id("zero_lslash7_geo")
E_model_mslash2 = smlua_model_util_get_id("zero_mslash2_geo")
E_model_mslash3 = smlua_model_util_get_id("zero_mslash3_geo")

E_model_hslash1 = smlua_model_util_get_id("zero_hslash1_geo")
E_model_hslash2 = smlua_model_util_get_id("zero_hslash2_geo")
E_model_hslash3 = smlua_model_util_get_id("zero_hslash3_geo")
E_model_hslash4 = smlua_model_util_get_id("zero_hslash4_geo")

E_model_kuenzan = smlua_model_util_get_id("zero_kuenzan_geo")
E_model_kuenzan2 = smlua_model_util_get_id("zero_kuenzan2_geo")

E_model_shippuga = smlua_model_util_get_id("zero_shippuga_geo")

E_model_sentsuizan = smlua_model_util_get_id("zero_sentsuizan_geo")

E_model_hyouretsuzan = smlua_model_util_get_id("zero_hyouretsuzan_geo")
E_model_hyouretsuzan_shard = smlua_model_util_get_id("zero_hyouretsuzan_shard_geo")

E_model_ryuenjin1 = smlua_model_util_get_id("zero_ryuenjin1new_geo")
E_model_ryuenjin2 = smlua_model_util_get_id("zero_ryuenjin2new_geo")

-----------------------------------------------------------
--- HELD SABERS -------------------------------------------
-----------------------------------------------------------

local hitboxDivider = 2

CONST_LIGHT_SLASH = 1
CONST_MEDIUM_SLASH = 2
CONST_HEAVY_SLASH = 3
CONST_AIR_SLASH = 4
CONST_KUENZAN = 5
CONST_SHIPPUGA = 6
CONST_RAIKOUSEN = 7
CONST_WALL_SLIDE_SLASH = 8
CONST_HYOURETSUZAN = 9
CONST_RYUENJIN = 10
CONST_SENTSUIZAN = 11
CONST_RAIKOUSEN_LIGHTNING = 12


local hitboxSpawnData = {
    [CONST_LIGHT_SLASH] = function(o)
        o.hitboxRadius            = 60 / hitboxDivider
        o.hitboxHeight            = 120 / hitboxDivider
        o.hitboxDownOffset        = 60 / hitboxDivider
        o.oIsMultiHit = 0
        o.oMmxAtkDmg = 2
    end,
    [CONST_MEDIUM_SLASH] = function(o)
        o.hitboxRadius            = 75 / hitboxDivider
        o.hitboxHeight            = 100 / hitboxDivider
        o.hitboxDownOffset        = 50 / hitboxDivider
        o.oIsMultiHit = 0
        o.oMmxAtkDmg = 2.5
    end,
    [CONST_HEAVY_SLASH] = function(o)
        o.hitboxRadius            = 80 / hitboxDivider
        o.hitboxHeight            = 140 / hitboxDivider
        o.hitboxDownOffset        = 70 / hitboxDivider
        o.oIsMultiHit = 1
        o.oMmxAtkDmg = 2.15
    end,
    [CONST_AIR_SLASH] = function(o)
        o.hitboxRadius            = 80 / hitboxDivider
        o.hitboxHeight            = 110 / hitboxDivider
        o.hitboxDownOffset        = 70 / hitboxDivider
        o.oIsMultiHit = 0
        o.oMmxAtkDmg = 2.5
    end,
    [CONST_KUENZAN] = function(o)
        o.hitboxRadius            = 70 / hitboxDivider
        o.hitboxHeight            = 130 / hitboxDivider
        o.hitboxDownOffset        = 65 / hitboxDivider
        o.oIsMultiHit = 1
        o.oMmxAtkDmg = 1
    end,
    [CONST_SHIPPUGA] = function(o)
        o.hitboxRadius            = 80 / hitboxDivider
        o.hitboxHeight            = 150 / hitboxDivider
        o.hitboxDownOffset        = 80 / hitboxDivider
        o.oIsMultiHit = 1
        o.oMmxAtkDmg = 2
    end,
    [CONST_RAIKOUSEN] = function(o)
        o.hitboxRadius            = 50 / hitboxDivider
        o.hitboxHeight            = 100 / hitboxDivider
        o.hitboxDownOffset        = 50 / hitboxDivider
        o.oIsMultiHit = 0
        o.oMmxAtkDmg = 5.5
    end,
    [CONST_WALL_SLIDE_SLASH] = function(o)
        o.hitboxRadius            = 60 / hitboxDivider
        o.hitboxHeight            = 120 / hitboxDivider
        o.hitboxDownOffset        = 60 / hitboxDivider
        o.oIsMultiHit = 0
        o.oMmxAtkDmg = 2.5
    end,
    [CONST_HYOURETSUZAN] = function(o)
        o.hitboxRadius            = 70 / hitboxDivider
        o.hitboxHeight            = 140 / hitboxDivider
        o.hitboxDownOffset        = 70 / hitboxDivider
        o.oIsMultiHit = 1
        o.oMmxAtkDmg = 1.4
    end,
    [CONST_RYUENJIN] = function(o)
        o.hitboxRadius            = 80 / hitboxDivider
        o.hitboxHeight            = 240 / hitboxDivider
        o.hitboxDownOffset        = 230 / hitboxDivider
        o.oIsMultiHit = 1
        o.oMmxAtkDmg = 2.2
    end,
    [CONST_SENTSUIZAN] = function(o)
        o.hitboxRadius            = 80 / hitboxDivider
        o.hitboxHeight            = 150 / hitboxDivider
        o.hitboxDownOffset        = 80 / hitboxDivider
        o.oIsMultiHit = 0
        o.oMmxAtkDmg = 7
    end,
}

local numberOfHitboxes = {
    [CONST_LIGHT_SLASH] = 2,
    [CONST_MEDIUM_SLASH] = 2,
    [CONST_HEAVY_SLASH] = 3,
    [CONST_AIR_SLASH] = 2,
    [CONST_KUENZAN] = 3,
    [CONST_SHIPPUGA] = 1,
    [CONST_RAIKOUSEN] = 3,
    [CONST_WALL_SLIDE_SLASH] = 2,
    [CONST_HYOURETSUZAN] = 2,
    [CONST_RYUENJIN] = 3,
    [CONST_SENTSUIZAN] = 1
}

local saber_init = function(o)
    network_init_object(o, true, { 'oTimer' })
    obj_set_model_extended(o, E_model_lslash1)
    --o.oMoveAnglePitch = o.oMoveAnglePitch - 38000
    --o.oMoveAngleYaw = o.oMoveAngleYaw + 1500

    spawn_non_sync_object(id_bhvZsaberBase, E_MODEL_NONE, o.oPosX, o.oPosY, o.oPosZ, function(obj)
        obj.parentObj = o
        obj.oBehParams = o.oSaberIndex
        obj.oOwner = o.oOwner
    end)

    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]

    if m.playerIndex == 0 then
        if o.oSaberIndex ~= CONST_RAIKOUSEN then
            for i = 1, numberOfHitboxes[o.oSaberIndex] do
                spawn_sync_object(id_bhvZsaberHitBox, E_MODEL_NONE, o.oPosX, o.oPosY, o.oPosZ, function(obj)
                    obj.parentObj = o
                    obj.oBehParams = o.oSaberIndex
                    obj.oOwner = o.oOwner
                    hitboxSpawnData[o.oSaberIndex](obj)
                    obj.oSaberIndex = i
                    obj.oFurthestHitbox = numberOfHitboxes[o.oSaberIndex]
                end)
            end
        end
    end
    
    
    cur_obj_hide()
    o.oFlags = (OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE | OBJ_FLAG_SET_FACE_ANGLE_TO_MOVE_ANGLE | OBJ_FLAG_SET_FACE_YAW_TO_MOVE_YAW)
    o.parentObj = m.marioObj
    o.oMoveAngleYaw = m.faceAngle.y
    if o.oSaberIndex == CONST_HEAVY_SLASH then
        o.oMoveAngleRoll = o.oMoveAngleRoll - 3000
    elseif o.oSaberIndex == CONST_AIR_SLASH or o.oSaberIndex == CONST_MEDIUM_SLASH then
        if o.oSaberIndex == CONST_AIR_SLASH then
            o.oMoveAnglePitch = o.oMoveAnglePitch + 3000
        end
        o.oMoveAngleYaw = o.oMoveAngleYaw + 15000
    elseif o.oSaberIndex == CONST_LIGHT_SLASH then
        o.oMoveAngleRoll = o.oMoveAngleRoll + 3000
    elseif o.oSaberIndex == CONST_KUENZAN then
        o.oMoveAnglePitch = o.oMoveAnglePitch - 5000
    end
    --network_init_object(o, false, nil)
end

local saber_loop = function(o)
    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]
    local mmx = gMmxStates[m.playerIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    o.hookRender = true
    if s.zero_hit_stop > 0 then
        o.oTimer = o.oTimer - 1
        return
    end

    --[[

        if (o.oTimer < 5) then
            o.oMoveAnglePitch = o.oMoveAnglePitch + 6500
            obj_scale(o, o.oTimer * o.oTimer * 0.03)
        elseif (o.oTimer >= 5 and o.oTimer < 9) then
            o.oMoveAnglePitch = o.oMoveAnglePitch + 2500
            obj_scale(o, o.oTimer * 0.17)
        elseif (o.oTimer >= 9 and o.oTimer < 11) then
            o.oMoveAnglePitch = o.oMoveAnglePitch + 1000
            obj_scale(o, 9.5 * 0.15 * (7 / o.oTimer))
        else
            obj_scale(o, 9.5 * 0.15 * (2 / o.oTimer))
        end
    ]]

    local up = 0
    local front = 0
    local side = 0

    local limb = 0
    
    -- you won't be ready for the code that follows

    if (o.oSaberIndex == CONST_LIGHT_SLASH) then
        front = 13
        side = -10
        up = -15
        if (o.oTimer == 2) then
            o.oMoveAngleYaw = o.oMoveAngleYaw + 1500
            obj_set_model_extended(o, E_model_lslash1)
            o.oMoveAnglePitch = -20000
            o.oMoveAngleYaw = o.oMoveAngleYaw - 3000
            o.oMoveAngleRoll = o.oMoveAngleRoll - 3000
            obj_scale_xyz(o, 0.6, 1.1, 0.96)
            cur_obj_unhide()
        elseif (o.oTimer == 3) then
            obj_set_model_extended(o, E_model_lslash2)
            obj_scale_xyz(o, 1.15, 1.63, 0.95)
            o.oMoveAnglePitch = -7500
        elseif (o.oTimer == 4) then
            obj_set_model_extended(o, E_model_lslash6)
            o.oMoveAngleYaw = o.oMoveAngleYaw + 3000
            o.oMoveAngleRoll = o.oMoveAngleRoll + 3000
            obj_scale_xyz(o, 1, 1.33, 1)
            o.oMoveAnglePitch = -1000
        elseif (o.oTimer == 5) then
            local scaleRate = 1 - ((o.oTimer / 4) * 0.05)
            obj_scale_xyz(o, scaleRate, scaleRate * 0.6, scaleRate * 0.975)
            o.oMoveAnglePitch = 250
        elseif (o.oTimer > 5 and o.oTimer <= 7) then
            local scaleRate = 0.9 - ((o.oTimer / 5) * 0.1)
            obj_scale_xyz(o, scaleRate, scaleRate, scaleRate * 0.85)
            o.oMoveAnglePitch = 1200
            obj_set_model_extended(o, E_model_lslash3)
        elseif (o.oTimer > 7) then
            local scaleRate = 0.8 - ((o.oTimer / 4) * 0.1)
            obj_scale_xyz(o, scaleRate, scaleRate, scaleRate * 0.9)
            o.oMoveAnglePitch = 1600
            obj_set_model_extended(o, E_model_lslash4)
        end
        if (m.action ~= ACT_LIGHT_ZSABER or o.oTimer == 12) then
            obj_mark_for_deletion(o)
        end
    elseif (o.oSaberIndex == CONST_MEDIUM_SLASH) then
            front = 0
            side = 20
            up = -5
        if (o.oTimer == 2) then
            o.oMoveAngleYaw = o.oMoveAngleYaw + 1500
            obj_set_model_extended(o, E_model_hslash1)
            obj_scale_xyz(o, 1.48, 0.6, 1.18)
            cur_obj_unhide()
            o.oMoveAngleYaw = o.oMoveAngleYaw - 7000
        elseif (o.oTimer == 3) then
            obj_scale_xyz(o, 1.6, 0.7, 1.35)
            o.oMoveAngleYaw = o.oMoveAngleYaw - 7000
        elseif (o.oTimer == 4) then
            obj_set_model_extended(o, E_model_hslash2)
            obj_scale_xyz(o, 1.2, 0.75, 1.5)
            o.oMoveAngleYaw = o.oMoveAngleYaw - 10500
        elseif (o.oTimer == 5) then
            local scaleRate = 1 - ((o.oTimer / 4) * 0.05)
            obj_scale_xyz(o, scaleRate * 0.6, scaleRate * 0.75, scaleRate * 0.975)
            o.oMoveAngleYaw = o.oMoveAngleYaw - 500
        elseif (o.oTimer > 5 and o.oTimer <= 7) then
            local scaleRate = 0.9 - ((o.oTimer / 5) * 0.1)
            obj_scale_xyz(o, scaleRate , scaleRate, scaleRate * 0.95)
            obj_set_model_extended(o, E_model_hslash3)
        elseif (o.oTimer > 7) then
            local scaleRate = 0.8 - ((o.oTimer / 4) * 0.1)
            obj_scale_xyz(o, scaleRate , scaleRate, scaleRate * 0.9)
            obj_set_model_extended(o, E_model_hslash4)
        end
        if (m.action ~= ACT_MEDIUM_ZSABER or o.oTimer == 11) then
            obj_mark_for_deletion(o)
        end
    elseif (o.oSaberIndex == CONST_HEAVY_SLASH) then
        front = 13
        side = 10
        up = -10
        if (o.oTimer == 2) then
            o.oMoveAngleYaw = o.oMoveAngleYaw + 1500
            front = 14
            o.oMoveAngleRoll = o.oMoveAngleRoll + 8000
            o.oMoveAngleYaw = o.oMoveAngleYaw - 5000
            obj_set_model_extended(o, E_model_lslash5)
            obj_scale_xyz(o, 1.2, 1.3, 1.1)
            o.oMoveAnglePitch = -19000
            cur_obj_unhide()
        elseif (o.oTimer == 3) then
            o.oMoveAngleRoll = o.oMoveAngleRoll - 8000
            o.oMoveAngleYaw = o.oMoveAngleYaw + 5000
            obj_set_model_extended(o, E_model_lslash5)
            obj_scale_xyz(o, 1.2, 1.68, 1.65)
            o.oMoveAnglePitch = -10000
        elseif (o.oTimer == 4) then
            obj_set_model_extended(o, E_model_lslash7)
            obj_scale_xyz(o, 1, 1.54, 1.48)
            o.oMoveAnglePitch = -3000
        elseif (o.oTimer == 5) then
            local scaleRate = 1.1 - ((o.oTimer / 4) * 0.05)
            obj_scale_xyz(o, scaleRate, 0.93, 1.2)
            o.oMoveAnglePitch = 0
            obj_set_model_extended(o, E_model_lslash6)
        elseif (o.oTimer > 5 and o.oTimer <= 7) then
            local scaleRate = 0.9 - ((o.oTimer / 5) * 0.1)
            obj_scale_xyz(o, scaleRate, scaleRate, scaleRate * 0.95)
            obj_set_model_extended(o, E_model_lslash3)
        elseif (o.oTimer > 7) then
            local scaleRate = 0.8 - ((o.oTimer / 4) * 0.1)
            obj_scale_xyz(o, scaleRate, scaleRate, scaleRate * 0.9)
            o.oMoveAnglePitch = 1000
            obj_set_model_extended(o, E_model_lslash4)
        end
        if (m.action ~= ACT_HEAVY_ZSABER or o.oTimer == 12) then
            obj_mark_for_deletion(o)
        end
    elseif (o.oSaberIndex == CONST_AIR_SLASH) then
        front = 0
        side = 20
        up = 0
        if (o.oTimer == 2) then
            o.oMoveAngleYaw = o.oMoveAngleYaw + 1500
            obj_set_model_extended(o, E_model_hslash1)
            obj_scale_xyz(o, 1.3, 0.6, 1.3)
            cur_obj_unhide()
            o.oMoveAngleYaw = o.oMoveAngleYaw - 7000
        elseif (o.oTimer == 3) then
            obj_scale_xyz(o, 1.5, 0.7, 1.3)
            o.oMoveAngleYaw = o.oMoveAngleYaw - 5500
        elseif (o.oTimer == 4) then
            obj_set_model_extended(o, E_model_hslash2)
            obj_scale_xyz(o, 1.15, 0.7, 1.15)
            o.oMoveAngleYaw = o.oMoveAngleYaw - 8000
        elseif (o.oTimer == 5) then
            local scaleRate = 1 - ((o.oTimer / 4) * 0.05)
            obj_scale_xyz(o, scaleRate * 0.6, scaleRate * 0.7, scaleRate * 0.975)
            o.oMoveAngleYaw = o.oMoveAngleYaw - 1000
        elseif (o.oTimer > 5 and o.oTimer <= 7) then
            local scaleRate = 0.9 - ((o.oTimer / 5) * 0.1)
            obj_scale_xyz(o, scaleRate , scaleRate * 0.9, scaleRate * 0.95)
            obj_set_model_extended(o, E_model_hslash3)
            o.oMoveAngleYaw = o.oMoveAngleYaw - 500
        elseif (o.oTimer > 7) then
            local scaleRate = 0.8 - ((o.oTimer / 4) * 0.1)
            obj_scale_xyz(o, scaleRate , scaleRate * 0.9, scaleRate * 0.9)
            obj_set_model_extended(o, E_model_hslash4)
        end
        local mmx = gMmxStates[m.playerIndex]
        if ((mmx.zero_cancel_slash == 1 and o.oTimer > 1) or (m.action ~= ACT_AIR_SLASH and m.action ~= ACT_AIR_SLASH_LAND))
        or o.oTimer == 12 then
            obj_mark_for_deletion(o)
        end
    elseif (o.oSaberIndex == CONST_KUENZAN) then
        front = 0
        side = -10
        up = 0
        if (o.oTimer == 1) then
            cur_obj_unhide()
            obj_set_model_extended(o, E_model_kuenzan2)
            obj_scale_xyz(o, 1.73, 0.99, 1.5)
        elseif (o.oTimer == 2) then
            obj_set_model_extended(o, E_model_kuenzan)
        elseif (o.oTimer == 3) then
            obj_scale_xyz(o, 1.73, 1.52, 1.52)
        elseif (o.oTimer == 6) then
            obj_scale_xyz(o, 1.73, 1.49, 1.49)
        elseif (o.oTimer == 8) then
            obj_set_model_extended(o, E_model_kuenzan2)
            obj_scale_xyz(o, 1.73, 1.12, 1.17)
        end

        o.oMoveAnglePitch = o.oMoveAnglePitch + 10000 - (o.oTimer * 300)
        if (m.action ~= ACT_KUENZAN or o.oTimer == 10) then
            obj_mark_for_deletion(o)
        end
    elseif (o.oSaberIndex == CONST_SHIPPUGA) then
        limb = 1
        if (o.oTimer == 1) then
            o.oMoveAngleYaw = o.oMoveAngleYaw + 1500
            obj_set_model_extended(o, E_model_shippuga)
            obj_scale_xyz(o, 0.7, 0.7, 1.1)
            cur_obj_unhide()
            obj_build_transform_relative_to_parent(o)
            obj_set_throw_matrix_from_transform(o)
            o.oMoveAnglePitch = 4000
            o.oMoveAngleRoll = 5000
            o.oMoveAngleYaw = o.oMoveAngleYaw - 5000
        elseif (o.oTimer > 2 and o.oTimer < 7) then
            local scaleRate = (o.oTimer % 2) * 0.1
            obj_scale_xyz(o, 0.6 + scaleRate, 1 + scaleRate, 0.7 + scaleRate)
            --o.oMoveAnglePitch = o.oMoveAnglePitch + 600
            
        else
            obj_scale_xyz(o, 0.35, 0.6, 0.6)
        end
        if (m.action ~= ACT_SHIPPUGA or o.oTimer == 8) then
            obj_mark_for_deletion(o)
        end
    elseif (o.oSaberIndex == CONST_RAIKOUSEN) then
        if (o.oTimer == 1) then
            o.oMoveAngleYaw = o.oMoveAngleYaw + 3000
            up = -21
            front = 20
            side = -2
            obj_scale(o, 1 - 13 * 0.05)
            obj_set_model_extended(o, E_model_raikousen_blade)
            cur_obj_unhide()
            o.oMoveAnglePitch = 3500
            o.oMoveAngleRoll = 5000
            o.oMoveAngleYaw = o.oMoveAngleYaw - 5000
        elseif o.oTimer < 13 then
            up = -21
            front = 20
            side = -2
            obj_scale(o, 1 - (14 - o.oTimer) * 0.05)
        elseif (o.oTimer == 13) then
            if (m.playerIndex == 0) then
                for i = 1, numberOfHitboxes[o.oSaberIndex] do
                    spawn_sync_object(id_bhvZsaberHitBox, E_MODEL_NONE, o.oPosX, o.oPosY, o.oPosZ, function(obj)
                        obj.parentObj = o
                        obj.oBehParams = o.oSaberIndex
                        obj.oOwner = o.oOwner
                        hitboxSpawnData[o.oSaberIndex](obj)
                        obj.oSaberIndex = i
                        obj.oFurthestHitbox = numberOfHitboxes[o.oSaberIndex]
                    end)
                end
            end
            o.oMoveAngleYaw = o.oMoveAngleYaw - 3000
            cur_obj_hide()
        elseif (o.oTimer == 22) then
            front = 35
            cur_obj_unhide()
            obj_scale(o, 1)
            o.oMoveAnglePitch = 0
            o.oMoveAngleRoll = 0
            o.oMoveAngleYaw = o.oMoveAngleYaw + 5000
        elseif (o.oTimer > 22 and o.oTimer <= 30) then
            front = 35
        elseif (o.oTimer > 30) then
            obj_scale(o, 1 - (o.oTimer - 30) * 0.045)
        end
        if (m.action ~= ACT_RAIKOUSEN) then
            obj_mark_for_deletion(o)
        end
    elseif o.oSaberIndex == CONST_WALL_SLIDE_SLASH then
        limb = 1
        up = -20
        front = 15
        if (o.oTimer == 2) then
            o.oMoveAnglePitch = -20000
            obj_scale(o, 0.6)
            o.header.gfx.scale.z = 1.2
            o.header.gfx.scale.y = 1.15
        elseif (o.oTimer == 3) then
            cur_obj_unhide()
            obj_set_model_extended(o, E_model_lslash2)
            obj_scale_xyz(o, 1.2, 1.8, 1.2)
            o.oMoveAnglePitch = -8000
        elseif (o.oTimer == 4) then
            obj_scale_xyz(o, 1.2, 1.65, 1.2)
            o.oMoveAnglePitch = -1000
        elseif (o.oTimer == 5) then
            local scaleRate = 1.1 - ((o.oTimer / 4) * 0.05)
            obj_scale_xyz(o, scaleRate, 0.6, scaleRate * 0.95)
            o.oMoveAnglePitch = o.oTimer * 50
        elseif (o.oTimer > 5 and o.oTimer < 7) then
            local scaleRate = 0.9 - ((o.oTimer / 5) * 0.1)
            obj_scale_xyz(o, scaleRate, 0.6, scaleRate * 0.95)
            obj_set_model_extended(o, E_model_lslash3)
        elseif o.oTimer >= 7 then
            obj_scale_xyz(o, 0.6, 0.6, 0.6)
            o.oMoveAnglePitch = o.oMoveAnglePitch + 500
            obj_set_model_extended(o, E_model_lslash4)
        end
        if (m.action ~= ACT_WALL_SLIDE or mmx.zero_wall_slide_slash == 0 
        or (mmx.zero_cancel_slash == 1 and o.oTimer > 1)) then
            obj_mark_for_deletion(o)
        end
    elseif o.oSaberIndex == CONST_HYOURETSUZAN then
        side = -10
        if (o.oTimer == 1) then
            obj_set_model_extended(o, E_model_hyouretsuzan)
            cur_obj_unhide()
            obj_scale(o, 0.5)
            front = 30
        elseif o.oTimer == 2 then
            obj_scale_xyz(o, 0.7, 0.7, 0.85)
            front = 15
        elseif o.oTimer == 3 then
            obj_scale_xyz(o, 0.9, 0.9, 1)
        end
        o.oMoveAnglePitch = 16384
        if (m.action ~= ACT_HYOURETSUZAN) then
            obj_mark_for_deletion(o)
        end
    elseif o.oSaberIndex == CONST_RYUENJIN then
        up = 27
        if o.oTimer == 1 then
            o.oMoveAnglePitch = -4000
            cur_obj_unhide()
        elseif o.oTimer == 2 then
            obj_scale_xyz(o, 0.8, 1.15, 0.8)
        elseif o.oTimer == 3 then
            obj_scale_xyz(o, 0.92, 0.88, 0.92)
        elseif o.oTimer == 9 then
            obj_scale_xyz(o, 0.92, 0.52, 0.82)
        end
    
        if (o.oTimer % 2 == 0) then
            obj_set_model_extended(o, E_model_ryuenjin2)
        else
            obj_set_model_extended(o, E_model_ryuenjin1)
        end

        --local xOffsetByPlayerSpeed = mmx.dPrevPos.x - 45 * sins(o.oMoveAngleYaw)
        --local yOffsetByPlayerSpeed = mmx.dPrevPos.y - 30
        --local zOffsetByPlayerSpeed = mmx.dPrevPos.z - 45 * coss(o.oMoveAngleYaw)
        local xOffsetByPlayerSpeed = 0
        local yOffsetByPlayerSpeed = 0
        local zOffsetByPlayerSpeed = 0
        if o.oTimer < 11 then
            xOffsetByPlayerSpeed = mmx.dPrevPos.x - m.vel.x
            yOffsetByPlayerSpeed = mmx.dPrevPos.y - m.vel.y - 4
            zOffsetByPlayerSpeed = mmx.dPrevPos.z - m.vel.z
        end
    
        if (o.oTimer < 10 and o.oTimer > 1) then
            local timeroffset = o.oTimer * -15
                spawn_non_sync_object(id_bhvRotatedFlame, E_MODEL_RED_FLAME, 
                o.oPosX + sins(o.oMoveAngleYaw) * (230 + timeroffset) + xOffsetByPlayerSpeed, 
                o.oPosY - 20 + yOffsetByPlayerSpeed, 
                o.oPosZ + coss(o.oMoveAngleYaw) * (230 + timeroffset) + zOffsetByPlayerSpeed, function(obj)
                    obj.header.gfx.scale.x = 4
                    obj.header.gfx.scale.y = 4
                    obj.header.gfx.scale.z = 4
                    obj.oOwner = o.oOwner
                end)
            
            if (o.oTimer < 8) then
                local evenOffset = 0
                if (o.oTimer % 2 == 0) then
                    evenOffset = 50
                end
                spawn_non_sync_object(id_bhvRotatedFlame, E_MODEL_BOWSER_FLAMES, 
                o.oPosX + sins(o.oMoveAngleYaw) * (260 + timeroffset - evenOffset) + xOffsetByPlayerSpeed, 
                o.oPosY + 110 + yOffsetByPlayerSpeed, 
                o.oPosZ + coss(o.oMoveAngleYaw) * (260 + timeroffset - evenOffset) + zOffsetByPlayerSpeed, function(obj)
                    obj.header.gfx.scale.x = 0.55
                    obj.header.gfx.scale.y = 0.55
                    obj.header.gfx.scale.z = 0.55
                    obj.oMoveAngleRoll = 32768
                    obj.oOwner = o.oOwner
                end)


                spawn_non_sync_object(id_bhvRotatedFlame, E_MODEL_BOWSER_FLAMES, 
                o.oPosX + sins(o.oMoveAngleYaw) * (320 + timeroffset - evenOffset) + xOffsetByPlayerSpeed, 
                o.oPosY + 80 + yOffsetByPlayerSpeed, 
                o.oPosZ + coss(o.oMoveAngleYaw) * (320 + timeroffset - evenOffset) + zOffsetByPlayerSpeed, function(obj)
                    obj.header.gfx.scale.x = 0.6
                    obj.header.gfx.scale.y = 0.6
                    obj.header.gfx.scale.z = 0.6
                    obj.oMoveAngleRoll = 32768
                    obj.oOwner = o.oOwner
                end)
        
                spawn_non_sync_object(id_bhvRotatedFlame, E_MODEL_BOWSER_FLAMES, 
                o.oPosX + sins(o.oMoveAngleYaw) * (320 + timeroffset - evenOffset) + xOffsetByPlayerSpeed, 
                o.oPosY + 80 + yOffsetByPlayerSpeed, 
                o.oPosZ + coss(o.oMoveAngleYaw) * (320 + timeroffset - evenOffset) + zOffsetByPlayerSpeed, function(obj)
                    obj.header.gfx.scale.x = 0.6
                    obj.header.gfx.scale.y = 0.2
                    obj.header.gfx.scale.z = 0.6
                    obj.oOwner = o.oOwner
                end)
    
                if (o.oTimer == 7) then
                    spawn_non_sync_object(id_bhvRotatedFlame, E_MODEL_BOWSER_FLAMES, 
                    o.oPosX + sins(o.oMoveAngleYaw) * (340 + timeroffset - evenOffset) + xOffsetByPlayerSpeed, 
                    o.oPosY + 130 + yOffsetByPlayerSpeed, 
                    o.oPosZ + coss(o.oMoveAngleYaw) * (340 + timeroffset - evenOffset) + zOffsetByPlayerSpeed, function(obj)
                        obj.header.gfx.scale.x = 0.4
                        obj.header.gfx.scale.y = 0.6
                        obj.header.gfx.scale.z = 0.4
                        obj.oMoveAngleRoll = 32768
                        obj.oOwner = o.oOwner
                    end)
            
                    spawn_non_sync_object(id_bhvRotatedFlame, E_MODEL_BOWSER_FLAMES, 
                    o.oPosX + sins(o.oMoveAngleYaw) * (340 + timeroffset - evenOffset) + xOffsetByPlayerSpeed, 
                    o.oPosY + 130 + yOffsetByPlayerSpeed, 
                    o.oPosZ + coss(o.oMoveAngleYaw) * (340 + timeroffset - evenOffset) + zOffsetByPlayerSpeed, function(obj)
                        obj.header.gfx.scale.x = 0.4
                        obj.header.gfx.scale.y = 0.2
                        obj.header.gfx.scale.z = 0.4
                        obj.oOwner = o.oOwner
                    end)
                end
            end
        
            spawn_non_sync_object(id_bhvWhitePuffSmoke2, E_MODEL_RED_FLAME, 
            o.oPosX + sins(o.oMoveAngleYaw) * (240 + timeroffset) + xOffsetByPlayerSpeed, 
            o.oPosY - 60 + yOffsetByPlayerSpeed, 
            o.oPosZ + coss(o.oMoveAngleYaw) * (240 + timeroffset) + zOffsetByPlayerSpeed, function(obj)
                obj.header.gfx.scale.x = 3
                obj.header.gfx.scale.y = 3
                obj.header.gfx.scale.z = 3
            end)
        
            if (o.oTimer >= 4) then
                spawn_non_sync_object(id_bhvWhitePuffSmoke2, E_MODEL_RED_FLAME, 
                o.oPosX + sins(o.oMoveAngleYaw) * (295 + timeroffset * 1.1) + xOffsetByPlayerSpeed, 
                o.oPosY - 70 + yOffsetByPlayerSpeed, 
                o.oPosZ + coss(o.oMoveAngleYaw) * (295 + timeroffset * 1.1) + zOffsetByPlayerSpeed, function(obj)
                    obj.header.gfx.scale.x = 2.5
                    obj.header.gfx.scale.y = 2.5
                    obj.header.gfx.scale.z = 2.5
                end)
            end
        
            if (o.oTimer >= 6) then
                spawn_non_sync_object(id_bhvWhitePuffSmoke2, E_MODEL_RED_FLAME, 
                o.oPosX + sins(o.oMoveAngleYaw) * 170 + xOffsetByPlayerSpeed,
                o.oPosY - 50 + yOffsetByPlayerSpeed,
                o.oPosZ + coss(o.oMoveAngleYaw) * 170 + zOffsetByPlayerSpeed, function(obj)
                    obj.header.gfx.scale.x = 2.5
                    obj.header.gfx.scale.y = 2.5
                    obj.header.gfx.scale.z = 2.5
                end)
            end
        end
        if m.action ~= ACT_RYUENJIN or o.oTimer == 11 then
            obj_mark_for_deletion(o)
        end
    elseif o.oSaberIndex == CONST_SENTSUIZAN then
        front = 32
        up = -25
        side = -15
        if (o.oTimer == 1) then
            obj_set_model_extended(o, E_model_sentsuizan)
            o.oMoveAnglePitch = 5000
            o.oMoveAngleRoll = 5000
            obj_scale_xyz(o, 0.6, 1, 0.9)
            cur_obj_unhide()
        end
        if (m.action ~= ACT_SENTSUIZAN) then
            obj_mark_for_deletion(o)
        end
    end

    local yawSin = sins(m.marioObj.header.gfx.angle.y)
    local yawSideSin = sins(m.marioObj.header.gfx.angle.y - 0x4000)

    local yawCos = coss(m.marioObj.header.gfx.angle.y)
    local yawSideCos = coss(m.marioObj.header.gfx.angle.y - 0x4000)

    local pitchSin = sins(m.marioObj.header.gfx.angle.x)
    local pitchCos = coss(m.marioObj.header.gfx.angle.x)

    if m.action == ACT_SHIPPUGA then
        side = 20
        up = 10
        front = -5
    end

    local velY = 0
    o.oPosX = get_hand_foot_pos_x(m, limb) + side * yawSideSin + front * yawSin * pitchCos + mmx.dPrevPos.x
    o.oPosY = get_hand_foot_pos_y(m, limb) + up + mmx.dPrevPos.y
    o.oPosZ = get_hand_foot_pos_z(m, limb) + side * yawSideCos + front * yawCos * pitchCos + mmx.dPrevPos.z
end


-- Hyouretsuzan saber
local hyouretsuzan_shard_init = function(o)
    obj_set_model_extended(o, E_model_hyouretsuzan_shard)
    obj_scale(o, 0.45)
    o.oFlags = (OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE | OBJ_FLAG_SET_FACE_ANGLE_TO_MOVE_ANGLE | OBJ_FLAG_SET_FACE_YAW_TO_MOVE_YAW)
end

local hyouretsuzan_shard_loop = function(o)
    local vspeed = 27 - o.oTimer * 3.9
    o.oPosX = o.oPosX + sins(o.oMoveAngleYaw) * 10
    o.oPosY = o.oPosY + vspeed
    o.oPosZ = o.oPosZ + coss(o.oMoveAngleYaw) * 10
    o.oMoveAnglePitch = o.oMoveAnglePitch + 5500
    if o.oTimer > 11 and o.oTimer < 14 then
        obj_scale(o, 0.35)
    elseif o.oTimer >= 14 then
        obj_mark_for_deletion(o)
    end
end


local rotated_flame_init = function(o)
    o.oFlags = (OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE | OBJ_FLAG_SET_FACE_ANGLE_TO_MOVE_ANGLE | OBJ_FLAG_SET_FACE_YAW_TO_MOVE_YAW)
    o.oAnimState = 4
    cur_obj_hide()
end

local rotated_flame_loop = function(o)
    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    if (s.zero_hit_stop > 0) then
        o.oTimer = o.oTimer - 1
        return
    end
    if (o.oTimer == 1) then
        cur_obj_unhide()
    end
    local m0 = gMarioStates[0]
    o.oMoveAngleYaw = m0.area.camera.yaw
    o.oAnimState = o.oAnimState + 1

    local pitch = calculate_pitch(m0.pos, m0.area.camera.pos)
    o.oMoveAnglePitch = -pitch

    if o.oTimer == 4 then
        obj_mark_for_deletion(o)
    end
end


--- Raikousen lightning 
local raik_lightning_init = function(o)
    obj_set_model_extended(o, E_model_raikousen)
    o.oFlags = (OBJ_FLAG_COMPUTE_ANGLE_TO_MARIO | OBJ_FLAG_COMPUTE_DIST_TO_MARIO | OBJ_FLAG_SET_FACE_ANGLE_TO_MOVE_ANGLE | OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE)
    o.header.gfx.scale.x = 1.2
    o.header.gfx.scale.y = 1.1
    o.header.gfx.scale.z = 1.2
    o.header.gfx.skipInViewCheck = true
    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]
    local mmx = gMmxStates[m.playerIndex]
    pitch = calculate_pitch(m.pos, mmx.zero_raikousen_start_pos)
    o.oMoveAnglePitch = pitch
    o.oMoveAngleYaw = atan2s(m.pos.z - mmx.zero_raikousen_start_pos.z, m.pos.x - mmx.zero_raikousen_start_pos.x)
    o.oPosY = o.oPosY - (m.pos.y - mmx.zero_raikousen_start_pos.y)
    cur_obj_hide()
end

local raik_lightning_loop = function(o)
    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    if (s.zero_hit_stop > 0) then
        o.oTimer = o.oTimer - 1
        return
    end
    if o.oTimer == 1 then
        cur_obj_unhide()
        for i = 1, 1 do
            local xpos = o.oPosX - sins(o.oMoveAngleYaw) * (900 - i * 120) * coss(o.oMoveAnglePitch)
            local ypos = o.oPosY
            local zpos = o.oPosZ - coss(o.oMoveAngleYaw) * (900 - i * 120) * coss(o.oMoveAnglePitch)
            spawn_sync_object(id_bhvRaikousenLightningHitboxSpawner, E_MODEL_NONE, xpos, ypos, zpos, function(obj)
                obj.oOwner = o.oOwner
                obj.oMoveAngleYaw = o.oMoveAngleYaw
                obj.oMoveAnglePitch = o.oMoveAnglePitch
            end)
        end
    end
    o.hookRender = true

    if o.oTimer % 2 == 0 then
        o.header.gfx.scale.x = 1.45
        o.header.gfx.scale.y = 1.35
    else
        o.header.gfx.scale.x = 1.2
        o.header.gfx.scale.y = 1.1
    end

    if o.oTimer == 3 then
        o.header.gfx.scale.x = 1.75
        o.header.gfx.scale.y = 1.65
    end

    if o.oTimer == 7 then
        o.header.gfx.scale.x = 0.95
        o.header.gfx.scale.y = 0.85
        o.oMoveAngleRoll = o.oMoveAngleRoll + 16384
    end

    if o.oTimer == 8 then
        o.header.gfx.scale.x = 0.85
        o.header.gfx.scale.y = 0.75
    end
    
    if o.oTimer == 3 or o.oTimer == 8 then
        obj_set_model_extended(o, E_model_raikousen2)
    end

    if o.oTimer == 5 then
        obj_set_model_extended(o, E_model_raikousen)
    end

    if o.oTimer == 9 then
        obj_mark_for_deletion(o)
    end
end


local lightning_hitbox_spawner_init = function(o)
    obj_set_model_extended(o, E_model_raikousen)
    o.oFlags = (OBJ_FLAG_COMPUTE_ANGLE_TO_MARIO | OBJ_FLAG_COMPUTE_DIST_TO_MARIO | OBJ_FLAG_SET_FACE_ANGLE_TO_MOVE_ANGLE | OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE)
    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]
    local mmx = gMmxStates[m.playerIndex]
    cur_obj_hide()
    if m.playerIndex == 0 then
        for i = 1, 6 do
            spawn_sync_object(id_bhvZsaberHitBox, E_MODEL_NONE, o.oPosX, o.oPosY, o.oPosZ, function(obj)
                obj.parentObj = o
                obj.oBehParams = CONST_RAIKOUSEN_LIGHTNING
                obj.oOwner = o.oOwner
                obj.oSaberIndex = i
                obj.oFurthestHitbox = 6
                obj.hitboxRadius            = 110 / hitboxDivider
                obj.hitboxHeight            = 220 / hitboxDivider
                obj.hitboxDownOffset        = 110 / hitboxDivider
                obj.oIsMultiHit = 0
                obj.oMmxAtkDmg = 2
            end)
        end
    end
end

local lightning_hitbox_spawner_loop = function(o)
    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    if (s.zero_hit_stop > 0) then
        o.oTimer = o.oTimer - 1
        return
    end

    if o.oTimer == 10 then
        obj_mark_for_deletion(o)
    end
end



local zsaber_base_init = function(o)
    obj_set_model_extended(o, E_model_zsaber_base)
    o.oFlags = (OBJ_FLAG_COMPUTE_ANGLE_TO_MARIO | OBJ_FLAG_SET_FACE_ANGLE_TO_MOVE_ANGLE | OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE)
    cur_obj_hide()
    obj_scale(o, 0.5)
end

baseDeleteConditionTable = {
    [1] = function(m, timer)
        return m.action ~= ACT_LIGHT_ZSABER or timer == 12
    end,
    [2] = function(m, timer)
        return m.action ~= ACT_MEDIUM_ZSABER or timer == 11
    end,
    [3] = function(m, timer)
        return m.action ~= ACT_HEAVY_ZSABER or timer == 12
    end,
    [4] = function(m, timer)
        local mmx = gMmxStates[m.playerIndex]
        return ((mmx.zero_cancel_slash == 1 and timer > 1) or
         (m.action ~= ACT_AIR_SLASH and m.action ~= ACT_AIR_SLASH_LAND)) or timer == 12
    end,
    [5] = function(m, timer)
        return m.action ~= ACT_KUENZAN or timer == 10
    end,
    [6] = function(m, timer)
        return m.action ~= ACT_SHIPPUGA or timer > 5
    end,
    [7] = function(m, timer)
        return m.action ~= ACT_RAIKOUSEN
    end,
    [8] = function(m, timer)
        local mmx = gMmxStates[m.playerIndex]
        return (m.action ~= ACT_WALL_SLIDE or mmx.zero_wall_slide_slash == 0 
        or (mmx.zero_cancel_slash == 1 and timer > 1))
    end,
    [9] = function(m, timer)
        return m.action ~= ACT_HYOURETSUZAN
    end,
    [10] = function(m, timer)
        return m.action ~= ACT_RYUENJIN or timer == 11
    end,
    [11] = function(m, timer)
        return m.action ~= ACT_SENTSUIZAN
    end,
    [12] = function(m, timer)
        return m.action ~= ACT_RAIKOUSEN or timer > 9
    end
}

local zsaber_base_loop = function(o)
    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    if (s.zero_hit_stop > 0) then
        o.oTimer = o.oTimer - 1
        return
    end
    if (o.oTimer == 2) then
        cur_obj_unhide()
    end
    o.oPosX = o.parentObj.oPosX
    o.oPosY = o.parentObj.oPosY
    o.oPosZ = o.parentObj.oPosZ
    
    o.oMoveAngleRoll = o.parentObj.oMoveAngleRoll
    o.oMoveAngleYaw = o.parentObj.oMoveAngleYaw
    o.oMoveAnglePitch = o.parentObj.oMoveAnglePitch
    if (baseDeleteConditionTable[o.oBehParams](m, o.oTimer) ~= false) then
        obj_mark_for_deletion(o)
    end
    if (m.action == ACT_RAIKOUSEN) then
        if o.oTimer == 13 then
            cur_obj_hide()
        elseif o.oTimer == 22 then
            cur_obj_unhide()
        end
    end
end


--------------------------------------------------
--- REGISTRING BEHAVIORS -------------------------
--------------------------------------------------

id_bhvSaber = hook_behavior(nil, OBJ_LIST_UNIMPORTANT, false, saber_init, saber_loop)

id_bhvHyouretsuzanShard = hook_behavior(nil, OBJ_LIST_UNIMPORTANT, false, hyouretsuzan_shard_init, hyouretsuzan_shard_loop)

id_bhvRotatedFlame = hook_behavior(nil, OBJ_LIST_UNIMPORTANT, false, rotated_flame_init, rotated_flame_loop)

id_bhvRaikousenLightning = hook_behavior(nil, OBJ_LIST_UNIMPORTANT, false, raik_lightning_init, raik_lightning_loop)
id_bhvRaikousenLightningHitboxSpawner = hook_behavior(nil, OBJ_LIST_UNIMPORTANT, false, lightning_hitbox_spawner_init, lightning_hitbox_spawner_loop)
id_bhvZsaberBase = hook_behavior(nil, OBJ_LIST_UNIMPORTANT, false, zsaber_base_init, zsaber_base_loop)


--------------------------------------------------
--- RENDER SABERS --------------------------------
--------------------------------------------------

hook_event(HOOK_ON_OBJECT_RENDER, function(o)
    if get_id_from_behavior(o.behavior) == id_bhvRaikousenLightning then
        o.header.gfx.pos.x = o.oPosX - sins(o.oMoveAngleYaw) * 675
        o.header.gfx.pos.z = o.oPosZ - coss(o.oMoveAngleYaw) * 675
        return
    elseif get_id_from_behavior(o.behavior) == id_bhvSaber then
        o.header.gfx.pos.x = o.oPosX + sins(o.oMoveAngleYaw) * 17
        o.header.gfx.pos.z = o.oPosZ + coss(o.oMoveAngleYaw) * 17
    end
    
    --[[
    if obj_has_model_extended(o, E_model_lslash1) == 0 then
        return
    end
    djui_chat_message_create('nil')

    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]

    if m == nil then
        djui_chat_message_create('nil')
        return
    end

    local up = 0
    local front = 0
    local side = 0

    local limb = 0

    local yawSin = sins(m.marioObj.header.gfx.angle.y)
    local yawSideSin = sins(m.marioObj.header.gfx.angle.y - 0x4000)

    local yawCos = coss(m.marioObj.header.gfx.angle.y)
    local yawSideCos = coss(m.marioObj.header.gfx.angle.y - 0x4000)

    local pitchSin = sins(m.marioObj.header.gfx.angle.x)
    local pitchCos = coss(m.marioObj.header.gfx.angle.x)

    if m.action == ACT_LIGHT_ZSABER then
        front = -10
        side = 10

        o.oOpacity = 0

    end
    o.header.gfx.pos.x = get_hand_foot_pos_x(m, limb) + side * yawSideSin + front * yawSin * pitchCos
    o.header.gfx.pos.y = get_hand_foot_pos_y(m, limb) + up
    o.header.gfx.pos.z = get_hand_foot_pos_z(m, limb) + side * yawSideCos + front * yawCos * pitchCos
    --]]
end)
