-----------------------------------------------------------------
----- LOCALIZED -------------------------------------------------
-----------------------------------------------------------------
local math_sin, math_cos, mario_check_object_grab, mario_floor_is_steep, mario_drop_held_object, spawn_non_sync_object, analog_stick_held_back, apply_slope_accel,
 set_mario_action, lava_boost_on_wall, perform_air_step, smlua_anim_util_set_animation, approach_s32, should_begin_sliding,
  update_air_without_turn, common_air_action_step, mario_set_forward_vel, begin_braking_action, set_jump_from_landing, smlua_anim_util_set_animation,
  set_mario_animation, align_with_floor, mmx_play_sound, atan2s, calc_abs_dist, abs_angle_diff, math_floor, math_pi, check_horizontal_wind =
 math.sin, math.cos, mario_check_object_grab, mario_floor_is_steep, mario_drop_held_object, spawn_non_sync_object, analog_stick_held_back, apply_slope_accel,
  set_mario_action, lava_boost_on_wall,  perform_air_step, smlua_anim_util_set_animation, approach_s32, should_begin_sliding,
   update_air_without_turn, common_air_action_step, mario_set_forward_vel, begin_braking_action, set_jump_from_landing, smlua_anim_util_set_animation,
   set_mario_animation, align_with_floor, mmx_play_sound, atan2s, calc_abs_dist, abs_angle_diff, math.floor, math.pi, check_horizontal_wind

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
---- ACTIONS -----------------------------------------------------------------
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------


-------------------------------------------
--- ALLOCATIONS ---------------------------
-------------------------------------------

ACT_AIR_HIT_WALL_CUSTOM =       allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING | ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION | ACT_FLAG_CONTROL_JUMP_HEIGHT)
ACT_DASH =                      allocate_mario_action(ACT_GROUP_MOVING | ACT_FLAG_MOVING | ACT_FLAG_BUTT_OR_STOMACH_SLIDE | ACT_FLAG_SHORT_HITBOX)
ACT_AIR_DASH =             allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING | ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION | ACT_FLAG_SHORT_HITBOX)
ACT_JUMP_CUSTOM =           allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING | ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION | ACT_FLAG_CONTROL_JUMP_HEIGHT)
ACT_FREEFALL_CUSTOM =           allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING | ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION)
ACT_WALL_SLIDE =           allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING | ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION)
ACT_WALL_KICK_CUSTOM =      allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING | ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION | ACT_FLAG_CONTROL_JUMP_HEIGHT)
ACT_WALKING_CUSTOM =               allocate_mario_action(ACT_GROUP_MOVING | ACT_FLAG_MOVING | ACT_FLAG_ALLOW_FIRST_PERSON)


-------------------------------------------
--- RESOURCES -----------------------------
-------------------------------------------

local SOUND_X_DASH = SOUND_X_DASH
local SOUND_X_WALLHIT = SOUND_X_WALLHIT

local SOUND_ZERO_DASH = SOUND_ZERO_DASH

local SOUND_VILE_DASH = SOUND_VILE_DASH

-------------------------------------------
--- STEP FUNCTIONS ------------------------
-------------------------------------------

function transition_into_idle_or_walk(m, speed)
    if (m.input & INPUT_NONZERO_ANALOG) ~= 0 then
        mario_set_forward_vel(m, (m.controller.stickMag / 64) * speed)
        return set_mario_action(m, ACT_WALKING_CUSTOM, 0)
    else
        return set_mario_action(m, ACT_IDLE, 0)
    end
end

function check_any_input(m)
    return (m.input & INPUT_ZERO_MOVEMENT) == 0 or (m.input & INPUT_A_PRESSED) ~= 0 or
        (m.input & INPUT_B_PRESSED) ~= 0 or (m.input & INPUT_Z_PRESSED) ~= 0 or
        (m.controller.buttonPressed & Y_BUTTON) ~= 0 or (m.controller.buttonPressed & X_BUTTON) ~= 0
end

function check_any_button(m)
    return (m.input & INPUT_A_PRESSED) ~= 0 or
        (m.input & INPUT_B_PRESSED) ~= 0 or (m.input & INPUT_Z_PRESSED) ~= 0 or
        (m.controller.buttonPressed & Y_BUTTON) ~= 0 or (m.controller.buttonPressed & X_BUTTON) ~= 0
end

-- This is like common_air_action_step except there is no bonk
function common_air_action_step_wall(m, landAction, animation, stepArg)
    if not m then return 0 end
    local stepResult

    update_air_without_turn(m)

    stepResult = perform_air_step(m, stepArg)
    if m.action == ACT_BUBBLED and stepResult == AIR_STEP_HIT_LAVA_WALL then
        stepResult = AIR_STEP_HIT_WALL
    end

    if stepResult == AIR_STEP_NONE then
        set_character_animation(m, animation)
    elseif stepResult == AIR_STEP_LANDED then
        if m.forwardVel < ZERO_MAXAIRSPEED_NODASH then
            m.forwardVel = m.intendedMag
        end
        set_mario_action(m, landAction, 0)
    elseif stepResult == AIR_STEP_HIT_WALL then
        set_character_animation(m, animation)
        if (m.forwardVel >= 12) then
            
            if m.wall then
                if m.action == ACT_AIR_DASH then
                    

                    local stickAngle = m.intendedYaw
                    local wallYaw = atan2s(m.wallNormal.z, m.wallNormal.x)
                    local angleDiff = abs_angle_diff(stickAngle, wallYaw)
                    if angleDiff > 32768 then
                        angleDiff = 2 * 32768 - angleDiff
                    end

                    local normalStickMag = m.controller.stickMag / 64

                    if (normalStickMag >= 0.1 and angleDiff >= 21500) then
                        m.faceAngle.y = m.faceAngle.y + 0x8000
                        set_mario_action(m, ACT_AIR_HIT_WALL, 0)
                    end



                else
                    m.faceAngle.y = m.faceAngle.y + 0x8000
                    set_mario_action(m, ACT_AIR_HIT_WALL, 0)
                end
            end
        else
            mario_set_forward_vel(m, 0)
        end
    elseif stepResult == AIR_STEP_GRABBED_CEILING then
        set_mario_action(m, ACT_START_HANGING, 0)
    elseif stepResult == AIR_STEP_HIT_LAVA_WALL then
        lava_boost_on_wall(m)
    end

    return stepResult
end

function update_air_without_turn_zero_air_slash(m)
    if not m then return end

    local s = gPlayerSyncTable[m.playerIndex]
    local targetMaxHspeed = ZERO_MAXAIRSPEED_NODASH
    local holdBackSlowDown = 7
    local sideSpeed = 13
    if s.jump_dash_state then
        if (s.jumped_from_ground_dash) then
            holdBackSlowDown = 16
            targetMaxHspeed = ZERO_MAXAIRSPEED_DASHJUMP
            sideSpeed = 17
        else
            holdBackSlowDown = 14
            sideSpeed = 16
            targetMaxHspeed = ZERO_MAXAIRSPEED_HOLDDASHJUMP
        end
    end

    local sidewaysSpeed = 0.0
    local intendedDYaw = m.intendedYaw - m.faceAngle.y
    local intendedMag

    if coss(intendedDYaw) >= 0 then
        if m.forwardVel > targetMaxHspeed then
            targetMaxHspeed = m.forwardVel
        end
    end

    targetMaxHspeed = targetMaxHspeed - holdBackSlowDown * (1 - coss(intendedDYaw)) / 1.7


    --if check_horizontal_wind(m) == 0 then
        m.forwardVel = approach_f32(m.forwardVel, 0.0, 0.35, 0.35)

        
        --if m.input & INPUT_NONZERO_ANALOG ~= 0 then
        --    intendedDYaw = m.intendedYaw - m.faceAngle.y
        --    intendedMag = m.intendedMag / 32.0
        --    local accel = coss(intendedDYaw) < 0 and targetMaxHspeed - holdBackSlowDown or targetMaxHspeed
        --    m.forwardVel = m.forwardVel + intendedMag * coss(intendedDYaw) * (targetMaxHspeed / 7)
        --    sidewaysSpeed = intendedMag * sins(intendedDYaw) * 10.0
        --end

        intendedMag = m.intendedMag / 32.0
        --m.forwardVel = intendedMag * coss(intendedDYaw) * targetMaxHspeed
        --sidewaysSpeed = intendedMag * sins(intendedDYaw) * targetMaxHspeed


        -- Uncapped air speed. Net positive when moving forward.
        --if m.forwardVel > targetMaxHspeed then
        --    m.forwardVel = targetMaxHspeed
        --end
        --if m.forwardVel < -targetMaxHspeed + holdBackSlowDown then
        --    m.forwardVel = -targetMaxHspeed + holdBackSlowDown
        --end


        if m.action == ACT_KUENZAN then
            sidewaysSpeed = intendedMag * sins(intendedDYaw) * sideSpeed
            m.slideVelX = m.forwardVel * sins(m.faceAngle.y)
            m.slideVelZ = m.forwardVel * coss(m.faceAngle.y)

            m.slideVelX = m.slideVelX + sidewaysSpeed * sins(m.faceAngle.y + 0x4000)
            m.slideVelZ = m.slideVelZ + sidewaysSpeed * coss(m.faceAngle.y + 0x4000)

            m.forwardVel = intendedMag * coss(intendedDYaw) * targetMaxHspeed
            m.vel.x = m.slideVelX
            m.vel.z = m.slideVelZ
        else
            m.forwardVel = intendedMag * targetMaxHspeed
            m.vel.x = m.forwardVel * sins(m.intendedYaw)
            m.vel.z = m.forwardVel * coss(m.intendedYaw)
        end

        --m.vel.x = intendedMag * sins(m.intendedYaw) * targetMaxHspeed
        --m.vel.z = intendedMag * coss(m.intendedYaw) * targetMaxHspeed
    --end
end

-- This is like common_air_action_step except that there is no wall interaction
-- Usually called when the vspeed is positive, to prevent the wall slide action with positive vspeed
function common_air_action_step_no_wall(m, landAction, animation, stepArg, actionArg)
    if not m then return 0 end
    local stepResult

    if m.action ~= ACT_AIR_SLASH and m.action ~= ACT_KUENZAN then
        update_air_without_turn(m)
    else
        update_air_without_turn_zero_air_slash(m)
    end

    stepResult = perform_air_step(m, stepArg)
    if m.action == ACT_BUBBLED and stepResult == AIR_STEP_HIT_LAVA_WALL then
        stepResult = AIR_STEP_HIT_WALL
    end

    if stepResult == AIR_STEP_NONE or stepResult == AIR_STEP_HIT_WALL then
        set_character_animation(m, animation)
    elseif stepResult == AIR_STEP_LANDED then
        if m.forwardVel < ZERO_MAXAIRSPEED_NODASH then
            m.forwardVel = m.intendedMag
        end
        set_mario_action(m, landAction, actionArg)
    elseif stepResult == AIR_STEP_GRABBED_CEILING then
        set_mario_action(m, ACT_START_HANGING, 0)
    elseif stepResult == AIR_STEP_HIT_LAVA_WALL then
        lava_boost_on_wall(m)
    end

    return stepResult
end

local function limit_angle(a)
    return (a + 0x8000) % 0x10000 - 0x8000
end

local function update_walking_speed_mmx(m)
    local s = gPlayerSyncTable[m.playerIndex]
    local maxTargetSpeed = 0
    local targetSpeed    = 0
    local char_accel = 1.5

    if m.floor ~= 0 and m.floor.type == SURFACE_SLOW then
        maxTargetSpeed = 24.0
    else
        if (s.character == 'vile') then
            maxTargetSpeed = 43.0
        else
            maxTargetSpeed = 32.0
        end
    end

    local intendedMag = m.intendedMag
    if (s.character == 'vile') then
        intendedMag = intendedMag * 1.34375
        char_accel = 1.75
    end

    if intendedMag < maxTargetSpeed then
        targetSpeed = intendedMag
    else
        targetSpeed = maxTargetSpeed
    end

    if m.quicksandDepth > 10.0 then
        targetSpeed = targetSpeed * (6.25 / m.quicksandDepth)
    end

    if m.forwardVel <= 0.0 then
        m.forwardVel = m.forwardVel + char_accel
    elseif m.forwardVel <= targetSpeed then
        m.forwardVel = m.forwardVel + (char_accel - m.forwardVel / 43.0)
    elseif m.floor ~= 0 and m.floor.normal.y >= 0.95 then
        m.forwardVel = m.forwardVel - 1.0
    end

    if m.forwardVel > 48.0 then
        m.forwardVel = 48.0
    end

    m.faceAngle.y = m.intendedYaw
    
    apply_slope_accel(m)
end

-- unused for now
local function anim_and_audio_for_walk_mmx(m)
    if not m then return end
    local val14 = 0
    local marioObj = m.marioObj
    local val0C = true
    local targetPitch = 0
    local val04 = 0

    val04 = m.intendedMag > m.forwardVel and m.intendedMag or m.forwardVel

    if val04 < 4.0 then
        val04 = 4.0
    end

    if m.quicksandDepth > 50.0 then
        val14 = math_floor(val04 / 4.0 * 0x10000)
        set_character_anim_with_accel(m, CHAR_ANIM_MOVE_IN_QUICKSAND, val14)
        play_step_sound(m, 19, 93)
        m.actionTimer = 0
    else
        while val0C do
            if m.actionTimer == 0 then
                if val04 > 8.0 then
                    m.actionTimer = 2
                else
                    if val04 / 4.0 * 0x10000 < 0x1000 then
                        val14 = 0x1000
                    else
                        val14 = math_floor(val04 / 4.0 * 0x10000)
                    end
                    set_character_anim_with_accel(m, CHAR_ANIM_START_TIPTOE, val14)
                    play_step_sound(m, 7, 22)
                    if is_anim_past_frame(m, 23) then
                        m.actionTimer = 2
                    end
                    val0C = false
                end
            elseif m.actionTimer == 1 then
                if val04 > 8.0 then
                    m.actionTimer = 2
                else
                    val14 = math_floor(val04 * 0x10000)
                    if val14 < 0x1000 then
                        val14 = 0x1000
                    end
                    set_character_anim_with_accel(m, CHAR_ANIM_TIPTOE, val14)
                    play_step_sound(m, 14, 72)
                    val0C = false
                end
            elseif m.actionTimer == 2 then
                if val04 < 5.0 then
                    m.actionTimer = 1
                elseif val04 > 22.0 then
                    m.actionTimer = 3
                else
                    val14 = math_floor(val04 / 4.0 * 0x10000)
                    set_character_anim_with_accel(m, CHAR_ANIM_WALKING, val14)
                    play_step_sound(m, 10, 49)
                    val0C = false
                end
            elseif m.actionTimer == 3 then
                if val04 < 18.0 then
                    m.actionTimer = 2
                else
                    val14 = math_floor(val04 / 4.0 * 0x10000)
                    set_character_anim_with_accel(m, CHAR_ANIM_RUNNING, val14)
                    --play_step_sound(m, 9, 45)
                    if (m.marioObj.header.gfx.animInfo.animFrame == 9 or m.marioObj.header.gfx.animInfo.animFrame == 10) then
                        --mmx_play_sound(SOUND_VILE_STEP, m.pos, 0.57)
                    end
                    if (is_anim_past_frame(m, 9) ~= 0 and is_anim_past_frame(m, 13) == 0) or 
                    (is_anim_past_frame(m, 45) ~= 0 and is_anim_past_frame(m, 49) == 0) then
                        mmx_play_sound(SOUND_VILE_STEP, m.pos, 0.3)
                    end
                    targetPitch = tilt_body_running(m)
                    val0C = false
                end
            else
                val0C = false
            end
        end
    end

    marioObj.oMarioWalkingPitch = approach_s32(marioObj.oMarioWalkingPitch, targetPitch, 0x800, 0x800)
    marioObj.header.gfx.angle.x = marioObj.oMarioWalkingPitch
end


----------------------------------------------
--- DEFINITION -------------------------------
----------------------------------------------

--- WALKING CUSTOM
local function act_walking_custom(m)
    local startPos = m.pos
    local startYaw = m.faceAngle.y

    mario_drop_held_object(m)

    if should_begin_sliding(m) ~= 0 then
        return set_mario_action(m, ACT_BEGIN_SLIDING, 0)
    end

    if (m.input & INPUT_FIRST_PERSON) ~= 0 then
        return begin_braking_action(m)
    end

    if (m.input & INPUT_A_PRESSED) ~= 0 then
        return set_jump_from_landing(m)
    end

    if (m.input & INPUT_ZERO_MOVEMENT) ~= 0 then
        return begin_braking_action(m)
    end

    

    --if (m.input & INPUT_Z_PRESSED) ~= 0 then
    --    return set_mario_action(m, ACT_CROUCH_SLIDE, 0)
    --end

    m.actionState = 0

    vec3f_copy(startPos, m.pos)
    update_walking_speed_mmx(m)

    local stepResult = perform_ground_step(m)
    
    if stepResult == GROUND_STEP_LEFT_GROUND then
        set_mario_action(m, ACT_FREEFALL_CUSTOM, 0)
        set_mario_animation(m, MARIO_ANIM_GENERAL_FALL)
    elseif stepResult == GROUND_STEP_NONE then
        anim_and_audio_for_walk(m)
        if (m.intendedMag - m.forwardVel > 16.0) then
            set_mario_particle_flags(m, PARTICLE_DUST, false);
        end
    elseif stepResult == GROUND_STEP_HIT_WALL then
        push_or_sidle_wall(m, startPos)
        m.actionTimer = 0
    end
    --tilt_body_walking(m, startYaw)
    return false
end

--- JUMP CUSTOM
-- This is basically the same act_jump code found in those c files but without the ledge grab check
-- Don't know if there was an alternative way to do this
function act_jump_custom(m)
    local s = gPlayerSyncTable[m.playerIndex]
    if (not m) then
        return 0
    end
    
    -- Not needed

    --if (check_kick_or_dive_in_air(m) ~= 0) then
    --    return true
    --end

    if (m.input & INPUT_A_PRESSED) ~= 0 and m.actionTimer > 0 then
        if (m.flags & MARIO_WING_CAP) ~= 0 then
            if (m.playerIndex == 0) then
                s.already_airdashed = false
                s.jump_dash_state = false
            end
            m.vel.y = 38
            return set_mario_action(m, ACT_FLYING_TRIPLE_JUMP, 0)
        elseif s.character == 'zero' and s.zero_double_jump == 0 and s.already_airdashed == false and s.jump_dash_state == false then
            m.vel.y = 30
            return set_mario_action(m, ACT_ZERO_DOUBLE_JUMP, 0)
        end
    end

    -- Variable Air Dash not available (v1.3)

    --if (m.input & INPUT_A_PRESSED) ~= 0 and m.actionTimer > 0 then
    --    return set_mario_action(m, ACT_VAD_UP, 0)
    --end

    play_mario_sound(m, SOUND_ACTION_TERRAIN_JUMP, 0)

    -- ACT_JUMP_LAND is trash?
    if (m.actionTimer < 15) then
        m.marioBodyState.eyeState = 9
    end

    if (m.vel.y >= 0) then
        common_air_action_step_no_wall(m, ACT_FREEFALL_LAND_STOP, MARIO_ANIM_SINGLE_JUMP, AIR_STEP_CHECK_HANG, 0)
    else
        common_air_action_step_wall(m, ACT_FREEFALL_LAND_STOP, MARIO_ANIM_SINGLE_JUMP, AIR_STEP_CHECK_HANG)
    end
    m.actionTimer = m.actionTimer + 1
    return false
end



--- FREEFALL_CUSTOM
function act_freefall_custom(m)
    if (not m) then
        return 0
    end

    if (m.vel.y >= 0) then
        common_air_action_step_no_wall(m, ACT_FREEFALL_LAND_STOP, MARIO_ANIM_SINGLE_JUMP, AIR_STEP_CHECK_HANG, 0)
    else
        common_air_action_step_wall(m, ACT_FREEFALL_LAND_STOP, MARIO_ANIM_SINGLE_JUMP, AIR_STEP_CHECK_HANG)
    end
    if (m.actionTimer < 30) then
        m.actionTimer = m.actionTimer + 1
    end
    return false
end




--- WALL KICK CUSTOM
function act_wall_kick_custom(m)
    local s = gPlayerSyncTable[m.playerIndex]
    local mmx = gMmxStates[m.playerIndex]
    local maxVelocity = 32
    local kickvspeed = 44.75
    if (m.actionTimer == 0) then
        if (s.character == 'x') then
            mmx_play_sound(SOUND_X_WALLKICK, m.pos, 0.3)
        elseif (s.character == 'zero') then
            mmx_play_sound(SOUND_ZERO_KICK_WALL, m.pos, 0.3)
        elseif (s.character == 'vile') then
            mmx_play_sound(SOUND_VILE_JUMP, m.pos, 0.4)
        end
    end
    if (s.character == 'vile') then
        maxVelocity = 43
        kickvspeed = 45.3
    end
    local mGfx = m.marioObj.header.gfx
    if s.jump_dash_state then
        maxVelocity = 48
    end
    if s.firstWallKick then
        if (m.playerIndex == 0) then
            s.firstWallKick = false
            s.quasiSameSideWallKicks = 0
        end
    end
    if (m.actionTimer == 0) then
        local vspeed
        if s.jump_dash_state then
            vspeed = 46.09
        else
            vspeed = kickvspeed
        end
        if s.quasiSameSideWallKicks < 1 then
            spawn_non_sync_object(id_bhvWallspark, E_model_wallspark, mGfx.pos.x , mGfx.pos.y , mGfx.pos.z , function (obj)
                obj.oMoveAngleYaw = m.faceAngle.y + 32768
            end)
        end
        vspeed = vspeed - s.quasiSameSideWallKicks * 2.5
        if (vspeed <= 0) then
            vspeed = 0
        end
        m.vel.y = vspeed
        m.faceAngle.y = m.faceAngle.y + 32768
        if (m.playerIndex == 0) then
            s.initialFaceAngleAfterWallKick = m.faceAngle.y
        end
        mario_set_forward_vel(m, -maxVelocity)
    end
    if (m.actionTimer <= 6) then
        local initialFaceTheta = s.initialFaceAngleAfterWallKick
    else
        local normalStickMag = m.controller.stickMag / 64
        mario_set_forward_vel(m, maxVelocity * normalStickMag)
    end

    mmx.last_max_vel_wallkick = maxVelocity

    -- Air dashing in here is different because it's not just the current face angle
    if s.character == 'x' or s.character == 'zero' then
        if (m.input & INPUT_Z_PRESSED) ~= 0 and s.jump_dash_state == false then
            m.vel.y = 0
            -- If action timer is smaller than 6, the airdash direction would be based on the stick orientation
            -- otherwise we don't have to do this calculation
            if (m.actionTimer <= 6) then
                m.faceAngle.y = m.intendedYaw
            end
            set_anim_to_frame(m, 0)
            return set_mario_action(m, ACT_AIR_DASH, 1)
        end
        if s.character == 'zero' then
            if (m.input & INPUT_A_PRESSED) ~= 0 and m.actionTimer > 5
            and s.zero_double_jump == 0 and s.already_airdashed == false and s.jump_dash_state == false then
                m.vel.y = m.actionTimer - 1
                return set_mario_action(m, ACT_ZERO_DOUBLE_JUMP, 0)
            end
        end
    end

    set_character_animation(m, CHAR_ANIM_SINGLE_JUMP)
    
    if m.actionTimer > 5 then
        if s.character ~= 'none' then
            mmx_update_shoot_chars_air_anims(m)
        end
    else
        if s.character == 'zero' then
            smlua_anim_util_set_animation(m.marioObj, "zero_wall_kick")
        else
            smlua_anim_util_set_animation(m.marioObj, "x_wall_kick")
        end
    end
    
    if m.actionTimer > 5 then
        if (s.character == 'zero') then
            smlua_anim_util_set_animation(m.marioObj, "zero_jump_end")
            local timerFrame = math_floor(m.actionTimer * 0.9)
            if (timerFrame) > 13 then
                timerFrame = 13
            end
            set_anim_to_frame(m, timerFrame - 4)
        end
    else
        set_anim_to_frame(m, m.actionTimer)
    end
    if m.actionTimer < 31 then
        m.actionTimer = m.actionTimer + 1
    end

    if (m.vel.y > 2) then
        common_air_action_step_no_wall(m, ACT_FREEFALL_LAND_STOP, MARIO_ANIM_SINGLE_JUMP, AIR_STEP_CHECK_HANG, 0)
    else
        common_air_action_step_wall(m, ACT_FREEFALL_LAND_STOP, MARIO_ANIM_SINGLE_JUMP, AIR_STEP_CHECK_HANG)
    end
    return 0
end




--- AIR HIT WALL CUSTOM
function act_air_hit_wall_custom(m)
    local s = gPlayerSyncTable[m.playerIndex]
    local mmx = gMmxStates[m.playerIndex]
    local wallYaw = atan2s(m.wallNormal.z, m.wallNormal.x)
    if (m.playerIndex == 0) then
        s.jump_dash_state = false
        s.zero_double_jump = 0
    end
    if m.heldObj ~= 0 then
        mario_drop_held_object(m)
    end

    if m.wall then
        m.faceAngle.y = wallYaw
    end
    
    mmx.zero_wall_slide_slash = 0
    mmx.zero_cancel_slash = 0
    return set_mario_action(m, ACT_WALL_SLIDE, 0)
end




--- WALL SLIDE
function point_is_in_funnel(x1, z1, x2, z2, direction_angle, fov_angle)
    local angle = atan2s(z1 - z2, x1 - x2)
    local angle_diff = abs_angle_diff(angle, direction_angle)
    return angle_diff <= fov_angle / 2
end

function act_wall_slide(m)
    local s = gPlayerSyncTable[m.playerIndex]
    local mmx = gMmxStates[m.playerIndex]
    if (m.playerIndex == 0 and s.already_airdashed) then
        if (s.already_airdashed) then
            s.already_airdashed = false
        end
    end
    if (m.actionTimer == 0) then
        mmx_play_sound(SOUND_X_WALLHIT, m.pos, 0.5)
    end
    if s.x_shooting == 0 or s.vile_shooting == 0 then
        if s.character == 'zero' then
            smlua_anim_util_set_animation(m.marioObj, "zero_wall_slide")
        else
            smlua_anim_util_set_animation(m.marioObj, "x_wall_slide")
        end
    end
    --local e = gMarioStateExtras[m.playerIndex]
    --e.savedWallSlideHeight = m.pos.y
    --e.savedWallSlide = true
    -- m.faceAngle.y = limit_angle(m.faceAngle.y + 0x8000)
    if (m.input & INPUT_A_PRESSED) ~= 0 then

        local wallYaw = atan2s(m.wallNormal.z, m.wallNormal.x)

        local wallYawDiff = abs_angle_diff(wallYaw, mmx.previousWallYaw)
        local check_point = point_is_in_funnel(m.pos.x, m.pos.z, mmx.lastWallKickPos.x, mmx.lastWallKickPos.z, mmx.previousWallYaw, 16384)
        if (m.playerIndex == 0) then
            if check_point and wallYawDiff >= 32768 / 1.9 then
                s.quasiSameSideWallKicks = 0
            else
                s.quasiSameSideWallKicks = s.quasiSameSideWallKicks + 1
            end
        end
        mmx.previousWallYaw = wallYaw
        mmx.lastWallKickPos = {x = m.pos.x, z = m.pos.z}

        if (m.playerIndex == 0) then
            s.just_walljumped = 6
            if (m.input & INPUT_Z_DOWN) ~= 0 then
                s.jump_dash_state = true
            end
        end
        -- m.faceAngle.y = limit_angle(m.faceAngle.y + 0x8000)
        return set_mario_action(m, ACT_WALL_KICK_CUSTOM, 1)
    end

    -- if the next step has the character moved by roughly 9 or 10 units backwards (along x and z), 
    -- the wall slide should be cancelled
    -- see where the diffdist variable is used
    mario_set_forward_vel(m, -10.0)

    m.particleFlags = m.particleFlags | PARTICLE_DUST

    play_sound(SOUND_MOVING_TERRAIN_SLIDE + m.terrainSoundAddend, m.marioObj.header.gfx.cameraToObject)
    
    if perform_air_step(m, 0) == AIR_STEP_LANDED then
        mario_set_forward_vel(m, 0.0)
        return set_mario_action(m, ACT_FREEFALL_LAND_STOP, 0)
    end

    local curPos = {x = m.pos.x, y = 0, z = m.pos.z}
    local prevPos = {x = mmx.prevPos.x, y = 0, z = mmx.prevPos.z}
    local diffdist = calc_abs_dist(curPos, prevPos)

    set_anim_to_frame(m, m.actionTimer)

    if (s.character == 'zero') then
        mmx.zero_cancel_slash = 0
        if (m.input & INPUT_B_PRESSED) ~= 0 and mmx.zero_wall_slide_slash < 3 then
            mmx.zero_cancel_slash = 1
            mmx_play_sound(SOUND_ZERO_SLASH1, m.pos, 0.75)
            if (m.playerIndex == 0) then
                spawn_sync_object(id_bhvSaber, E_MODEL_NONE, m.pos.x, m.pos.y, m.pos.z, function(o)
                    o.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
                    o.oSaberIndex = 8
                end)
            end
            mmx.zero_wall_slide_slash = 10
        end
        if (mmx.zero_wall_slide_slash > 0) then
            smlua_anim_util_set_animation(m.marioObj, "zero_wall_slide_slash")
            set_anim_to_frame(m, 11 - mmx.zero_wall_slide_slash)
            mmx.zero_wall_slide_slash = mmx.zero_wall_slide_slash - 1
        end
    end
    
    if (m.actionTimer < 6) then
        m.actionTimer = m.actionTimer + 1
    end
    if (m.wall == nil or diffdist > 9) and m.actionTimer > 2 then
        mario_set_forward_vel(m, 0.0)
        if (m.playerIndex == 0) then
            if (m.input & INPUT_Z_DOWN) ~= 0 then
                -- This caps the fall hspeed to the same hspeed as if the character jumped from a held dash
                s.jump_dash_state = true
                s.jumped_from_ground_dash = false
            end
        end
        local wallYaw = atan2s(m.wallNormal.z, m.wallNormal.x)
        mmx.previousWallYaw = wallYaw
        mmx.lastWallKickPos = {x = m.pos.x, z = m.pos.z}
        if (m.playerIndex == 0) then
            s.zero_dropped_from_wall = 1
        end
        return set_mario_action(m, ACT_FREEFALL_CUSTOM, 0)
    end

    local stickAngle = m.intendedYaw
    local wallYaw = m.faceAngle.y
    local angleDiff = abs_angle_diff(stickAngle, wallYaw)
    if angleDiff > 32768 then
        angleDiff = 2 * 32768 - angleDiff
    end

    local normalStickMag = m.controller.stickMag / 64

    if (normalStickMag < 0.1 or angleDiff < 21500) and m.actionState == 1 then
        mario_set_forward_vel(m, 0.0)
        m.vel.y = 0
        if (m.playerIndex == 0) then
            if (m.input & INPUT_Z_DOWN) ~= 0 then
                -- This caps the fall hspeed to the same hspeed as if the character jumped from a held dash
                s.jump_dash_state = true
                s.jumped_from_ground_dash = false
            end
        end
        local wallYaw = atan2s(m.wallNormal.z, m.wallNormal.x)
        mmx.previousWallYaw = wallYaw
        mmx.lastWallKickPos = {x = m.pos.x, z = m.pos.z}
        if (m.playerIndex == 0) then
            s.zero_dropped_from_wall = 1
        end
        return set_mario_action(m, ACT_FREEFALL_CUSTOM, 0)
    end

    if m.actionState == 0 and (normalStickMag < 0.1 or angleDiff < 21500) then
        m.actionState = 1
    elseif m.actionState == 1 and not (normalStickMag < 0.1 or angleDiff < 21500) then
        m.actionState = 0
    end

    return 0
end

function act_wall_slide_gravity(m)
    m.vel.y = m.vel.y - 3

    if m.vel.y < -20 then
        m.vel.y = -20
    end
end




--- DASH
function act_dash(m)
    local s = gPlayerSyncTable[m.playerIndex]
    if (m.actionTimer == 0) then
        if (s.character == 'x') then
            mmx_play_sound(SOUND_X_DASH, m.pos, 0.5)
        elseif (s.character == 'zero') then
            mmx_play_sound(SOUND_ZERO_DASH, m.pos, 0.4)
        elseif (s.character == 'vile') then
            mmx_play_sound(SOUND_VILE_DASH, m.pos, 0.5)
        end
    end
    
    if s.character == 'vile' and mario_check_object_grab(m) ~= 0 then
        if m.interactObj.behavior ~= get_behavior_from_id(id_bhvBowser) 
        and (m.interactObj.oInteractionSubtype & INT_SUBTYPE_GRABS_MARIO) == 0 then
            mario_grab_used_object(m)
            play_character_sound(m, CHAR_SOUND_HRMM)
            m.marioBodyState.grabPos = GRAB_POS_LIGHT_OBJ
            mario_set_forward_vel(m, 32.0)
            return set_mario_action(m, ACT_HOLD_IDLE, 0)
        end
    end

    set_character_animation(m, CHAR_ANIM_SINGLE_JUMP)
    if (s.x_shooting == 0 or s.vile_shooting == 0) then
        if (s.character == 'x') then
            smlua_anim_util_set_animation(m.marioObj, "x_dash")
        else
            smlua_anim_util_set_animation(m.marioObj, "zero_dash")
        end
    end
    local mGfx = m.marioObj.header.gfx
    mario_set_forward_vel(m, 57.0)
    local performStep = perform_ground_step(m)
    if performStep == GROUND_STEP_LEFT_GROUND then
        m.vel.y = 0
        set_mario_action(m, ACT_FREEFALL_CUSTOM, 0)
    elseif performStep == GROUND_STEP_NONE then
        align_with_floor(m)
        set_mario_particle_flags(m, PARTICLE_DUST, false)
        if (s.character == 'x') then
            spawn_non_sync_object(id_bhvTrail, E_model_x_animated_alpha, mGfx.pos.x, mGfx.pos.y + 5, mGfx.pos.z, function (obj)
                obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
                obj.oMoveAngleYaw = m.faceAngle.y
                obj.header.gfx.animInfo.curAnim = m.marioObj.header.gfx.animInfo.curAnim
                obj.header.gfx.animInfo.animFrame = m.marioObj.header.gfx.animInfo.animFrame
            end)
        elseif (s.character == 'zero') then
            spawn_non_sync_object(id_bhvTrail, E_model_zero_animated_alpha, mGfx.pos.x, mGfx.pos.y + 5, mGfx.pos.z, function (obj)
                obj.oMoveAngleYaw = m.faceAngle.y
                obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
            end)
        elseif (s.character == 'vile') then
            spawn_non_sync_object(id_bhvTrail, E_model_vile_animated_alpha, mGfx.pos.x , mGfx.pos.y + 5 , mGfx.pos.z , function (obj)
                obj.oMoveAngleYaw = m.faceAngle.y
                obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
                obj.oOwnerChar = 1
            end)
            if (m.actionTimer == 0) then
                spawn_non_sync_object(id_bhvDashFx, E_MODEL_NONE, mGfx.pos.x , mGfx.pos.y + 5 , mGfx.pos.z , function (obj)
                    obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
                    obj.oMoveAngleYaw = m.faceAngle.y
                end)
            end
        end
    --elseif performStep == GROUND_STEP_HIT_WALL then
    --    set_mario_action(m, ACT_WALKING, 0)
    else
        align_with_floor(m)
    end
    if (m.input & INPUT_A_PRESSED) ~= 0 then
        if (m.playerIndex == 0) then
            s.jumped_from_ground_dash = true
            s.jump_dash_state = true
            s.ground_dash_cooldown = 5
        end
        return set_mario_action(m, ACT_JUMP, 0)
    end

    if (m.input & INPUT_B_PRESSED) ~= 0 and s.character == 'zero' and m.actionTimer > 0 then
        return set_mario_action(m, ACT_LIGHT_ZSABER, 0)
    end

    if m.controller.buttonPressed & Y_BUTTON ~= 0 and s.character == 'x' then
        local mmx = gMmxStates[m.playerIndex]
        m.forwardVel = 48
        mmx.execute_punch = true
        set_mario_action(m, ACT_MOVE_PUNCHING, 0)
        mmx.execute_punch = false
        return
    end

    if m.actionTimer >= 13 or ((m.input & INPUT_Z_DOWN) == 0 and m.actionTimer >= 3) then
        if (m.playerIndex == 0) then
            if mario_floor_is_steep(m) ~= 0 then
                s.ground_dash_cooldown = 8
            else
                s.ground_dash_cooldown = 5
            end
        end
        mario_set_forward_vel(m, 32.0)
        return set_mario_action(m, ACT_WALKING, 0)
    end
    m.actionTimer = m.actionTimer + 1

    return 0
end




--- AIR DASH
-- For now, only X uses this action. But it should be a common action to other charcters added in a future update
function act_air_dash(m)
    local s = gPlayerSyncTable[m.playerIndex]
    if (m.actionTimer == 0) then
        if (s.character == 'x') then
            mmx_play_sound(SOUND_X_DASH, m.pos, 0.5)
        elseif (s.character == 'zero') then
            mmx_play_sound(SOUND_ZERO_DASH, m.pos, 0.4)
        end
    end
    local mmx = gMmxStates[m.playerIndex]
    --set_character_animation(m, CHAR_ANIM_SINGLE_JUMP)
    s.already_airdashed = true
    m.marioObj.header.gfx.pos.y = m.pos.y
    local mGfx = m.marioObj.header.gfx
    
    if (s.character == 'x') then
        spawn_non_sync_object(id_bhvTrail, E_model_x_animated_alpha, mGfx.pos.x , mGfx.pos.y + 40 , mGfx.pos.z , function (obj)
            obj.oMoveAngleYaw = m.faceAngle.y
            obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
            obj.header.gfx.animInfo.curAnim = m.marioObj.header.gfx.animInfo.curAnim
            obj.header.gfx.animInfo.animFrame = m.marioObj.header.gfx.animInfo.animFrame
        end)
    elseif (s.character == 'zero') then
        spawn_non_sync_object(id_bhvTrail, E_model_zero_animated_alpha, mGfx.pos.x , mGfx.pos.y + 40 , mGfx.pos.z , function (obj)
            obj.oMoveAngleYaw = m.faceAngle.y
            obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
        end)
    end

    mario_set_forward_vel(m, 57.0)

    if m.actionTimer >= 12 or ((m.input & INPUT_Z_DOWN) == 0 and m.actionTimer >= 3) or
    (mmx.dPrevPos.x == 0 and mmx.dPrevPos.y == 0 and mmx.dPrevPos.z == 0) then
        if not m.wall then
            mario_set_forward_vel(m, 32.0)
        else
            mario_set_forward_vel(m, 0)
        end
        return set_mario_action(m, ACT_FREEFALL_CUSTOM, 0)
    end

    m.marioBodyState.headAngle.z = 0
    m.marioBodyState.headAngle.x = 0
    m.actionTimer = m.actionTimer + 1
    
    m.vel.y = 0

    common_air_action_step_wall(m, ACT_FREEFALL_LAND_STOP, MARIO_ANIM_SLIDEJUMP,
                           AIR_STEP_CHECK_HANG)

    if (s.x_shooting == 0 or s.vile_shooting == 0) and s.character ~= 'none' then
        smlua_anim_util_set_animation(m.marioObj, s.character .. "_dash")
    end

    return false
end


hook_mario_action(ACT_DASH,                         { every_frame = act_dash })
hook_mario_action(ACT_AIR_DASH,                     { every_frame = act_air_dash })
hook_mario_action(ACT_AIR_HIT_WALL_CUSTOM,          { every_frame = act_air_hit_wall_custom })
hook_mario_action(ACT_WALL_SLIDE,                   { every_frame = act_wall_slide, gravity = act_wall_slide_gravity })
hook_mario_action(ACT_WALL_KICK_CUSTOM,             { every_frame = act_wall_kick_custom})
hook_mario_action(ACT_JUMP_CUSTOM,                  { every_frame = act_jump_custom})
hook_mario_action(ACT_FREEFALL_CUSTOM,              { every_frame = act_freefall_custom})
hook_mario_action(ACT_WALKING_CUSTOM,              { every_frame = act_walking_custom})








-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
---- UPDATE LOOP --------------------------------------------------------------
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------

-- Functions

function executeSmoothContinuity(m)
    local mmx = gMmxStates[m.playerIndex]
    m.pos.x = m.pos.x + mmx.dPrevPos.x
    m.pos.y = m.pos.y + mmx.dPrevPos.y
    m.pos.z = m.pos.z + mmx.dPrevPos.z
    m.marioObj.header.gfx.pos.x = m.pos.x
    m.marioObj.header.gfx.pos.y = m.pos.y
    m.marioObj.header.gfx.pos.z = m.pos.z
end

-- Local player

function mmx_update_local_intro_timer(m)
    if (m.action == ACT_INTRO_CUTSCENE) and introTimer < 1195 then
        introTimer = introTimer + 1
    end
end

function mmx_local_update_air(m)
    local s = gPlayerSyncTable[m.playerIndex]
    -- (Automatically synced?)
    if ((m.action == ACT_JUMP_CUSTOM) 
    or (m.action == ACT_ZERO_DOUBLE_JUMP)
    or (m.action == ACT_FREEFALL_CUSTOM) 
    or (m.action == ACT_WALL_KICK_CUSTOM) 
    or (m.action == ACT_TOP_OF_POLE_JUMP)) and s.just_walljumped == 0 then
        m.faceAngle.y = m.intendedYaw
    end

    if (m.action & ACT_FLAG_AIR) == 0 then
        s.firstWallKick = true
        s.quasiSameSideWallKicks = 0
    end
end

function mmx_local_update_walljump(m)
    local s = gPlayerSyncTable[m.playerIndex]
    if s.just_walljumped > 0 then
        s.just_walljumped = s.just_walljumped - 1
        if m.action == ACT_WALL_KICK_CUSTOM and (m.input & INPUT_A_DOWN) == 0 then
            m.forwardVel = 0
            m.vel.y = 0
            s.just_walljumped = 0
        end
    end
end


-- All players

function mmx_resize_char(m, factor)
    if (m.action ~= ACT_SQUISHED) then
        m.marioObj.header.gfx.scale.x = m.marioObj.header.gfx.scale.x * factor
        m.marioObj.header.gfx.scale.y = m.marioObj.header.gfx.scale.y * factor
        m.marioObj.header.gfx.scale.z = m.marioObj.header.gfx.scale.z * factor
    end
end

function mmx_update_props(m)
    local mmx = gMmxStates[m.playerIndex]
    local mGfx = m.marioObj.header.gfx
    local s = gPlayerSyncTable[m.playerIndex]

    if (m.marioBodyState.capState == MARIO_HAS_DEFAULT_CAP_OFF) then
        m.marioBodyState.capState = MARIO_HAS_DEFAULT_CAP_ON
    end

    if mmx.smoothContinuityFlag then
        executeSmoothContinuity(m)
        mmx.smoothContinuityFlag = false
    end

    -- Offset the Y model because X/Zero/Vile is taller than Mario
    m.marioObj.hookRender = true
    if (m.playerIndex == 0) then
        if (m.action ~= ACT_GROUND_POUND
        and m.action ~= ACT_CROUCHING 
        and m.action ~= ACT_START_CRAWLING 
        and m.action ~= ACT_CRAWLING 
        and m.action ~= ACT_STOP_CRAWLING
        and m.action ~= ACT_QUICKSAND_DEATH) then
            mGfx.pos.y = m.pos.y + MODEL_Y_OFFSET
        end
        if (m.action == ACT_CROUCHING) then
            mGfx.pos.y = m.pos.y + MODEL_Y_OFFSET - 10
        end
    end
    
    -- No fall damage
    m.peakHeight = m.pos.y

    -- METAL CAP sets the eye state to 0
    if (m.flags & MARIO_METAL_CAP) ~= 0 then
        m.marioBodyState.eyeState = 1
    end
end

function mmx_update_sleeping(m)
    if (m.action == ACT_SLEEPING or m.action == ACT_START_SLEEPING) then
        set_mario_action(m, ACT_IDLE, 0)
    end
end

function mmx_update_water_jump(m)
    local s = gPlayerSyncTable[m.playerIndex]
    if (m.action == ACT_WATER_JUMP) then
        

        if (s.character == 'zero') then
            smlua_anim_util_set_animation(m.marioObj, "zero_jump")
            if m.vel.y <= -10 then
                smlua_anim_util_set_animation(m.marioObj, "zero_jump_end")
                local velFrame = math_floor((m.vel.y + 10) * 0.33)
                if velFrame < -8 then
                    velFrame = -8
                end
                set_anim_to_frame(m, velFrame * -1 + 1)
                m.marioObj.header.gfx.animInfo.animFrame = velFrame * -1 + 1
            elseif m.vel.y > -10 and m.vel.y <= 0 then
                local velFrame = math_floor(m.vel.y * 0.33)
                if velFrame < -3 then
                    velFrame = -3
                end
                set_anim_to_frame(m, 6 - velFrame)
                m.marioObj.header.gfx.animInfo.animFrame = 6 - velFrame
            elseif m.vel.y > 0 and m.vel.y < 10 then
                local velFrame = math_floor(m.vel.y * 0.5)
                set_anim_to_frame(m, 6 - velFrame)
                m.marioObj.header.gfx.animInfo.animFrame = 6 - velFrame
            else
                smlua_anim_util_set_animation(m.marioObj, "zero_jump_begin")
            end
        else
            mmx_update_shoot_chars_air_anims(m)
        end


        if (m.vel.y <= 1) then
            return set_mario_action(m, ACT_FREEFALL_CUSTOM, 0)
        end
    end
end

local SOFTLOCK_ELIGIBLE = {
    [ACT_SHOCKED] = true,
    [ACT_SOFT_FORWARD_GROUND_KB] = true,
    [ACT_SOFT_BACKWARD_GROUND_KB] = true,
}

function mmx_update_idle(m, shooting)
    local s = gPlayerSyncTable[m.playerIndex]
    local mmx = gMmxStates[m.playerIndex]
    if m.action == ACT_IDLE then
        -- MMX moveset characters don't fall asleep
        m.actionState = 0
        if shooting == 0 and s.character ~= 'none' then
            smlua_anim_util_set_animation(m.marioObj, s.character .. "_idle")
        end
    elseif m.action == ACT_WARP_DOOR_SPAWN or (m.action == ACT_READING_NPC_DIALOG and m.heldObj == nil) or m.action == ACT_READING_SIGN and s.character ~= 'none' then
        smlua_anim_util_set_animation(m.marioObj, s.character .. "_idle")
    elseif SOFTLOCK_ELIGIBLE[m.action] and s.character ~= 'none' then
        local curAnim = smlua_anim_util_get_current_animation_name(m.marioObj)
        if (curAnim == s.character .. "_idle" or curAnim == s.character .. "_idle_shoot") then
            return set_mario_action(m, ACT_IDLE, 0)
        end
    end
end

function mmx_update_walking(m, shooting)
    local mGfx = m.marioObj.header.gfx
    local s = gPlayerSyncTable[m.playerIndex]
    if m.action == ACT_WALKING_CUSTOM or m.action == ACT_WALKING then
        local char_factor = 0.95
        if (s.character == 'vile') then
            if (m.forwardVel > 32) then
                char_factor = m.forwardVel / 32
            end
            char_factor = char_factor * 0.95
        end
        mGfx.animInfo.animAccel = math_floor(mGfx.animInfo.animAccel / 1.7 / char_factor)
        if shooting == 0 then
            --m.marioBodyState.torsoAngle.x = m.marioBodyState.torsoAngle.x / 1.8
            --m.marioBodyState.torsoAngle.z = m.marioBodyState.torsoAngle.z / 1.8
            if (m.marioObj.header.gfx.animInfo.animID == CHAR_ANIM_RUNNING) then
                if s.character == 'zero' then
                    smlua_anim_util_set_animation(m.marioObj, "zero_running")
                elseif s.character ~= 'none' then
                    smlua_anim_util_set_animation(m.marioObj, "x_running")
                end
            elseif smlua_anim_util_get_current_animation_name(m.marioObj) == s.character .. '_running_shoot' then
                set_mario_animation(m, CHAR_ANIM_IDLE_HEAD_RIGHT)
                smlua_anim_util_set_animation(m.marioObj, "x_running")
            end
        end
    end
end

function mmx_update_shoot_chars_air_anims(m)
    local s = gPlayerSyncTable[m.playerIndex]
    local mmx = gMmxStates[m.playerIndex]
    if m.vel.y <= 0 then
        local velFrame = math_floor(-m.vel.y * 0.3)
        if velFrame > 8 then
            velFrame = 8
        end
        set_anim_to_frame(m, velFrame)
        if (s.character == 'x') then
            if (s.x_shooting > 0) then
                if (mmx.x_right_hand_shot == true) then
                    smlua_anim_util_set_animation(m.marioObj, "x_jump_end_right_shoot")
                else
                    smlua_anim_util_set_animation(m.marioObj, "x_jump_end_shoot")
                end
            else
                smlua_anim_util_set_animation(m.marioObj, "x_jump_end")
            end
        elseif (s.character == 'vile') then
            if (s.vile_shooting > 0) then
                smlua_anim_util_set_animation(m.marioObj, "vile_jump_end_shoot")
            else
                smlua_anim_util_set_animation(m.marioObj, "vile_jump_end")
            end
        end
        m.marioObj.header.gfx.animInfo.animFrame = velFrame
    else
        if (s.character == 'x') then
            if (s.x_shooting > 0) then
                if (mmx.x_right_hand_shot == true) then
                    smlua_anim_util_set_animation(m.marioObj, "x_jump_begin_right_shoot")
                else
                    smlua_anim_util_set_animation(m.marioObj, "x_jump_begin_shoot")
                end
            else
                smlua_anim_util_set_animation(m.marioObj, "x_jump_begin")
            end
        elseif (s.character == 'vile') then
            if (s.vile_shooting > 0) then
                smlua_anim_util_set_animation(m.marioObj, "vile_jump_begin_shoot")
            else
                smlua_anim_util_set_animation(m.marioObj, "vile_jump_begin")
            end
        end
    end
end

function mmx_update_jump_fall(m, targetHspeed, targetHspeedDashJump, targetHspeedHoldDashJump, shooting)
    local s = gPlayerSyncTable[m.playerIndex]
    local mmx = gMmxStates[m.playerIndex]
    if (m.action == ACT_JUMP_CUSTOM or m.action == ACT_FREEFALL_CUSTOM or m.action == ACT_STEEP_JUMP 
    or m.action == ACT_TOP_OF_POLE_JUMP or m.action == ACT_ZERO_DOUBLE_JUMP)
    or (m.action == ACT_AIR_SLASH and m.actionTimer > 13) then

        local targetMaxHspeed = targetHspeed
        if s.jump_dash_state then
            if (s.jumped_from_ground_dash) then
                targetMaxHspeed = targetHspeedDashJump
            else
                targetMaxHspeed = targetHspeedHoldDashJump
            end
        end

        if (m.forwardVel >= targetMaxHspeed) then
            targetMaxHspeed = m.forwardVel
        end

        local normalStickMag = m.controller.stickMag / 64
        mario_set_forward_vel(m, targetMaxHspeed * normalStickMag)

        if (m.action ~= ACT_AIR_SLASH) then
            if (s.character == 'zero') then
                if m.action ~= ACT_ZERO_DOUBLE_JUMP then
                    smlua_anim_util_set_animation(m.marioObj, "zero_jump")
                    if m.vel.y <= -10 then
                        smlua_anim_util_set_animation(m.marioObj, "zero_jump_end")
                        local velFrame = math_floor((m.vel.y + 10) * 0.33)
                        if velFrame < -8 then
                            velFrame = -8
                        end
                        set_anim_to_frame(m, velFrame * -1 + 1)
                        m.marioObj.header.gfx.animInfo.animFrame = velFrame * -1 + 1
                    elseif m.vel.y > -10 and m.vel.y <= 0 then
                        local velFrame = math_floor(m.vel.y * 0.33)
                        if velFrame < -3 then
                            velFrame = -3
                        end
                        set_anim_to_frame(m, 6 - velFrame)
                        m.marioObj.header.gfx.animInfo.animFrame = 6 - velFrame
                    elseif m.vel.y > 0 and m.vel.y < 10 then
                        local velFrame = math_floor(m.vel.y * 0.5)
                        set_anim_to_frame(m, 6 - velFrame)
                        m.marioObj.header.gfx.animInfo.animFrame = 6 - velFrame
                    else
                        smlua_anim_util_set_animation(m.marioObj, "zero_jump_begin")
                    end
                end
            else
                mmx_update_shoot_chars_air_anims(m)
            end
        end
    end
end

function mmx_update_butt_slide(m)
    if (m.action & ACT_FLAG_BUTT_OR_STOMACH_SLIDE) ~= 0 then
        m.marioBodyState.torsoAngle.x = 0
        m.marioBodyState.torsoAngle.z = 0
    end
end

function mmx_update_punching(m, shooting)
    local s = gPlayerSyncTable[m.playerIndex]
    local mmx = gMmxStates[m.playerIndex]
    if (m.controller.buttonPressed & Y_BUTTON) ~= 0 and (m.input & INPUT_A_DOWN) == 0 and not (m.action == ACT_PUNCHING or m.action == ACT_MOVE_PUNCHING) then
        if (m.action == ACT_IDLE or m.action == ACT_PANTING) then
            mmx.execute_punch = true
            set_mario_action(m, ACT_PUNCHING, 0)
            mmx.execute_punch = false
        elseif (m.action == ACT_WALKING_CUSTOM or m.action == ACT_DECELERATING 
        or m.action == ACT_BRAKING or m.action == ACT_BRAKING_STOP or m.action == ACT_WALKING) then
            mmx.execute_punch = true
            set_mario_action(m, ACT_MOVE_PUNCHING, 0)
            mmx.execute_punch = false
            return
        end
    end
    if (m.action == ACT_PUNCHING or m.action == ACT_MOVE_PUNCHING) then
        mario_check_object_grab(m)
        if (m.actionArg == 3) then
            set_mario_action(m, ACT_IDLE, 0)
        end
    end
end

function mmx_update_groundpound(m)
    if (m.controller.buttonPressed & Y_BUTTON) ~= 0 and 
    (m.action == ACT_JUMP_CUSTOM or m.action == ACT_FREEFALL_CUSTOM or m.action == ACT_WALL_KICK_CUSTOM or m.action == ACT_FLYING) then
        if m.action == ACT_FLYING and m.playerIndex == 0 then
            set_camera_mode(m.area.camera, m.area.camera.defMode, 1)
        end
        return set_mario_action(m, ACT_GROUND_POUND, 0)
    end
end

function mmx_update_turnaround(m, shooting)
    local s = gPlayerSyncTable[m.playerIndex]
    if (m.action == ACT_TURNING_AROUND) then
        if shooting == 0 then
            smlua_anim_util_set_animation(m.marioObj, "x_turnaround")
            local turningAnimFrame = 6 - math_floor(m.forwardVel / 4.6)
            if turningAnimFrame < 1 then
                turningAnimFrame = 1
            end
            set_anim_to_frame(m, turningAnimFrame)
        end
    end
end

function mmx_update_rollout(m)
    if ((m.action == ACT_BACKWARD_ROLLOUT or m.action == ACT_FORWARD_ROLLOUT) and m.vel.y < 0) then
        return set_mario_action(m, ACT_FREEFALL_CUSTOM, 0)
    end
end

function mmx_update_landing(m, shooting)
    local mGfx = m.marioObj.header.gfx
    local s = gPlayerSyncTable[m.playerIndex]
    local mmx = gMmxStates[m.playerIndex]
    if (m.action == ACT_FREEFALL_LAND_STOP) then
        if shooting == 0 and s.character ~= 'none' then
            smlua_anim_util_set_animation(m.marioObj, s.character .. "_land")
        end
        set_anim_to_frame(m, mmx.land_timer)
        mmx.land_timer = mmx.land_timer + 1
    end
end

function mmx_update_brake_stop(m)
    local s = gPlayerSyncTable[m.playerIndex]
    if (m.action == ACT_BRAKING_STOP) and s.character ~= 'none' then
        smlua_anim_util_set_animation(m.marioObj, s.character .. "_brake_stop")
    end
end

function mmx_update_stop_crouch(m)
    local s = gPlayerSyncTable[m.playerIndex]
    if (m.action == ACT_STOP_CROUCHING) and s.character ~= 'none' then
        smlua_anim_util_set_animation(m.marioObj, s.character .. "_stop_crouch")
    end
end