-----------------------------------------------------------------
----- LOCALIZED FUNCTIONS ---------------------------------------
-----------------------------------------------------------------
local network_send, network_player_set_override_palette_color, network_player_get_palette_color, mmx_update_local_intro_timer,
mmx_update_props, mmx_update_sleeping, mmx_update_idle, mmx_update_walking, mmx_update_jump_fall, mmx_update_landing, mmx_update_brake_stop,
mmx_update_stop_crouch, mmx_update_butt_slide, mmx_update_punching, mmx_update_groundpound, mmx_update_turnaround,
smlua_anim_util_set_animation, mmx_update_water_jump, mmx_resize_char, act_dash, mmx_update_rollout, transition_into_idle_or_walk =
network_send, network_player_set_override_palette_color, network_player_get_palette_color, mmx_update_local_intro_timer,
mmx_update_props, mmx_update_sleeping, mmx_update_idle, mmx_update_walking, mmx_update_jump_fall, mmx_update_landing, mmx_update_brake_stop,
mmx_update_stop_crouch, mmx_update_butt_slide, mmx_update_punching, mmx_update_groundpound, mmx_update_turnaround,
smlua_anim_util_set_animation, mmx_update_water_jump, mmx_resize_char, act_dash, mmx_update_rollout, transition_into_idle_or_walk

---------------------------------------------------------------
--- INIT ------------------------------------------------------
---------------------------------------------------------------
E_model_vile = smlua_model_util_get_id("vile_geo")
E_model_vile_cannon = smlua_model_util_get_id("vile_cannon_geo")
E_model_vile_knee = smlua_model_util_get_id("vile_knee_geo")
E_model_vile_defaulthands = smlua_model_util_get_id("vile_defaulthands_geo")
E_model_vile_animated_alpha = smlua_model_util_get_id("vile_animated_alpha_geo")
local VILE_SHOOT_DURATION = 3
local VILE_WEAK_SHOT_METER = 0.6

---------------------------------------------------------------
--- ACTIONS ---------------------------------------------------
---------------------------------------------------------------

-- DECLARATION
ACT_SHOULDER_CANNON = allocate_mario_action(ACT_GROUP_MOVING | ACT_FLAG_MOVING)
ACT_AIR_SHOULDER_CANNON = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING | ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION)
ACT_LEG_NAPALM = allocate_mario_action(ACT_GROUP_MOVING | ACT_FLAG_MOVING)
ACT_AIR_LEG_NAPALM = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING | ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION)
ACT_VILE_DASH =  allocate_mario_action(ACT_GROUP_MOVING | ACT_FLAG_MOVING | ACT_FLAG_BUTT_OR_STOMACH_SLIDE | ACT_FLAG_SHORT_HITBOX)


local ALLOWED_SHOOT_ACTIONS = {
    [ACT_WALKING_CUSTOM] = true,
    [ACT_WALKING] = true,
    [ACT_IDLE] = true,
    [ACT_VILE_DASH] = true,
    [ACT_DECELERATING] = true,
    [ACT_BRAKING] = true,
    [ACT_BRAKING_STOP] = true,
    [ACT_JUMP_CUSTOM] = true,
    [ACT_FREEFALL_CUSTOM] = true,
    [ACT_FREEFALL_LAND] = true,
    [ACT_FREEFALL_LAND_STOP] = true,
    [ACT_PUNCHING] = true,
    [ACT_MOVE_PUNCHING] = true,
    [ACT_WALL_KICK_CUSTOM] = true,
    [ACT_AIR_HIT_WALL_CUSTOM] = true,
    [ACT_WALL_SLIDE] = true,
    [ACT_WATER_JUMP] = true,
    [ACT_PANTING] = true,
    [ACT_TURNING_AROUND] = true,
}


-- DEFINITION
function act_shoulder_cannon(m)
    local s = gPlayerSyncTable[m.playerIndex]
    local mmx = gPlayerSyncTable[m.playerIndex]
    if (s.enable_model) then
        if (m.actionTimer < 9) then
            if _G.charSelectExists and m.playerIndex == 0 then
                _G.charSelect.character_edit(VILE_CS, nil, nil, nil, nil, E_model_vile_cannon, nil, nil)
            else
                gPlayerSyncTable[m.playerIndex].modelId = E_model_vile_cannon
            end
        else
            if _G.charSelectExists and m.playerIndex == 0 then
                _G.charSelect.character_edit(VILE_CS, nil, nil, nil, nil, E_model_vile, nil, nil)
            else
                gPlayerSyncTable[m.playerIndex].modelId = E_model_vile
            end
        end
    end
    set_mario_animation(m, MARIO_ANIM_IDLE_HEAD_CENTER)
    if (m.actionTimer == 1) then
        math.random()
        local sound_rng = math.random(0, 1)
        if sound_rng == 0 then
            if (enable_sounds) then
                play_character_sound(m, CHAR_SOUND_SNORING2)
            end
        else
            play_mario_action_sound(m, CHAR_SOUND_PUNCH_HOO, 1)
        end
        local mGfx = m.marioObj.header.gfx
        spawn_shot(m, 100, 60, -5000, 2)
    end
    m.actionTimer = m.actionTimer + 1
    smlua_anim_util_set_animation(m.marioObj, "vile_shoulder_cannon")
    set_anim_to_frame(m, m.actionTimer)
    if m.actionTimer == 15 then
        return transition_into_idle_or_walk(m, 43)
    end
    if (m.input & INPUT_OFF_FLOOR) ~= 0 then
        return set_mario_action(m, ACT_FREEFALL_CUSTOM, 0)
    end
    stationary_ground_step(m)
    return false
end

function act_air_shoulder_cannon(m)
    local s = gPlayerSyncTable[m.playerIndex]
    local mmx = gPlayerSyncTable[m.playerIndex]
    if (s.enable_model) then
        if (m.actionTimer < 11) then
            if _G.charSelectExists and m.playerIndex == 0 then
                _G.charSelect.character_edit(VILE_CS, nil, nil, nil, nil, E_model_vile_cannon, nil, nil)
            else
                gPlayerSyncTable[m.playerIndex].modelId = E_model_vile_cannon
            end
        else
            if _G.charSelectExists and m.playerIndex == 0 then
                _G.charSelect.character_edit(VILE_CS, nil, nil, nil, nil, E_model_vile, nil, nil)
            else
                gPlayerSyncTable[m.playerIndex].modelId = E_model_vile
            end
        end
    end
    set_mario_animation(m, MARIO_ANIM_SINGLE_JUMP)
    if (m.actionTimer == 1) then
        math.random()
        local sound_rng = math.random(0, 1)
        if sound_rng == 0 then
            if (enable_sounds) then
                play_character_sound(m, CHAR_SOUND_SNORING2)
            end
        else
            play_mario_action_sound(m, CHAR_SOUND_PUNCH_HOO, 1)
        end
        local mGfx = m.marioObj.header.gfx
        spawn_shot(m, 100, 60, -5000, 2)
    end
    smlua_anim_util_set_animation(m.marioObj, "vile_air_shoulder_cannon")
    set_anim_to_frame(m, m.actionTimer)
    m.actionTimer = m.actionTimer + 1

    m.vel.y = 0
    mario_set_forward_vel(m, 0.0)
    if perform_air_step(m, 0) == AIR_STEP_LANDED then
        if check_fall_damage_or_get_stuck(m, ACT_HARD_BACKWARD_GROUND_KB) == 0 then
            return set_mario_action(m, ACT_FREEFALL_LAND_STOP, 0)
        end
    end
    if m.actionTimer == 15 then
        return set_mario_action(m, ACT_FREEFALL_CUSTOM, 0)
    end
end

function act_leg_napalm(m)
    set_mario_animation(m, MARIO_ANIM_IDLE_HEAD_CENTER)
    if (m.actionTimer == 1) then
        math.random()
        local sound_rng = math.random(0, 1)
        if sound_rng == 0 then
            play_character_sound(m, CHAR_SOUND_PUNCH_WAH)
        else
            if (enable_sounds) then
                play_character_sound(m, CHAR_SOUND_SNORING1)
            end
        end
        spawn_napalm(m, true)
    end
    m.actionTimer = m.actionTimer + 1
    smlua_anim_util_set_animation(m.marioObj, "vile_leg_napalm")
    set_anim_to_frame(m, m.actionTimer)
    if m.actionTimer == 13 then
        return transition_into_idle_or_walk(m, 43)
    end
    if (m.input & INPUT_OFF_FLOOR) ~= 0 then
        return set_mario_action(m, ACT_FREEFALL_CUSTOM, 0)
    end
    stationary_ground_step(m)
    return false
end

function act_air_leg_napalm(m)
    set_mario_animation(m, MARIO_ANIM_SINGLE_JUMP)
    if (m.actionTimer == 1) then
        math.random()
        local sound_rng = math.random(0, 1)
        if sound_rng == 0 then
            play_character_sound(m, CHAR_SOUND_PUNCH_WAH)
        else
            if (enable_sounds) then
                play_character_sound(m, CHAR_SOUND_SNORING1)
            end
        end
        spawn_napalm(m, false)
    end
    smlua_anim_util_set_animation(m.marioObj, "vile_air_leg_napalm")
    set_anim_to_frame(m, m.actionTimer)
    m.actionTimer = m.actionTimer + 1

    m.vel.y = 0
    mario_set_forward_vel(m, 0.0)
    if perform_air_step(m, 0) == AIR_STEP_LANDED then
        if check_fall_damage_or_get_stuck(m, ACT_HARD_BACKWARD_GROUND_KB) == 0 then
            return set_mario_action(m, ACT_FREEFALL_LAND_STOP, 0)
        end
    end
    if m.actionTimer == 13 then
        return set_mario_action(m, ACT_FREEFALL_CUSTOM, 0)
    end
end


-- ACTION HOOKS
hook_mario_action(ACT_SHOULDER_CANNON,                       { every_frame = act_shoulder_cannon})
hook_mario_action(ACT_AIR_SHOULDER_CANNON,                       { every_frame = act_air_shoulder_cannon})
hook_mario_action(ACT_LEG_NAPALM,                       { every_frame = act_leg_napalm})
hook_mario_action(ACT_AIR_LEG_NAPALM,                       { every_frame = act_air_leg_napalm})
hook_mario_action(ACT_VILE_DASH,                       { every_frame = act_dash}, INT_PUNCH)

---------------------------------------------------------------
--- FUNCTIONS -------------------------------------------------
---------------------------------------------------------------

function mmx_vile_apply_colors(m)
    local s = gPlayerSyncTable[m.playerIndex] 
    local colors = {
        -- PANTS
        [0] = {r = 56, g = 72, b = 85},
        -- SHIRT
        [1] = {r = 106, g = 95, b = 190},
        -- GLOVES
        [2] = {r = 255, g = 255, b = 255},
        -- SHOES
        [3] = {r = 50, g = 178, b = 220},
        -- HAIR
        [4] = {r = 111, g = 177, b = 13},
        -- SKIN
        [5] = {r = 255, g = 215, b = 72},
        -- CAP
        [6] = {r = 254, g = 53, b = 43},
        -- EMBLEM
        [7] = {r = 158, g = 181, b = 248}
    }
    for i = 0, PLAYER_PART_MAX - 1 do
        local color = network_player_get_palette_color(gNetworkPlayers[m.playerIndex], i)
        if (s.enable_color and s.enable_model) then
            color = colors[i]
        end
        network_player_set_override_palette_color(gNetworkPlayers[m.playerIndex], i, color)
    end
end

----------------------------------------------------
--- LOOP -------------------------------------------
----------------------------------------------------

local ALLOW_AIR_ATK_FROM = {
    [ACT_JUMP_CUSTOM] = true,
    [ACT_GROUND_POUND] = true,
    [ACT_FREEFALL_CUSTOM] = true,
    [ACT_WATER_JUMP] = true,
    [ACT_WALL_KICK_CUSTOM] = true,
    [ACT_WALL_SLIDE] = true,
}

function vile_update_local(m)
    local s = gPlayerSyncTable[m.playerIndex]

    --- INTRO ----------------------------------------------
    mmx_update_local_intro_timer(m)

    --- AIR ------------------------------------------------
    mmx_local_update_air(m)

    --- WALL JUMPING ---------------------------------------
    mmx_local_update_walljump(m)

    --- NO DASH --------------------------------------------
    s.jump_dash_state = false
    s.jumped_from_ground_dash = false

    --------------------------------------------------------
    --- SHOOTING -------------------------------------------
    --------------------------------------------------------

    if s.vile_shooting > 0 then
        s.vile_shooting = s.vile_shooting - 1
    end
    if (m.controller.buttonDown & B_BUTTON) ~= 0 and ALLOWED_SHOOT_ACTIONS[m.action] 
    and s.vile_shooting == 0 and s.vile_meter >= VILE_WEAK_SHOT_METER and s.menu_open == false then
        s.vile_shooting = VILE_SHOOT_DURATION
    end

    --------------------------------------------------------
    --- METER ----------------------------------------------
    --------------------------------------------------------
    s.vile_meter = s.vile_meter + 0.1
    if (s.vile_meter >= 10) then
        s.vile_meter = 10
    end
    if (s.vile_meter <= 0) then
        s.vile_meter = 0
    end

end

local DEFAULTHANDS_TABLE = DEFAULTHANDS_TABLE
local GROUND_ACTIONS_TABLE = GROUND_ACTIONS_TABLE
local GROUND_HOLD_ACTIONS_TABLE = GROUND_HOLD_ACTIONS_TABLE

local SHOOT_CANCEL_ACTIONS = {
    [ACT_FREEFALL_LAND] = true,
    [ACT_FREEFALL_LAND_STOP] = true,
    [ACT_MOVE_PUNCHING] = true,
    [ACT_PUNCHING] = true
}

function vile_update_all(m)
    local s = gPlayerSyncTable[m.playerIndex]
    local mmx = gMmxStates[m.playerIndex]
    local mGfx = m.marioObj.header.gfx
    local animFrame = mGfx.animInfo.animFrame

    if (s.enable_model) then
        if (m.action == ACT_LEG_NAPALM or m.action == ACT_AIR_LEG_NAPALM) then
            if _G.charSelectExists and m.playerIndex == 0 then
                _G.charSelect.character_edit(VILE_CS, nil, nil, nil, nil, E_model_vile_knee, nil, nil)
            else
                gPlayerSyncTable[m.playerIndex].modelId = E_model_vile_knee
            end
        elseif ((m.action & ACT_FLAG_SWIMMING_OR_FLYING) ~= 0 or DEFAULTHANDS_TABLE[m.action]) then
            if _G.charSelectExists and m.playerIndex == 0 then
                _G.charSelect.character_edit(VILE_CS, nil, nil, nil, nil, E_model_vile_defaulthands, nil, nil)
            else
                gPlayerSyncTable[m.playerIndex].modelId = E_model_vile_defaulthands
            end
            gPlayerSyncTable[m.playerIndex].modelId = E_model_vile_defaulthands
        elseif (m.action ~= ACT_SHOULDER_CANNON and m.action ~= ACT_AIR_SHOULDER_CANNON) then
            if _G.charSelectExists and m.playerIndex == 0 then
                _G.charSelect.character_edit(VILE_CS, nil, nil, nil, nil, E_model_vile, nil, nil)
            else
                gPlayerSyncTable[m.playerIndex].modelId = E_model_vile
            end   
        end
    end

    --------------------------------------------------------
    --- GENERAL --------------------------------------------
    --------------------------------------------------------

    mmx_update_props(m)
    mmx_resize_char(m, 0.99)

    --------------------------------------------------------
    --- IDLE -----------------------------------------------
    --------------------------------------------------------
    
    mmx_update_sleeping(m)
    mmx_update_idle(m, s.vile_shooting)

    --------------------------------------------------------
    --- WATER JUMP -----------------------------------------
    --------------------------------------------------------
    
    mmx_update_water_jump(m)

    --------------------------------------------------------
    --- WALKING --------------------------------------------
    --------------------------------------------------------

    mmx_update_walking(m, s.vile_shooting)

    --------------------------------------------------------
    --- JUMPING AND FALLING --------------------------------
    --------------------------------------------------------

    mmx_update_jump_fall(m, 43, 58, 49, s.vile_shooting)

    --------------------------------------------------------
    --- COLOR ----------------------------------------------
    --------------------------------------------------------

    mmx_vile_apply_colors(m)

    --------------------------------------------------------
    --- SHOULDER CANNON ------------------------------------
    --------------------------------------------------------
    if (m.controller.buttonPressed & X_BUTTON) ~= 0 and (GROUND_ACTIONS_TABLE[m.action] or m.action == ACT_WALKING_CUSTOM) 
    and s.vile_meter >= 4 then
        if (m.playerIndex == 0) then
            s.vile_meter = s.vile_meter - 4
        end
        set_mario_action(m, ACT_SHOULDER_CANNON, 0)
    end

    --------------------------------------------------------
    --- AIR SHOULDER CANNON --------------------------------
    --------------------------------------------------------

    if (m.controller.buttonPressed & X_BUTTON) ~= 0 and ALLOW_AIR_ATK_FROM[m.action] and
    ((s.vile_meter >= 4 and m.action ~= ACT_GROUND_POUND) or (s.vile_meter >= 7 and m.action == ACT_GROUND_POUND)) then
        if m.action == ACT_GROUND_POUND then
            s.vile_meter = s.vile_meter - 7
        else
            s.vile_meter = s.vile_meter - 4
        end
        m.faceAngle.y = m.intendedYaw
        set_mario_action(m, ACT_AIR_SHOULDER_CANNON, 0)
    end

    --------------------------------------------------------
    --- LEG NAPALM -----------------------------------------
    --------------------------------------------------------
    if (m.controller.buttonPressed & Y_BUTTON) ~= 0 and (GROUND_ACTIONS_TABLE[m.action] or m.action == ACT_WALKING_CUSTOM) 
    and s.vile_meter >= 4 then
        if (m.playerIndex == 0) then
            s.vile_meter = s.vile_meter - 4
        end
        set_mario_action(m, ACT_LEG_NAPALM, 0)
    end

    --------------------------------------------------------
    --- AIR LEG NAPALM -------------------------------------
    --------------------------------------------------------
    if (m.controller.buttonPressed & Y_BUTTON) ~= 0 and ALLOW_AIR_ATK_FROM[m.action] and 
    ((s.vile_meter >= 4 and m.action ~= ACT_GROUND_POUND) or (s.vile_meter >= 7 and m.action == ACT_GROUND_POUND)) then
        if (m.playerIndex == 0) then
            if m.action == ACT_GROUND_POUND then
                s.vile_meter = s.vile_meter - 7
            else
                s.vile_meter = s.vile_meter - 4
            end
        end
        m.faceAngle.y = m.intendedYaw
        set_mario_action(m, ACT_AIR_LEG_NAPALM, 0)
    end

    --------------------------------------------------------
    --- DASH ATTACK ----------------------------------------
    --------------------------------------------------------
    if ((m.input & INPUT_Z_PRESSED) ~= 0) and 
    (GROUND_ACTIONS_TABLE[m.action] or m.action == ACT_RIDING_SHELL_GROUND or GROUND_HOLD_ACTIONS_TABLE[m.action] or m.action == ACT_WALKING_CUSTOM)
    and s.vile_meter >= 3 then
        if (m.playerIndex == 0) then
            s.vile_meter = s.vile_meter - 3
        end
        m.faceAngle.y = m.intendedYaw
        set_anim_to_frame(m, 0)
        set_mario_action(m, ACT_VILE_DASH, 0)
    end

    --------------------------------------------------------
    --- LANDING --------------------------------------------
    --------------------------------------------------------

    mmx_update_landing(m, s.vile_shooting)

    --------------------------------------------------------
    --- BRAKE STOP -----------------------------------------
    --------------------------------------------------------

    mmx_update_brake_stop(m)

    --------------------------------------------------------
    --- STOP CROUCH ----------------------------------------
    --------------------------------------------------------

    mmx_update_stop_crouch(m)

    --------------------------------------------------------
    --- BUTT SLIDE -----------------------------------------
    --------------------------------------------------------

    mmx_update_butt_slide(m)

    --------------------------------------------------------
    --SHOOTING----------------------------------------------
    --------------------------------------------------------
    if s.vile_shooting > 0 then
        if (m.action == ACT_BRAKING or m.action == ACT_BRAKING_STOP or SHOOT_CANCEL_ACTIONS[m.action]) then
            if m.input & INPUT_NONZERO_ANALOG ~= 0 then
                set_mario_action(m, ACT_WALKING_CUSTOM, 0)
            else
                set_mario_action(m, ACT_IDLE, 0)
            end
        end
        if (m.action == ACT_JUMP_CUSTOM 
        or m.action == ACT_FREEFALL_CUSTOM 
        or m.action == ACT_WATER_JUMP or m.action == ACT_WALL_KICK_CUSTOM) then
            if (s.enable_model) then
                m.marioBodyState.handState = MARIO_HAND_PEACE_SIGN
            end
            if s.vile_shooting == VILE_SHOOT_DURATION then
                if (m.playerIndex == 0) then
                    s.vile_meter = s.vile_meter - VILE_WEAK_SHOT_METER
                end
                spawn_shot(m, 75, 60, -5000, 0)
            end
        elseif (m.action == ACT_VILE_DASH) then
            if (s.enable_model) then
                m.marioBodyState.handState = MARIO_HAND_OPEN
            end
            smlua_anim_util_set_animation(m.marioObj, "vile_dash_shoot")
            if s.vile_shooting == VILE_SHOOT_DURATION then
                if (m.playerIndex == 0) then
                    s.vile_meter = s.vile_meter - VILE_WEAK_SHOT_METER
                end
                spawn_shot(m, 20, 120, 1800, 0) 
            end
        elseif (m.action == ACT_WALL_SLIDE or m.action == ACT_AIR_HIT_WALL_CUSTOM) then
            if (s.enable_model) then
                m.marioBodyState.handState = MARIO_HAND_OPEN
            end
            smlua_anim_util_set_animation(m.marioObj, "vile_wall_slide_shoot")
            if s.vile_shooting == VILE_SHOOT_DURATION then
                if (m.playerIndex == 0) then
                    s.vile_meter = s.vile_meter - VILE_WEAK_SHOT_METER
                end
                spawn_shot(m, 70, 85, 3000, 0)                     
            end
        elseif (m.action == ACT_WALKING_CUSTOM or m.action == ACT_DECELERATING) then
            mGfx.angle.x = 0
            m.marioBodyState.torsoAngle.x = 0
            m.marioBodyState.torsoAngle.z = 0
            if (s.enable_model) then
                m.marioBodyState.handState = MARIO_HAND_PEACE_SIGN
            end
            smlua_anim_util_set_animation(m.marioObj, "vile_running_shoot")
            if s.vile_shooting == VILE_SHOOT_DURATION then
                if (m.playerIndex == 0) then
                    s.vile_meter = s.vile_meter - VILE_WEAK_SHOT_METER
                end
                spawn_shot(m, 75, 90, -2000, 0)
            end
        elseif (m.action == ACT_IDLE or m.action == ACT_PANTING) then
            set_character_animation(m, CHAR_ANIM_IDLE_HEAD_CENTER)
            if (s.enable_model) then
                m.marioBodyState.handState = MARIO_HAND_PEACE_SIGN
            end
            smlua_anim_util_set_animation(m.marioObj, "vile_idle_shoot")
            if s.vile_shooting == VILE_SHOOT_DURATION then
                set_anim_to_frame(m, 1)
                if (m.playerIndex == 0) then
                    s.vile_meter = s.vile_meter - VILE_WEAK_SHOT_METER
                end
                spawn_shot(m, 75, 90, -2000, 0)
            end
        end
    end

    --------------------------------------------------------
    --GROUND POUND------------------------------------------
    --------------------------------------------------------

    if (m.input & INPUT_Z_PRESSED) ~= 0 and 
    (m.action == ACT_JUMP_CUSTOM or m.action == ACT_FREEFALL_CUSTOM or m.action == ACT_WALL_KICK_CUSTOM or m.action == ACT_FLYING) then
        if m.action == ACT_FLYING and m.playerIndex == 0 then
            set_camera_mode(m.area.camera, m.area.camera.defMode, 1)
        end
        return set_mario_action(m, ACT_GROUND_POUND, 0)
    end

    --------------------------------------------------------
    --GROUND TURNAROUND-------------------------------------
    --------------------------------------------------------
    
    mmx_update_turnaround(m, s.vile_shooting)

    --------------------------------------------------------
    --ROLLOUT-----------------------------------------------
    --------------------------------------------------------
    mmx_update_rollout(m)
end
