-----------------------------------------------------------------
----- LOCALIZED FUNCTIONS ---------------------------------------
-----------------------------------------------------------------
local network_send, network_player_set_override_palette_color, network_player_get_palette_color, mmx_update_local_intro_timer,
mmx_update_props, mmx_update_sleeping, mmx_update_idle, mmx_update_walking, mmx_update_jump_fall, mmx_update_landing, mmx_update_brake_stop,
mmx_update_stop_crouch, mmx_update_butt_slide, mmx_update_punching, mmx_update_groundpound, mmx_update_turnaround, smlua_anim_util_set_animation,
mmx_play_sound, mmx_update_water_jump, mmx_resize_char, mmx_update_rollout, transition_into_idle_or_walk =
network_send, network_player_set_override_palette_color, network_player_get_palette_color, mmx_update_local_intro_timer,
mmx_update_props, mmx_update_sleeping, mmx_update_idle, mmx_update_walking, mmx_update_jump_fall, mmx_update_landing, mmx_update_brake_stop,
mmx_update_stop_crouch, mmx_update_butt_slide, mmx_update_punching, mmx_update_groundpound, mmx_update_turnaround, smlua_anim_util_set_animation,
mmx_play_sound, mmx_update_water_jump, mmx_resize_char, mmx_update_rollout, transition_into_idle_or_walk

---------------------------------------------------------------
--- INIT ------------------------------------------------------
---------------------------------------------------------------
E_model_x = smlua_model_util_get_id("x_geo")
E_model_x_defaulthands = smlua_model_util_get_id("x_defaulthands_geo")
E_model_x_alpha_jump = smlua_model_util_get_id("x_alpha_jump_geo")
E_model_x_alpha_gp = smlua_model_util_get_id("x_alpha_gp_geo")
E_model_x_alpha_dash = smlua_model_util_get_id("x_alpha_dash_geo")

E_model_x_animated_alpha = smlua_model_util_get_id("x_animated_alpha_geo")

E_model_x_lightarmor = smlua_model_util_get_id("x_lightarmor_geo")
E_model_x_lightarmor_defaulthands = smlua_model_util_get_id("x_lightarmor_defaulthands_geo")

E_model_x_gigaarmor = smlua_model_util_get_id("x_gigaarmor_geo")

local X_SHOOT_IASA = 13
local X_SHOOT_DURATION = 13

local X_BUSTER_RIGHT = 3
local X_BUSTER_LEFT = 4

---------------------------------------------------------------
--- ACTIONS ---------------------------------------------------
---------------------------------------------------------------

-- DECLARATION
ACT_DOUBLESHOT = allocate_mario_action(ACT_GROUP_MOVING | ACT_FLAG_MOVING)
ACT_VAD_UP = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING | ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION | ACT_FLAG_CONTROL_JUMP_HEIGHT)


local ALLOWED_SHOOT_ACTIONS = {
    [ACT_WALKING_CUSTOM] = true,
    [ACT_WALKING] = true,
    [ACT_IDLE] = true,
    [ACT_DASH] = true,
    [ACT_AIR_DASH] = true,
    [ACT_DECELERATING] = true,
    [ACT_BRAKING] = true,
    [ACT_BRAKING_STOP] = true,
    [ACT_JUMP_CUSTOM] = true,
    [ACT_FREEFALL_CUSTOM] = true,
    [ACT_FREEFALL_LAND] = true,
    [ACT_FREEFALL_LAND_STOP] = true,
    [ACT_PUNCHING] = true,
    [ACT_MOVE_PUNCHING] = true,
    [ACT_WALL_KICK_CUSTOM] = true,
    [ACT_AIR_HIT_WALL_CUSTOM] = true,
    [ACT_WALL_SLIDE] = true,
    [ACT_WATER_JUMP] = true,
    [ACT_PANTING] = true,
    [ACT_TURNING_AROUND] = true,
}

local GROUND_ACTIONS_TABLE = GROUND_ACTIONS_TABLE
local GROUND_HOLD_ACTIONS_TABLE = GROUND_HOLD_ACTIONS_TABLE

-- DEFINITION
function act_doubleshot(m)
    local s = gPlayerSyncTable[m.playerIndex]
    local mmx = gPlayerSyncTable[m.playerIndex]
    if m.actionArg > 1 and m.actionTimer == 0 then
        if m.playerIndex == 0 then
            s.x_shooting = 0
        end
        m.actionTimer = 4
    end
    if m.actionTimer == 0 then
        if m.playerIndex == 0 then
            s.x_shooting = 0
            s.x_charge_timer = 0
            s.x_charge_level = 0
        end
        mmx.x_gigaarmor_holding = 0
        audio_sample_stop(SOUND_X_GIGA_CHARGE_HOLD)
        mmx.x_right_hand_shot = false
        if m.playerIndex == 0 then
            if m.actionArg == 0 then
                s.x_doubleshot = 1
            else
                s.x_doubleshot = 0
            end
        end
    end
    set_mario_animation(m, MARIO_ANIM_IDLE_HEAD_CENTER)
    if (m.actionTimer == 1) then
        local mGfx = m.marioObj.header.gfx
        spawn_shot(m, 80, 60, -4000 + m.actionArg * 8000, 2 + m.actionArg * 2)
    end
    m.actionTimer = m.actionTimer + 1
    if m.actionArg % 2 == 0 then
        m.marioBodyState.handState = X_BUSTER_RIGHT
        smlua_anim_util_set_animation(m.marioObj, "x_doubleshot1")
    else
        m.marioBodyState.handState = X_BUSTER_LEFT
        smlua_anim_util_set_animation(m.marioObj, "x_doubleshot2")
    end
    set_anim_to_frame(m, m.actionTimer)
    if m.actionArg % 2 == 0 then
        if (m.input & INPUT_B_PRESSED) ~= 0 then
            if m.actionTimer > 1 and m.actionState == 0 then
                m.actionState = 1
            end
        end
        if m.actionTimer > 7 and m.actionState == 1 then
            return set_mario_action(m, ACT_DOUBLESHOT, 1)
        end
    end
    if (m.actionTimer == 12 and m.actionArg % 2 == 0) or (m.actionTimer == 13 and m.actionArg % 2 == 1) then
        if m.actionArg < 2 then
            mmx.x_gigaarmor_holding = 11
        end
        return transition_into_idle_or_walk(m, 32)
    end
    if (m.input & INPUT_OFF_FLOOR) ~= 0 then
        return set_mario_action(m, ACT_FREEFALL_CUSTOM, 0)
    end
    stationary_ground_step(m)
    return false
end

function act_vad_up(m)
    if (m.actionTimer == 1) then
        mario_set_forward_vel(m, m.forwardVel / 2)
    end
    smlua_anim_util_set_animation(m.marioObj, "x_vad_up")
    set_anim_to_frame(m, m.actionTimer)
    m.actionTimer = m.actionTimer + 1
    if m.actionTimer <= 10 then
        m.vel.y = 4
        if perform_air_step(m, 0) == AIR_STEP_LANDED then
            mario_set_forward_vel(m, 0.0)
            if check_fall_damage_or_get_stuck(m, ACT_HARD_BACKWARD_GROUND_KB) == 0 then
                return set_mario_action(m, ACT_FREEFALL_LAND_STOP, 0)
            end
        end
    else
        if m.actionTimer == 11 then
            m.vel.y = 44
        end
        if (m.vel.y > 0) then
            common_air_action_step_no_wall(m, ACT_FREEFALL_LAND_STOP, MARIO_ANIM_SINGLE_JUMP, AIR_STEP_CHECK_HANG, 0)
        else
            common_air_action_step_wall(m, ACT_FREEFALL_LAND_STOP, MARIO_ANIM_SINGLE_JUMP, AIR_STEP_CHECK_HANG)
        end
        if (m.actionTimer > 23 or ((m.input & INPUT_A_DOWN) == 0 and m.actionTimer > 17)) then
            return set_mario_action(m, ACT_FREEFALL_CUSTOM, 0)
        end
    end
end


-- ACTION HOOKS
hook_mario_action(ACT_DOUBLESHOT,                   { every_frame = act_doubleshot})
hook_mario_action(ACT_VAD_UP,                       { every_frame = act_vad_up})

---------------------------------------------------------------
--- FUNCTIONS -------------------------------------------------
---------------------------------------------------------------

function mmx_x_play_charge_sound(m, sound, level, intensity)
    if m.playerIndex == 0 then
        mmx_play_sound(sound, m.pos, intensity)
        network_send(true, { type = 'charge_sound',
            m = gNetworkPlayers[m.playerIndex].globalIndex, 
            chargeLevel = level,
            intensity = intensity,
        })
    end
end

function mmx_x_on_area_change()
    local m = gMarioStates[0]
    local s = gPlayerSyncTable[m.playerIndex]
    if (m.playerIndex == 0) then
        if (s.x_charge_spawned > 0) then
            s.x_charge_spawned = s.x_charge_spawned - 1
        end
    end
end

hook_event(HOOK_ON_LEVEL_INIT, mmx_x_on_area_change)
hook_event(HOOK_ON_WARP, mmx_x_on_area_change)

function mmx_x_apply_colors(m)
    local s = gPlayerSyncTable[m.playerIndex]
    local x_defaultcolors = {
        -- PANTS
        [0] = {r = 114, g = 215, b = 238},
        -- SHIRT
        [1] = {r = 0, g = 123, b = 210},
        -- GLOVES
        [2] = {r = 255, g = 255, b = 255},
        -- SHOES
        [3] = {r = 255, g = 39, b = 31},
        -- HAIR
        [4] = {r = 113, g = 113, b = 113},
        -- SKIN
        [5] = {r = 255, g = 255, b = 255},
        -- CAP
        [6] = {r = 158, g = 181, b = 248},
        -- EMBLEM
        [7] = {r = 255, g = 39, b = 31},
    }
    local x_lightarmor_defaultcolors = {
        -- PANTS
        [0] = {r = 121, g = 209, b = 227},
        -- SHIRT
        [1] = {r = 255, g = 255, b = 255},
        -- GLOVES
        [2] = {r = 0, g = 122, b = 183},
        -- SHOES
        [3] = {r = 255, g = 39, b = 31},
        -- HAIR
        [4] = {r = 70, g = 70, b = 70},
        -- SKIN
        [5] = {r = 255, g = 255, b = 255},
        -- CAP
        [6] = {r = 228, g = 177, b = 53},
        -- EMBLEM
        [7] = {r = 255, g = 39, b = 31},
    }
    local x_gigaarmor_defaultcolors = {
        -- PANTS
        [0] = {r = 121, g = 209, b = 227},
        -- SHIRT
        [1] = {r = 255, g = 255, b = 255},
        -- GLOVES
        [2] = {r = 255, g = 39, b = 31},
        -- SHOES
        [3] = {r = 228, g = 177, b = 53},
        -- HAIR
        [4] = {r = 70, g = 70, b = 70},
        -- SKIN
        [5] = {r = 255, g = 255, b = 255},
        -- CAP
        [6] = {r = 30, g = 220, b = 30},
        -- EMBLEM
        [7] = {r = 0, g = 122, b = 183},
    }
    local colors = x_defaultcolors
    if (s.x_armor == 1) then
        colors = x_lightarmor_defaultcolors
    elseif (s.x_armor == 2) then
        colors = x_gigaarmor_defaultcolors
    end
    if s.x_glow_index >= 2 and (s.x_charge_timer >= 105 or s.x_armor == 2 and s.x_doubleshot == 1 
    and (m.action ~= ACT_DOUBLESHOT or m.actionArg > 1)) then
        for i = 0, PLAYER_PART_MAX - 1 do
            local color = network_player_get_palette_color(gNetworkPlayers[m.playerIndex], i)
            if (s.enable_color and s.enable_model) then
                color = colors[i]
            end
            color.r = color.r + 140
            if color.r > 255 then
                color.r = 255
            end
            m.marioBodyState.shadeR = 215
            m.marioBodyState.lightR = 255
            m.marioBodyState.shadeG = 100
            m.marioBodyState.lightG = 100
            m.marioBodyState.shadeB = 100
            m.marioBodyState.lightB = 100
            network_player_set_override_palette_color(gNetworkPlayers[m.playerIndex], i, color)
        end
    elseif s.x_glow_index >= 2 and s.x_charge_timer > 64 and s.x_charge_timer < 105 then
        for i = 0, PLAYER_PART_MAX - 1 do
            local color = network_player_get_palette_color(gNetworkPlayers[m.playerIndex], i)
            if (s.enable_color and s.enable_model) then
                color = colors[i]
            end
            color.g = color.g + 90
            color.r = color.r + 90
            if color.g > 255 then
                color.g = 255
            end
            if color.r > 255 then
                color.r = 255
            end
            m.marioBodyState.shadeR = 200
            m.marioBodyState.lightR = 255
            m.marioBodyState.shadeG = 200
            m.marioBodyState.lightG = 255
            m.marioBodyState.shadeB = 100
            m.marioBodyState.lightB = 100
            network_player_set_override_palette_color(gNetworkPlayers[m.playerIndex], i, color)
        end
    elseif s.x_glow_index >= 2 and s.x_charge_timer > 10 and s.x_charge_timer <= 64 then
        for i = 0, PLAYER_PART_MAX - 1 do
            local color = network_player_get_palette_color(gNetworkPlayers[m.playerIndex], i)
            if (s.enable_color and s.enable_model) then
                color = colors[i]
            end
            color.b = color.b + 140
            if color.b > 255 then
                color.b = 255
            end
            m.marioBodyState.shadeR = 100
            m.marioBodyState.lightR = 100
            m.marioBodyState.shadeG = 100
            m.marioBodyState.lightG = 100
            m.marioBodyState.shadeB = 215
            m.marioBodyState.lightB = 255
            network_player_set_override_palette_color(gNetworkPlayers[m.playerIndex], i, color)
        end
    else
        for i = 0, PLAYER_PART_MAX - 1 do
            local color = network_player_get_palette_color(gNetworkPlayers[m.playerIndex], i)
            if (s.enable_color and s.enable_model) then
                color = colors[i]
            end
            m.marioBodyState.shadeR = 127
            m.marioBodyState.lightR = 255
            m.marioBodyState.shadeG = 127
            m.marioBodyState.lightG = 255
            m.marioBodyState.shadeB = 127
            m.marioBodyState.lightB = 255
            network_player_set_override_palette_color(gNetworkPlayers[m.playerIndex], i, color)
        end
    end
end

---------------------------------------------------------------
--- LOOP ------------------------------------------------------
---------------------------------------------------------------


-- For the current player
function x_update_local(m)
    local s = gPlayerSyncTable[m.playerIndex]

    --- INTRO ----------------------------------------------
    mmx_update_local_intro_timer(m)

    --- CHARGING X-BUSTER ----------------------------------
    s.x_glow_index = s.x_glow_index + 1
    
    if s.x_glow_index == 4 then
        s.x_glow_index = 0
    end

    -- Holding to charge, releasing to reset
    s.x_charge_level = 0
    if (m.controller.buttonDown & B_BUTTON) ~= 0 and s.menu_open == false and s.x_doubleshot == 0 then
        s.x_charge_timer = s.x_charge_timer + 1
    elseif s.x_charge_timer > 0 then
        if (ALLOWED_SHOOT_ACTIONS[m.action]) then
            if s.x_charge_timer > 20 and s.x_charge_timer < 66 then
                s.x_shooting = X_SHOOT_DURATION + 1
                s.x_charge_level = 1
            elseif s.x_charge_timer >= 66 and s.x_charge_timer < 105 then
                s.x_shooting = X_SHOOT_DURATION + 1
                s.x_charge_level = 2
            elseif s.x_charge_timer >= 105 then 
                if (s.x_armor == 2) and (GROUND_ACTIONS_TABLE[m.action] or m.action == ACT_WALKING_CUSTOM or m.action == ACT_DASH) then
                    s.x_charge_level = 0
                    s.x_shooting = 0
                    set_mario_action(m, ACT_DOUBLESHOT, 0)
                else
                    s.x_shooting = X_SHOOT_DURATION + 1    
                    s.x_charge_level = 3    
                end
            end
        end
        s.x_charge_spawned = 0
        s.x_max_charge_looped = 0
        s.x_charge_timer = 0
    end

    --- AIR ------------------------------------------------
    mmx_local_update_air(m)

    --- WALL JUMPING ---------------------------------------
    mmx_local_update_walljump(m)

    --- DASHING --------------------------------------------
    if s.ground_dash_cooldown > 0 then
        s.ground_dash_cooldown = s.ground_dash_cooldown - 1
    end

    --- AIR DASHING ----------------------------------------
    if ((m.action & ACT_FLAG_AIR) == 0 or m.action == ACT_BUTT_SLIDE_AIR) and m.action ~= ACT_DASH then
        
        s.jump_dash_state = false
        s.already_airdashed = false
        s.jumped_from_ground_dash = false
        
        -- If holding Z on ground without dashing and then jumping, jump_dash_state will be set
        -- needs to be tested though
        if (m.input & INPUT_Z_DOWN) ~= 0 then
            s.jump_dash_state = true
        end
    end

    --------------------------------------------------------
    --- SHOOTING -------------------------------------------
    --------------------------------------------------------

    if s.x_shooting > 0 then
        s.x_shooting = s.x_shooting - 1
    end
    if (m.input & INPUT_B_PRESSED) ~= 0 and s.x_shooting < X_SHOOT_IASA and s.x_active_shots < 5 then
        if (s.x_armor == 2) and (GROUND_ACTIONS_TABLE[m.action] or m.action == ACT_WALKING_CUSTOM or m.action == ACT_DASH) 
        and s.x_doubleshot == 1 then
            return set_mario_action(m, ACT_DOUBLESHOT, 1)
        elseif m.action ~= ACT_DOUBLESHOT and ALLOWED_SHOOT_ACTIONS[m.action] then
            s.x_shooting = X_SHOOT_DURATION 
        end
    end

end

local DEFAULTHANDS_TABLE = DEFAULTHANDS_TABLE

local SHOOT_CANCEL_ACTIONS = {
    [ACT_FREEFALL_LAND] = true,
    [ACT_FREEFALL_LAND_STOP] = true,
    [ACT_MOVE_PUNCHING] = true,
    [ACT_PUNCHING] = true
}

-- For all players
function x_update_all(m)
    local s = gPlayerSyncTable[m.playerIndex]
    local mmx = gMmxStates[m.playerIndex]
    local mGfx = m.marioObj.header.gfx
    local animFrame = mGfx.animInfo.animFrame

    if (s.enable_model) then
        if (s.x_armor == 0) then
            if not _G.charSelectExists then
                gPlayerSyncTable[m.playerIndex].modelId = E_model_x
            end
        elseif (s.x_armor == 1) then
            if not _G.charSelectExists then
                gPlayerSyncTable[m.playerIndex].modelId = E_model_x_lightarmor
            end
        elseif (s.x_armor == 2) then
            if not _G.charSelectExists then
                gPlayerSyncTable[m.playerIndex].modelId = E_model_x_gigaarmor
            end
        end
    end

    --------------------------------------------------------
    --- GENERAL --------------------------------------------
    --------------------------------------------------------

    mmx_update_props(m)
    mmx_resize_char(m, 0.95)

    --------------------------------------------------------
    --- IDLE -----------------------------------------------
    --------------------------------------------------------
    
    mmx_update_sleeping(m)
    mmx_update_idle(m, s.x_shooting)

    --------------------------------------------------------
    --- WATER JUMP -----------------------------------------
    --------------------------------------------------------
    
    mmx_update_water_jump(m)

    --------------------------------------------------------
    --- WALKING --------------------------------------------
    --------------------------------------------------------

    mmx_update_walking(m, s.x_shooting)

    --------------------------------------------------------
    --- JUMPING AND FALLING --------------------------------
    --------------------------------------------------------

    mmx_update_jump_fall(m, 32, 50, 46, s.x_shooting)

    --------------------------------------------------------
    --- CHARGING X-BUSTER ----------------------------------
    --------------------------------------------------------

    mmx_x_apply_colors(m)
    if (s.x_charge_timer == 9) then
        mmx.x_charge_sound_stopped = false
        --mmx_play_sound(SOUND_X_CHARGE_BEGIN, m.pos, 0.6)
        mmx_x_play_charge_sound(m, SOUND_X_CHARGE_BEGIN, 1, 0.6)
        --spawn_non_sync_object(id_bhvChargePre, E_model_charge_pre, mGfx.pos.x, mGfx.pos.y + 80, mGfx.pos.z, function (obj)
        --    obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
        --end)
        if (s.x_charge_spawned < 1) then
            if (m.playerIndex == 0) then
                s.x_charge_spawned = 1
                spawn_charge(m, 1)
                network_send(true, { type = 'charge',
                    m = gNetworkPlayers[m.playerIndex].globalIndex, 
                    chargeLevel = 1
                })
            end
        end
    elseif (s.x_charge_timer == 67) then
        if (s.x_charge_spawned < 2) then
            if (m.playerIndex == 0) then
                s.x_charge_spawned = 2
                spawn_charge(m, 2)
                network_send(true, { type = 'charge',
                    m = gNetworkPlayers[m.playerIndex].globalIndex, 
                    chargeLevel = 2
                })
            end
        end
        mmx.x_charge_sound_stopped = false
        mmx_x_play_charge_sound(m, SOUND_X_CHARGE_LOOP, 2, 0.6)
        --mmx_play_sound(SOUND_X_CHARGE_LOOP, m.pos, 0.6)
    elseif (s.x_charge_timer == 106) then
        mmx.x_charge_sound_stopped = false
        if (s.x_max_charge_looped == 0) then
            mmx_x_play_charge_sound(m, SOUND_X_CHARGE_MAX_BEGIN, 3, 0.6)
            --mmx_play_sound(SOUND_X_CHARGE_MAX_BEGIN, m.pos, 0.6)
        else
            mmx_x_play_charge_sound(m, SOUND_X_CHARGE_MAX_LOOP, 4, 0.6)
            --mmx_play_sound(SOUND_X_CHARGE_MAX_LOOP, m.pos, 0.6)
        end
        if (s.x_charge_spawned < 3) then
            if (m.playerIndex == 0) then
                s.x_charge_spawned = 3
                spawn_charge(m, 3)
                network_send(true, { type = 'charge',
                    m = gNetworkPlayers[m.playerIndex].globalIndex, 
                    chargeLevel = 3
                })
            end
        end
    end

     -- Jump to the looping point
    if (s.x_armor == 0) then
        if (s.x_charge_timer == 89) then
            s.x_charge_timer = 66
        end 
    elseif (s.x_armor == 1 or s.x_armor == 2) then
        if (s.x_charge_timer == 127 and s.x_max_charge_looped == 0) then
            s.x_max_charge_looped = 1
            s.x_charge_timer = 105
        elseif (s.x_charge_timer == 116 and (s.x_max_charge_looped == 1 or s.x_charge_spawned < 3)) then
            s.x_charge_timer = 105
        elseif (s.x_charge_timer == 90) then
            mmx_x_play_charge_sound(m, SOUND_X_CHARGE_LOOP, 2, 0.6)
        end
    end

    if (s.x_charge_timer == 0) then
        if (mmx.x_charge_sound_stopped == false) then
            audio_sample_stop(SOUND_X_CHARGE_BEGIN)
            audio_sample_stop(SOUND_X_CHARGE_LOOP)
            audio_sample_stop(SOUND_X_CHARGE_MAX_BEGIN)
            audio_sample_stop(SOUND_X_CHARGE_MAX_LOOP)
            mmx.x_charge_sound_stopped = true
        end
    end

    if (s.x_doubleshot == 1 and (m.action ~= ACT_DOUBLESHOT or m.actionArg > 1)) then
        s.x_charge_timer = 0
        s.x_charge_level = 0
        mmx.x_gigaarmor_holding = mmx.x_gigaarmor_holding + 1
        --djui_chat_message_create(tostring(mmx.x_gigaarmor_holding))
        if (mmx.x_gigaarmor_holding == 12) then
            mmx_x_play_charge_sound(m, SOUND_X_GIGA_CHARGE_HOLD, 5, 0.6)
            --mmx_play_sound(SOUND_X_GIGA_CHARGE_HOLD, m.pos, 0.6)
            mmx.x_gigaarmor_holding = 0
        end
    end

    --------------------------------------------------------
    --- DASHING --------------------------------------------
    --------------------------------------------------------
    if ((m.input & INPUT_Z_PRESSED) ~= 0)
    and (GROUND_ACTIONS_TABLE[m.action] or m.action == ACT_RIDING_SHELL_GROUND or GROUND_HOLD_ACTIONS_TABLE[m.action] or m.action == ACT_WALKING_CUSTOM) 
    and s.ground_dash_cooldown == 0
        then
        m.faceAngle.y = m.intendedYaw
        set_anim_to_frame(m, 0)
        set_mario_action(m, ACT_DASH, 0)
    end

    --------------------------------------------------------
    --- AIR DASHING ----------------------------------------
    --------------------------------------------------------
    if (m.input & INPUT_Z_PRESSED) ~= 0 and (m.action ~= ACT_BUBBLED) and ((m.action == ACT_JUMP_CUSTOM 
    or m.action == ACT_FREEFALL_CUSTOM 
    or m.action == ACT_WATER_JUMP))
    and s.jump_dash_state == false and s.already_airdashed == false then
        m.vel.y = 0
        m.faceAngle.y = m.intendedYaw
        set_anim_to_frame(m, 0)
        set_mario_action(m, ACT_AIR_DASH, 0)
    end

    -- Trail spawning
    if (s.jump_dash_state == true) then
        if (m.action == ACT_FREEFALL_CUSTOM or m.action == ACT_JUMP_CUSTOM 
        or m.action == ACT_WALL_KICK_CUSTOM or m.action == ACT_WATER_JUMP) then
            spawn_non_sync_object(id_bhvTrail, E_model_x_animated_alpha, mGfx.pos.x , mGfx.pos.y , mGfx.pos.z , function (obj)
                obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
                obj.oMoveAngleYaw = m.faceAngle.y
                obj.header.gfx.animInfo.curAnim = m.marioObj.header.gfx.animInfo.curAnim
                obj.header.gfx.animInfo.animFrame = m.marioObj.header.gfx.animInfo.animFrame
            end)
        end
    elseif (s.already_airdashed == true) then
        if (m.action == ACT_FREEFALL_CUSTOM or m.action == ACT_JUMP_CUSTOM) then
            spawn_non_sync_object(id_bhvTrail, E_model_x_animated_alpha, mGfx.pos.x , mGfx.pos.y , mGfx.pos.z , function (obj)
                obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
                obj.oMoveAngleYaw = m.faceAngle.y
                obj.header.gfx.animInfo.curAnim = m.marioObj.header.gfx.animInfo.curAnim
                obj.header.gfx.animInfo.animFrame = m.marioObj.header.gfx.animInfo.animFrame
            end)
        end
    end

    --------------------------------------------------------
    --- LANDING --------------------------------------------
    --------------------------------------------------------

    mmx_update_landing(m, s.x_shooting)

    --------------------------------------------------------
    --- BRAKE STOP -----------------------------------------
    --------------------------------------------------------

    mmx_update_brake_stop(m)

    --------------------------------------------------------
    --- STOP CROUCH ----------------------------------------
    --------------------------------------------------------

    mmx_update_stop_crouch(m)

    --------------------------------------------------------
    --- BUTT SLIDE -----------------------------------------
    --------------------------------------------------------

    mmx_update_butt_slide(m)

    --------------------------------------------------------
    --SHOOTING----------------------------------------------
    --------------------------------------------------------


    -- This code really needs refactoring. Just trying to finish the update at this point. maybe in 1.3
    if s.x_shooting > 0 then
        if (m.action == ACT_FREEFALL_LAND_STOP or m.action == ACT_FREEFALL_LAND) then
            if (s.x_armor == 2 and s.x_doubleshot == 1) then
                if s.x_shooting < 5 and m.playerIndex == 0 then
                    s.x_shooting = 0
                    return
                else
                    return set_mario_action(m, ACT_DOUBLESHOT, 2)
                end
            end
        end
        if (m.action == ACT_BRAKING or m.action == ACT_BRAKING_STOP or SHOOT_CANCEL_ACTIONS[m.action]) then
            if m.input & INPUT_NONZERO_ANALOG ~= 0 then
                set_mario_action(m, ACT_WALKING_CUSTOM, 0)
            else
                set_mario_action(m, ACT_IDLE, 0)
            end
        end
        if (m.action == ACT_JUMP_CUSTOM 
        or m.action == ACT_FREEFALL_CUSTOM 
        or m.action == ACT_WATER_JUMP or m.action == ACT_WALL_KICK_CUSTOM) then
            local mmx = gMmxStates[m.playerIndex]
            if (s.x_armor == 2 and mmx.x_right_hand_shot == true) then
                m.marioBodyState.handState = X_BUSTER_RIGHT
            else
                m.marioBodyState.handState = X_BUSTER_LEFT
            end
            if s.x_shooting == X_SHOOT_DURATION then

                if (s.x_armor == 2 and s.x_charge_level == 3) then
                    mmx.x_right_hand_shot = true
                    if m.playerIndex == 0 then
                        s.x_charge_level = 2
                        s.x_doubleshot = 1
                    end
                    m.marioBodyState.handState = X_BUSTER_RIGHT
                elseif (s.x_armor == 2 and s.x_charge_level < 3 and s.x_doubleshot == 0) then
                    mmx.x_right_hand_shot = false
                elseif (s.x_armor == 2 and s.x_doubleshot == 1) then
                    mmx.x_right_hand_shot = false
                    if m.playerIndex == 0 then
                        s.x_charge_level = 4
                        s.x_doubleshot = 0
                    end
                end

                if (mmx.x_right_hand_shot == true) then
                    spawn_shot(m, 75, 90, -5000, s.x_charge_level)
                else
                    spawn_shot(m, 75, 90, 2000, s.x_charge_level)
                end     
                if (m.playerIndex == 0) then
                    s.x_charge_level = 0
                end
            end
        elseif (m.action == ACT_DASH) then
            if (s.enable_model) then
                m.marioBodyState.handState = X_BUSTER_LEFT
            end
            smlua_anim_util_set_animation(m.marioObj, "x_dash_shoot")
            if s.x_shooting == X_SHOOT_DURATION then
                spawn_shot(m, 20, 120, 1800, s.x_charge_level)
                if (m.playerIndex == 0) then
                    s.x_charge_level = 0
                end
            end
        elseif (m.action == ACT_AIR_DASH) then
            if (s.enable_model) then
                m.marioBodyState.handState = X_BUSTER_LEFT
            end
            smlua_anim_util_set_animation(m.marioObj, "x_dash_shoot")
            if s.x_shooting == X_SHOOT_DURATION then
                if (s.x_armor == 2 and (s.x_doubleshot == 1 or s.x_charge_level == 3 )) then
                    if (s.x_armor == 2 and s.x_charge_level == 3) then
                        s.x_charge_level = 2
                        s.x_doubleshot = 1
                        m.marioBodyState.handState = X_BUSTER_RIGHT
                    elseif (s.x_armor == 2 and s.x_doubleshot == 1) then
                        s.x_charge_level = 4
                        s.x_doubleshot = 0
                    end
                end
                spawn_shot(m, 55, 120, 1800, s.x_charge_level)
                if (m.playerIndex == 0) then
                    s.x_charge_level = 0
                end
            end
        elseif (m.action == ACT_WALL_SLIDE or m.action == ACT_AIR_HIT_WALL_CUSTOM) then

            if (s.enable_model) then
                m.marioBodyState.handState = X_BUSTER_LEFT
            end
            smlua_anim_util_set_animation(m.marioObj, "x_wall_slide_shoot")
            if s.x_shooting == X_SHOOT_DURATION then

                if (s.x_armor == 2 and (s.x_doubleshot == 1 or s.x_charge_level == 3 )) then
                    if (s.x_armor == 2 and s.x_charge_level == 3) then
                        s.x_charge_level = 2
                        s.x_doubleshot = 1
                        m.marioBodyState.handState = X_BUSTER_RIGHT
                    elseif (s.x_armor == 2 and s.x_doubleshot == 1) then
                        s.x_charge_level = 4
                        s.x_doubleshot = 0
                    end
                end

                spawn_shot(m, 80, 85, 3000, s.x_charge_level)                     
                if (m.playerIndex == 0) then
                    s.x_charge_level = 0
                end
            end
            
        elseif (m.action == ACT_WALKING_CUSTOM or m.action == ACT_DECELERATING or m.action == ACT_WALKING) then
            mGfx.angle.x = 0
            if (s.enable_model) then
                m.marioBodyState.handState = X_BUSTER_LEFT
            end
            smlua_anim_util_set_animation(m.marioObj, "x_running_shoot")
            if s.x_shooting == X_SHOOT_DURATION then
                spawn_shot(m, 75, 90, 2000, s.x_charge_level)
                if (m.playerIndex == 0) then
                    s.x_charge_level = 0
                end
            end
        elseif (m.action == ACT_IDLE or m.action == ACT_PANTING) then
            set_character_animation(m, CHAR_ANIM_IDLE_HEAD_CENTER)
            set_anim_to_frame(m, 11 - s.x_shooting)
            if (s.enable_model) then
                m.marioBodyState.handState = 4
            end
            smlua_anim_util_set_animation(m.marioObj, "x_idle_shoot")
            if s.x_shooting == X_SHOOT_DURATION then
                set_anim_to_frame(m, 1)
                spawn_shot(m, 75, 90, 1200, s.x_charge_level)
                if (m.playerIndex == 0) then
                    s.x_charge_level = 0
                end
            end
        end
    end

    --------------------------------------------------------
    --PUNCHING----------------------------------------------
    --------------------------------------------------------

    mmx_update_punching(m, s.x_shooting)

    --------------------------------------------------------
    --GROUND POUND------------------------------------------
    --------------------------------------------------------

    mmx_update_groundpound(m)

    --------------------------------------------------------
    --GROUND TURNAROUND-------------------------------------
    --------------------------------------------------------
    
    mmx_update_turnaround(m, s.x_shooting)

    --------------------------------------------------------
    --ROLLOUT-----------------------------------------------
    --------------------------------------------------------
    mmx_update_rollout(m)
end