-----------------------------------------------------------------
----- LOCALIZED FUNCTIONS ---------------------------------------
-----------------------------------------------------------------
local obj_set_model_extended, network_send, network_player_set_override_palette_color, network_player_get_palette_color, mmx_update_local_intro_timer,
mmx_update_props, mmx_update_sleeping, mmx_update_idle, mmx_update_walking, mmx_update_jump_fall, mmx_update_landing, mmx_update_brake_stop,
mmx_update_stop_crouch, mmx_update_butt_slide, mmx_update_punching, mmx_update_groundpound, mmx_update_turnaround,
smlua_anim_util_set_animation, mmx_update_water_jump, mmx_resize_char, mmx_play_sound, vec3f_copy, check_any_input, check_any_button,
abs_angle_diff, atan2s, mmx_update_rollout, transition_into_idle_or_walk =
obj_set_model_extended, network_send, network_player_set_override_palette_color, network_player_get_palette_color, mmx_update_local_intro_timer,
mmx_update_props, mmx_update_sleeping, mmx_update_idle, mmx_update_walking, mmx_update_jump_fall, mmx_update_landing, mmx_update_brake_stop,
mmx_update_stop_crouch, mmx_update_butt_slide, mmx_update_punching, mmx_update_groundpound, mmx_update_turnaround,
smlua_anim_util_set_animation, mmx_update_water_jump, mmx_resize_char, mmx_play_sound, vec3f_copy, check_any_input, check_any_button,
abs_angle_diff, atan2s, mmx_update_rollout, transition_into_idle_or_walk

---------------------------------------------------------------
--- INIT ------------------------------------------------------
---------------------------------------------------------------
E_model_zero = smlua_model_util_get_id("zero_geo")
E_model_zero_handle = smlua_model_util_get_id("zero_handle_geo")
E_model_zero_noanim = smlua_model_util_get_id("zero_noanim_geo")
E_model_zero_alpha_dash = smlua_model_util_get_id("zero_alpha_dash_geo")
-- mid
E_model_zero_alpha_jump = smlua_model_util_get_id("zero_alpha_jump_geo")
-- rise
E_model_zero_alpha_jump1 = smlua_model_util_get_id("zero_alpha_jump1_geo")
-- descent
E_model_zero_animated_alpha = smlua_model_util_get_id("zero_animated_alpha_geo")
E_model_zero_dash_fx = smlua_model_util_get_id("zero_dash_fx_geo")

ZERO_MAXAIRSPEED_NODASH = 32
ZERO_MAXAIRSPEED_HOLDDASHJUMP = 46
ZERO_MAXAIRSPEED_DASHJUMP = 50

---------------------------------------------------------------
--- ACTIONS ---------------------------------------------------
---------------------------------------------------------------

-- DECLARATION
ACT_LIGHT_ZSABER = allocate_mario_action(ACT_GROUP_MOVING | ACT_FLAG_MOVING)
ACT_MEDIUM_ZSABER = allocate_mario_action(ACT_GROUP_MOVING | ACT_FLAG_MOVING)
ACT_HEAVY_ZSABER = allocate_mario_action(ACT_GROUP_MOVING | ACT_FLAG_MOVING)
ACT_AIR_SLASH = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING | ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION | ACT_FLAG_CONTROL_JUMP_HEIGHT)
ACT_AIR_SLASH_LAND = allocate_mario_action(ACT_GROUP_MOVING | ACT_FLAG_MOVING)
ACT_RYUENJIN_START = allocate_mario_action(ACT_GROUP_MOVING | ACT_FLAG_MOVING)
ACT_RYUENJIN = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING | ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION)
ACT_RYUENJIN_END = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING | ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION)
ACT_HYOURETSUZAN = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING | ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION)
ACT_SHIPPUGA = allocate_mario_action(ACT_GROUP_MOVING | ACT_FLAG_MOVING | ACT_FLAG_BUTT_OR_STOMACH_SLIDE)
ACT_SENTSUIZAN = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING | ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION)
ACT_KUENZAN = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING | ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION | ACT_FLAG_CONTROL_JUMP_HEIGHT)
ACT_RAIKOUSEN = allocate_mario_action(ACT_GROUP_MOVING | ACT_FLAG_MOVING | ACT_FLAG_BUTT_OR_STOMACH_SLIDE)
ACT_ZERO_DOUBLE_JUMP = allocate_mario_action(ACT_GROUP_AIRBORNE | ACT_FLAG_AIR | ACT_FLAG_MOVING | ACT_FLAG_ALLOW_VERTICAL_WIND_ACTION | ACT_FLAG_CONTROL_JUMP_HEIGHT)
ACT_ZERO_SPECIAL_LAND = allocate_mario_action(ACT_GROUP_MOVING | ACT_FLAG_MOVING)

-- DEFINITION
function act_zero_double_jump(m)
    local s = gPlayerSyncTable[m.playerIndex]
    if (not m) then
        return 0
    end

    if m.actionTimer == 0 then
        if (m.playerIndex == 0) then
            s.zero_double_jump = 1
        end
        mmx_play_sound(SOUND_ZERO_JUMP, m.pos, 0.6)
    end

    set_character_animation(m, CHAR_ANIM_SINGLE_JUMP)
    smlua_anim_util_set_animation(m.marioObj, "zero_double_jump")

    if (m.vel.y >= 0) then
        common_air_action_step_no_wall(m, ACT_FREEFALL_LAND_STOP, MARIO_ANIM_SINGLE_JUMP, AIR_STEP_CHECK_HANG, 0)
    else
        common_air_action_step_wall(m, ACT_FREEFALL_LAND_STOP, MARIO_ANIM_SINGLE_JUMP, AIR_STEP_CHECK_HANG)
    end
    set_anim_to_frame(m, m.actionTimer)
    if m.actionTimer < 20 then
        m.actionTimer = m.actionTimer + 1
    end
    return false
end

function act_light_zsaber(m)
    set_mario_animation(m, MARIO_ANIM_IDLE_HEAD_CENTER)
    
    
    if (m.actionTimer == 0) then
        play_character_sound(m, CHAR_SOUND_PUNCH_YAH)
        mmx_play_sound(SOUND_ZERO_SLASH1, m.pos, 0.75)
        if (m.playerIndex == 0) then
            spawn_sync_object(id_bhvSaber, E_MODEL_NONE, m.pos.x, m.pos.y, m.pos.z, function(o)
                o.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
                o.oSaberIndex = 1
            end)
        end
    end
    m.actionTimer = m.actionTimer + 1
    smlua_anim_util_set_animation(m.marioObj, "zero_slash1")
    set_anim_to_frame(m, m.actionTimer)
    
    if (m.actionTimer > 0 and (m.input & INPUT_Z_PRESSED) ~= 0) then
        set_anim_to_frame(m, 0)
        return set_mario_action(m, ACT_DASH, 0)
    end
    if (m.actionTimer > 6 and ((m.input & INPUT_B_PRESSED) ~= 0 or m.actionState == 1)) then
        set_anim_to_frame(m, 0)
        play_character_sound(m, CHAR_SOUND_PUNCH_WAH)
        return set_mario_action(m, ACT_MEDIUM_ZSABER, 0)
    elseif (m.actionTimer >= 5 and (m.input & INPUT_B_PRESSED) ~= 0) then
        m.actionState = 1
    end
    if (m.actionTimer == 14) or (m.actionTimer > 10 and check_any_input(m) == true) then
        return transition_into_idle_or_walk(m, 32)
    end
    if (m.input & INPUT_OFF_FLOOR) ~= 0 then
        return set_mario_action(m, ACT_FREEFALL_CUSTOM, 0)
    end

    if (m.input & INPUT_A_PRESSED) ~= 0 then
        return set_mario_action(m, ACT_JUMP, 0)
    end
    if (m.controller.buttonPressed & X_BUTTON) ~= 0 then
        return set_mario_action(m, ACT_RYUENJIN_START, 0)
    end
    stationary_ground_step(m)
    return false
end

function act_medium_zsaber(m)
    set_mario_animation(m, MARIO_ANIM_IDLE_HEAD_CENTER)
    smlua_anim_util_set_animation(m.marioObj, "zero_slash2")
    set_anim_to_frame(m, m.actionTimer)
    if (m.input & INPUT_OFF_FLOOR) ~= 0 then
        return set_mario_action(m, ACT_FREEFALL_CUSTOM, 0)
    end
    if (m.input & INPUT_A_PRESSED) ~= 0 then
        return set_mario_action(m, ACT_JUMP, 0)
    end
    if (m.controller.buttonPressed & X_BUTTON) ~= 0 then
        return set_mario_action(m, ACT_RYUENJIN_START, 0)
    end
    stationary_ground_step(m)
    if (m.actionTimer == 0) then
        mmx_play_sound(SOUND_ZERO_SLASH2, m.pos, 0.75)
        if (m.playerIndex == 0) then
            spawn_sync_object(id_bhvSaber, E_MODEL_NONE, m.pos.x, m.pos.y, m.pos.z, function(o)
                o.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
                o.oSaberIndex = 2
            end)
        end
    end
    m.actionTimer = m.actionTimer + 1
    local mGfx = m.marioObj.header.gfx
    if (m.actionTimer > 0 and (m.input & INPUT_Z_PRESSED) ~= 0) then
        set_anim_to_frame(m, 0)
        return set_mario_action(m, ACT_DASH, 0)
    end
    if (m.actionTimer > 6 and ((m.input & INPUT_B_PRESSED) ~= 0 or m.actionState == 1)) then
        set_anim_to_frame(m, 0)
        play_mario_action_sound(m, CHAR_SOUND_PUNCH_HOO, 1)
        return set_mario_action(m, ACT_HEAVY_ZSABER, 0)
    elseif (m.actionTimer >= 5 and (m.input & INPUT_B_PRESSED) ~= 0) then
        m.actionState = 1
    end
    if (m.actionTimer == 13) then
        return transition_into_idle_or_walk(m, 32)
    end
    return false
end

function act_heavy_zsaber(m)
    set_mario_animation(m, MARIO_ANIM_IDLE_HEAD_CENTER)
    smlua_anim_util_set_animation(m.marioObj, "zero_slash3")
    set_anim_to_frame(m, m.actionTimer)
    if (m.input & INPUT_OFF_FLOOR) ~= 0 then
        return set_mario_action(m, ACT_FREEFALL_CUSTOM, 0)
    end
    stationary_ground_step(m)
    if (m.actionTimer == 1) then
        mmx_play_sound(SOUND_ZERO_SLASH3, m.pos, 0.75)
        if (m.playerIndex == 0) then
            spawn_sync_object(id_bhvSaber, E_MODEL_NONE, m.pos.x, m.pos.y, m.pos.z, function(o)
                o.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
                o.oSaberIndex = 3
            end)
        end
    end
    m.actionTimer = m.actionTimer + 1
    if (m.actionTimer == 17) or (m.actionTimer > 13 and check_any_input(m) == true) then
        return transition_into_idle_or_walk(m, 32)
    end
    return false
end

function zero_air_atk_exit_velocity(m)
    local s = gPlayerSyncTable[m.playerIndex]
    local targetMaxHspeed = ZERO_MAXAIRSPEED_NODASH
    if s.jump_dash_state then
        if (s.jumped_from_ground_dash) then
            targetMaxHspeed = ZERO_MAXAIRSPEED_DASHJUMP
        else
            targetMaxHspeed = ZERO_MAXAIRSPEED_HOLDDASHJUMP
        end
    end

    if m.forwardVel > targetMaxHspeed then
        targetMaxHspeed = m.forwardVel
    end

    return (m.intendedMag / 32) * targetMaxHspeed
end

function act_air_slash(m)
    local mmx = gMmxStates[m.playerIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    if (not m) then
        return 0
    end

    if mmx.zero_cancel_slash == 1 then
        mmx.zero_cancel_slash = 0
    end
    if (m.actionTimer == 0) then
        m.actionTimer = m.actionArg
        mmx_play_sound(SOUND_ZERO_SLASH1, m.pos, 0.75)
        mmx.zero_cancel_slash = 1
    end

    if (m.actionTimer == 1) then
        if (m.playerIndex == 0) then
            spawn_sync_object(id_bhvSaber, E_MODEL_NONE, m.pos.x, m.pos.y, m.pos.z, function(o)
                o.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
                o.oSaberIndex = 4
            end)
        end
    end

    --set_character_animation(m, CHAR_ANIM_SINGLE_JUMP)
    smlua_anim_util_set_animation(m.marioObj, "zero_air_slash")
    m.actionTimer = m.actionTimer + 1
    set_anim_to_frame(m, m.actionTimer)
    if (m.actionTimer == 16) then
        return set_mario_action(m, ACT_FREEFALL_CUSTOM, 0)
    end
    if (m.actionState == 1 or (m.input & INPUT_B_PRESSED) ~= 0) and m.actionTimer >= 7 + m.actionArg then
        --local intendedDYaw = m.intendedYaw - m.faceAngle.y
        --if m.actionTimer > 10 or coss(intendedDYaw) > 0.4 then
        if m.actionTimer > 10 then
            m.forwardVel = zero_air_atk_exit_velocity(m)
            m.faceAngle.y = m.intendedYaw
            if m.forwardVel < 0 then
                m.forwardVel = 0
            end
        end
        return set_mario_action(m, ACT_AIR_SLASH, 1)
    end
    if (m.input & INPUT_B_PRESSED) ~= 0 and (m.actionTimer < 7 + m.actionArg and m.actionTimer >= 5 + m.actionArg) then
        m.actionState = 1
    end

    if (m.actionTimer > 10) then
        if (m.actionState == 2 or (m.input & INPUT_Z_PRESSED) ~= 0)
         and s.jump_dash_state == false and s.already_airdashed == false then
            set_anim_to_frame(m, 0)
            m.faceAngle.y = m.intendedYaw
            if m.forwardVel < 0 then
                m.forwardVel = 0
            end
            return set_mario_action(m, ACT_AIR_DASH, 0)
        elseif m.actionState == 3 or (m.controller.buttonPressed & X_BUTTON) ~= 0 then
            m.forwardVel = zero_air_atk_exit_velocity(m)
            m.faceAngle.y = m.intendedYaw
            if m.forwardVel < 0 then
                m.forwardVel = 0
            end
            return set_mario_action(m, ACT_HYOURETSUZAN, 0)
        elseif m.actionState == 4 or (m.controller.buttonPressed & Y_BUTTON) ~= 0 then
            m.faceAngle.y = m.intendedYaw
            if m.forwardVel < 0 then
                m.forwardVel = 0
            end
            return set_mario_action(m, ACT_KUENZAN, 0)
        elseif (m.actionState == 5 or (m.input & INPUT_A_PRESSED) ~= 0) and 
        s.zero_double_jump == 0 and s.already_airdashed == false and s.jump_dash_state == false then
            m.vel.y = 30
            return set_mario_action(m, ACT_ZERO_DOUBLE_JUMP, 0)
        end
    elseif (m.actionTimer > 8) then
        if (m.controller.buttonPressed & Y_BUTTON) ~= 0 then
            m.actionState = 4
        elseif (m.controller.buttonPressed & X_BUTTON) ~= 0 then
            m.actionState = 3
        elseif (m.input & INPUT_Z_PRESSED) ~= 0 then
            m.actionState = 2
        elseif (m.input & INPUT_A_PRESSED) ~= 0 then
            m.actionState = 5
        end
    end
    
    if (m.actionTimer < 11) then
        common_air_action_step_no_wall(m, ACT_AIR_SLASH_LAND, MARIO_ANIM_SINGLE_JUMP, AIR_STEP_CHECK_HANG, m.actionTimer - 1 - m.actionArg)
    else
        if (m.actionTimer > 12) then
            m.faceAngle.y = m.intendedYaw
            if m.forwardVel < 0 then
                m.forwardVel = -m.forwardVel
            end
        end
        common_air_action_step_no_wall(m, ACT_FREEFALL_LAND_STOP, MARIO_ANIM_SINGLE_JUMP, AIR_STEP_CHECK_HANG, 0)
    end
    
    return false
end

function act_air_slash_land(m)
    local mmx = gMmxStates[m.playerIndex]
    --set_character_animation(m, CHAR_ANIM_FIRST_PUNCH)
    smlua_anim_util_set_animation(m.marioObj, "zero_air_slash_land")
    if (m.input & INPUT_OFF_FLOOR) ~= 0 then
        return set_mario_action(m, ACT_FREEFALL_CUSTOM, 0)
    end
    if (m.input & INPUT_A_PRESSED) ~= 0 then
        return set_mario_action(m, ACT_JUMP, 0)
    end
    if (m.controller.buttonPressed & X_BUTTON) ~= 0 then
        return set_mario_action(m, ACT_RYUENJIN_START, 0)
    end
    stationary_ground_step(m)
    if (m.actionTimer == 0) then
        mmx_play_sound(SOUND_ZERO_LAND, m.pos, 0.4)
        m.actionTimer = m.actionArg
        if (m.actionArg == 0) then
            mmx.zero_cancel_slash = 0
            if (m.playerIndex == 0) then
                spawn_sync_object(id_bhvSaber, E_MODEL_NONE, m.pos.x, m.pos.y, m.pos.z, function(o)
                    o.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
                    o.oSaberIndex = 4
                end)
            end
        end
    end
    m.actionTimer = m.actionTimer + 1
    local mGfx = m.marioObj.header.gfx
    set_anim_to_frame(m, m.actionTimer)
    if (m.actionTimer > 0 and (m.input & INPUT_Z_PRESSED) ~= 0) then
        set_anim_to_frame(m, 0)
        return set_mario_action(m, ACT_DASH, 0)
    end
    if (m.actionTimer > 7 and (m.input & INPUT_B_PRESSED) ~= 0) then
        set_anim_to_frame(m, 0)
        return set_mario_action(m, ACT_LIGHT_ZSABER, 0)
    end
    if (m.actionTimer >= 17) or (m.actionTimer >= 12 and check_any_input(m) == true) then
        return transition_into_idle_or_walk(m, 32)
    end
    return false
end

function act_ryuenjin_start(m)
    set_character_animation(m, CHAR_ANIM_FIRST_PUNCH)
    smlua_anim_util_set_animation(m.marioObj, "zero_ryuenjin_start")
    m.actionTimer = m.actionTimer + 1
    local timerFrame = m.actionTimer
    if (m.actionTimer >= 3) then
        timerFrame = timerFrame + 1
    end
    local mGfx = m.marioObj.header.gfx
    set_anim_to_frame(m, timerFrame)
    if (m.actionTimer == 4) then
        m.vel.y = 95
        mario_set_forward_vel(m, 60)
        mmx_play_sound(SOUND_ZERO_RYUENJIN, m.pos, 0.75)
        if (m.playerIndex == 0) then
            spawn_sync_object(id_bhvSaber, E_MODEL_NONE, m.pos.x, m.pos.y, m.pos.z, function(o)
                o.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
                o.oSaberIndex = 10
            end)
        end
        m.marioObj.oIntangibleTimer = 9
        play_character_sound(m, CHAR_SOUND_SNORING2)
        return set_mario_action(m, ACT_RYUENJIN, 0)
    end
    if (m.input & INPUT_OFF_FLOOR) ~= 0 then
        return set_mario_action(m, ACT_FREEFALL_CUSTOM, 0)
    end
    stationary_ground_step(m)
    return false
end

function act_ryuenjin(m)
    m.vel.y = m.vel.y - 4.25
    if (m.vel.y < 0) then
        m.vel.y = 0
    end
    m.actionTimer = m.actionTimer + 1
    mario_set_forward_vel(m, m.forwardVel - 3)
    set_character_animation(m, CHAR_ANIM_FIRST_PUNCH)
    smlua_anim_util_set_animation(m.marioObj, "zero_ryuenjin")
    local airstep = perform_air_step(m, 0)
    if (m.actionTimer == 12 or (not m.ceil and m.vel.y <= 0)) then
        mario_set_forward_vel(m, 0)
        m.marioObj.oIntangibleTimer = 0
        local s = gPlayerSyncTable[m.playerIndex]
        s.jump_dash_state = false
        s.already_airdashed = false
        s.jumped_from_ground_dash = false
        return set_mario_action(m, ACT_RYUENJIN_END, 0)
    end
    if airstep == AIR_STEP_LANDED then
        m.marioObj.oIntangibleTimer = 0
        return set_mario_action(m, ACT_FREEFALL_LAND_STOP, 0)
    end

    return false
end

function act_ryuenjin_end(m)
    set_character_animation(m, CHAR_ANIM_FIRST_PUNCH)
    smlua_anim_util_set_animation(m.marioObj, "zero_ryuenjin_end")
    m.actionTimer = m.actionTimer + 1
    local mGfx = m.marioObj.header.gfx
    set_anim_to_frame(m, m.actionTimer)
    if (m.actionTimer > 2) then
        if (m.controller.buttonPressed & Y_BUTTON) ~= 0 then
            m.actionState = 4
        elseif (m.controller.buttonPressed & X_BUTTON) ~= 0 then
            m.actionState = 3
        elseif (m.input & INPUT_Z_PRESSED) ~= 0 then
            m.actionState = 2
        elseif (m.input & INPUT_B_PRESSED) ~= 0 then
            m.actionState = 1
        elseif (m.input & INPUT_A_PRESSED) ~= 0 then
            m.actionState = 5
        end
        if (m.actionTimer > 3) then
            if (m.actionState == 1) then
                m.forwardVel = zero_air_atk_exit_velocity(m)
                return set_mario_action(m, ACT_AIR_SLASH, 0)
            elseif (m.actionState == 2) then
                set_anim_to_frame(m, 0)
                return set_mario_action(m, ACT_AIR_DASH, 0)
            elseif m.actionState == 3 then
                return set_mario_action(m, ACT_HYOURETSUZAN, 0)
            elseif m.actionState == 4 then
                m.forwardVel = zero_air_atk_exit_velocity(m)
                return set_mario_action(m, ACT_KUENZAN, 0)
            elseif m.actionState == 5 and m.actionTimer == 5 then
                m.vel.y = 30
                return set_mario_action(m, ACT_ZERO_DOUBLE_JUMP, 0)
            end
        end
    end
    if (m.actionTimer == 5) then
        return set_mario_action(m, ACT_FREEFALL_CUSTOM, 0)
    end
    local airstep = perform_air_step(m, 0)
    if airstep == AIR_STEP_LANDED then
        return set_mario_action(m, ACT_FREEFALL_LAND_STOP, 0)
    end
    return false
end

function act_hyouretsuzan(m)
    if not m then return 0 end

    local stepResult
    local yOffset

    m.vel.y = m.actionTimer * -9
    
    if (m.actionTimer == 1) then
        play_character_sound(m, CHAR_SOUND_PUNCH_HOO)
    elseif (m.actionTimer == 2) then
        if (m.playerIndex == 0) then
            spawn_sync_object(id_bhvSaber, E_MODEL_NONE, m.pos.x, m.pos.y, m.pos.z, function(o)
                o.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
                o.oSaberIndex = 9
            end)
        end
    end

    play_sound_if_no_flag(m, SOUND_ACTION_THROW, MARIO_ACTION_SOUND_PLAYED)
    mario_set_forward_vel(m, 0.0)
    
    set_character_animation(m, CHAR_ANIM_START_GROUND_POUND)
    smlua_anim_util_set_animation(m.marioObj, "zero_hyouretsuzan")

    update_air_without_turn(m)
    stepResult = perform_air_step(m, 0)
    if stepResult == AIR_STEP_LANDED then
        
        set_mario_particle_flags(m, PARTICLE_MIST_CIRCLE, false)
        set_anim_to_frame(m, 1)
        if m.playerIndex == 0 then set_camera_shake_from_hit(SHAKE_GROUND_POUND) end
        return set_mario_action(m, ACT_ZERO_SPECIAL_LAND, 0)
    end
    
    if (m.actionTimer < 8) then
        m.actionTimer = m.actionTimer + 1
    end

    return false
end

function act_shippuga(m)
    local s = gPlayerSyncTable[m.playerIndex]
    local mmx = gMmxStates[m.playerIndex]

    if (m.actionTimer == 4) then
        mmx_play_sound(SOUND_ZERO_SLASH1, m.pos, 0.75)
        if (m.playerIndex == 0) then
            spawn_sync_object(id_bhvSaber, E_MODEL_NONE, m.pos.x, m.pos.y, m.pos.z, function(o)
                o.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
                o.oSaberIndex = 6
            end)
        end
    end

    if mario_check_object_grab(m) ~= 0 then
        if m.interactObj.behavior ~= get_behavior_from_id(id_bhvBowser) 
        and (m.interactObj.oInteractionSubtype & INT_SUBTYPE_GRABS_MARIO) == 0 then
            mario_grab_used_object(m)
            play_character_sound(m, CHAR_SOUND_HRMM)
            m.marioBodyState.grabPos = GRAB_POS_LIGHT_OBJ
            mario_set_forward_vel(m, 32.0)
            return set_mario_action(m, ACT_HOLD_IDLE, 0)
        end
    end

    set_character_animation(m, CHAR_ANIM_DIVE)
    smlua_anim_util_set_animation(m.marioObj, "zero_shippuga")
    if (m.actionTimer < 3) then
        mario_set_forward_vel(m, 20 + m.actionTimer * 4)
    elseif (m.actionTimer >= 3 and m.actionTimer < 12) then
        mario_set_forward_vel(m, 130 - m.actionTimer * 6 - (m.actionTimer - 3) * 2)
    else
        if m.actionState == 1 then
            mario_set_forward_vel(m, 10)
        else
            mario_set_forward_vel(m, 30 - (m.actionTimer - 12) * 3)
        end
    end
    local performStep = perform_ground_step(m)
    if performStep == GROUND_STEP_LEFT_GROUND then
        mmx.zero_ledge_shippuga = 1
        m.actionState = 1
        local mmx = gMmxStates[m.playerIndex]
        mario_set_forward_vel(m, 0)
        m.pos.x = mmx.prevPos.x
        m.pos.y = mmx.prevPos.y
        m.pos.z = mmx.prevPos.z
        --return set_mario_action(m, ACT_FREEFALL_CUSTOM, 0)
    else
        m.floorHeight = m.floorHeight + 10
        align_with_floor(m)
        mmx.zero_ledge_shippuga = 0
    end

    if (m.actionTimer == 18) then
        if (m.actionState == 1) then
            mario_set_forward_vel(m, 0)
        end
        set_mario_action(m, ACT_WALKING, 0)
    end

    m.actionTimer = m.actionTimer + 1

    return false
end

function act_sentsuizan(m)
    if not m then return 0 end

    local stepResult

    if (m.actionTimer == 8) then
        play_character_sound(m, CHAR_SOUND_SNORING1)
        if (m.playerIndex == 0) then
            spawn_sync_object(id_bhvSaber, E_MODEL_NONE, m.pos.x, m.pos.y, m.pos.z, function(o)
                o.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
                o.oSaberIndex = 11
            end)
        end
    end

    if (m.actionState == 1) then
        m.vel.y = -90
        mario_set_forward_vel(m, 85)
    else
        m.vel.y = 0
        mario_set_forward_vel(m, 0.0)
    end
    
    set_character_animation(m, CHAR_ANIM_START_GROUND_POUND)
    smlua_anim_util_set_animation(m.marioObj, "zero_sentsuizan")

    stepResult = perform_air_step(m, 0)
    if stepResult == AIR_STEP_LANDED then
        
        set_mario_particle_flags(m, PARTICLE_MIST_CIRCLE, false)
        if m.playerIndex == 0 then set_camera_shake_from_hit(SHAKE_GROUND_POUND) end
        set_anim_to_frame(m, 0)
        set_mario_action(m, ACT_ZERO_SPECIAL_LAND, 1)
    end
    
    if (m.actionTimer < 10) then
        m.actionTimer = m.actionTimer + 1
    end

    if (m.actionTimer == 9) then
        m.actionState = 1
    end

    return false
end

function act_kuenzan(m)
    local s = gPlayerSyncTable[m.playerIndex]
    if m.actionTimer == 2 then
        mmx_play_sound(SOUND_ZERO_SLASH1, m.pos, 0.75)
        if (m.playerIndex == 0) then
            spawn_sync_object(id_bhvSaber, E_MODEL_NONE, m.pos.x, m.pos.y, m.pos.z, function(o)
                o.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
                o.oSaberIndex = 5
            end)
        end
    end
    m.actionTimer = m.actionTimer + 1
    if (m.actionTimer > 12 and m.actionTimer <= 15) then
        if (m.controller.buttonPressed & Y_BUTTON) ~= 0 then
            m.actionState = 4
        elseif (m.controller.buttonPressed & X_BUTTON) ~= 0 then
            m.actionState = 3
        elseif (m.input & INPUT_Z_PRESSED) ~= 0 then
            m.actionState = 2
        elseif (m.input & INPUT_B_PRESSED) ~= 0 then
            m.actionState = 1
        elseif (m.input & INPUT_A_PRESSED) ~= 0 then
            m.actionState = 5
        end
    end
    if (m.actionTimer == 15) then
        m.faceAngle.y = m.intendedYaw
        if m.forwardVel < 0 then
            m.forwardVel = 0
        end
        if (m.actionState == 1) then
            m.forwardVel = zero_air_atk_exit_velocity(m)
            return set_mario_action(m, ACT_AIR_SLASH, 0)
        elseif (m.actionState == 2) and s.jump_dash_state == false and s.already_airdashed == false then
            set_anim_to_frame(m, 0)
            return set_mario_action(m, ACT_AIR_DASH, 0)
        elseif m.actionState == 3 then
            return set_mario_action(m, ACT_HYOURETSUZAN, 0)
        elseif m.actionState == 4 then
            m.forwardVel = zero_air_atk_exit_velocity(m)
            return set_mario_action(m, ACT_KUENZAN, 0)
        elseif m.actionState == 5 and 
        s.zero_double_jump == 0 and s.already_airdashed == false and s.jump_dash_state == false then
            m.vel.y = 30
            return set_mario_action(m, ACT_ZERO_DOUBLE_JUMP, 0)
        else
            return set_mario_action(m, ACT_FREEFALL_CUSTOM, 0)
        end
    end
    common_air_action_step_no_wall(m, ACT_FREEFALL_LAND_STOP, CHAR_ANIM_FORWARD_SPINNING, AIR_STEP_CHECK_HANG, 0)
    set_anim_to_frame(m, m.actionTimer - 1)
    --set_character_animation(m, CHAR_ANIM_FORWARD_SPINNING)
    smlua_anim_util_set_animation(m.marioObj, "zero_kuenzan")
    return false
end

function act_raikousen(m)
    local mmx = gMmxStates[m.playerIndex]
    if (m.actionTimer == 0) then
        play_character_sound(m, CHAR_SOUND_SNORING1)
        mmx.zero_raikousen_start_pos = {x = m.pos.x, y = m.pos.y, z = m.pos.z}
        if (m.playerIndex == 0) then
            spawn_sync_object(id_bhvSaber, E_MODEL_NONE, m.pos.x, m.pos.y, m.pos.z, function(o)
                o.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
                o.oSaberIndex = 7
            end)
        end
    elseif (m.actionTimer == 20) then
        mmx_play_sound(SOUND_ZERO_RAIKOUSEN, m.pos, 0.75)
        set_environmental_camera_shake(SHAKE_ENV_EXPLOSION)
    elseif (m.actionTimer == 24) then
        spawn_non_sync_object(id_bhvRaikousenLightning, E_MODEL_NONE, m.pos.x, m.pos.y + 80, m.pos.z, function(o)
            o.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
        end)
    end


    local performStep = perform_ground_step(m)
    if performStep == GROUND_STEP_LEFT_GROUND then
        m.actionState = 1
        m.pos.x = mmx.prevPos.x
        m.pos.y = mmx.prevPos.y
        m.pos.z = mmx.prevPos.z
        mario_set_forward_vel(m, 0)
        --set_mario_action(m, ACT_FREEFALL_CUSTOM, 0)
    end

    if (m.input & INPUT_OFF_FLOOR) ~= 0 then
        return set_mario_action(m, ACT_FREEFALL_CUSTOM, 0)
    end


    m.actionTimer = m.actionTimer + 1
    if (m.actionTimer < 14) then
        set_character_animation(m, CHAR_ANIM_FIRST_PUNCH)
        smlua_anim_util_set_animation(m.marioObj, "zero_raikousen_start")
        mario_set_forward_vel(m, 0)
    elseif (m.actionTimer >= 14 and m.actionTimer < 22) then
        m.marioObj.header.gfx.node.flags = m.marioObj.header.gfx.node.flags | GRAPH_RENDER_INVISIBLE
        m.marioObj.oIntangibleTimer = 16
        mario_set_forward_vel(m, 100.0 - m.actionState * 100)
    elseif (m.actionTimer >= 22 and m.actionTimer < 37) then
        set_character_animation(m, CHAR_ANIM_SINGLE_JUMP)
        m.marioObj.oIntangibleTimer = 0
        smlua_anim_util_set_animation(m.marioObj, "zero_raikousen_end")
        --set_anim_to_frame(m, m.actionTimer - 20)
        m.marioObj.header.gfx.animInfo.animFrame = m.actionTimer - 21
        m.marioObj.header.gfx.node.flags = m.marioObj.header.gfx.node.flags &~ GRAPH_RENDER_INVISIBLE
        mario_set_forward_vel(m, 0)
    elseif (m.actionTimer >= 37) then
        return transition_into_idle_or_walk(m, 32)
    end
    return false
end

function act_zero_special_land(m)
    local mmx = gMmxStates[m.playerIndex]
    local anim = "zero_hyouretsuzan_land"
    if (m.actionArg == 0) then
        if (m.actionTimer == 0) then
            mmx_play_sound(SOUND_ZERO_HYOURETSUZAN_IMPACT, m.pos, 0.75)
            for i = 1,5,1 
            do 
                local angle = m.faceAngle.y + 13107 * i
                local xOffset = sins(angle) * 15 + 35 * sins(m.faceAngle.y)
                local zOffset = coss(angle) * 15 + 35 * coss(m.faceAngle.y)
                spawn_non_sync_object(id_bhvHyouretsuzanShard, E_MODEL_NONE, m.pos.x + xOffset, m.pos.y, m.pos.z + zOffset, function(o)
                    o.oMoveAngleYaw = angle
                end)
                spawn_non_sync_object(id_bhvSnowParticleSpawner, E_MODEL_NONE, m.pos.x + xOffset, m.pos.y + 20, m.pos.z + zOffset , nil)
            end
        end
    elseif (m.actionArg == 1) then
        if m.actionTimer == 1 then
            set_environmental_camera_shake(SHAKE_ENV_EXPLOSION)
            mmx_play_sound(SOUND_ZERO_SENTSUIZAN_LAND, m.pos, 0.65)
        end
        anim = "zero_sentsuizan_land"
    end

    if (m.input & INPUT_OFF_FLOOR) ~= 0 then
        return set_mario_action(m, ACT_FREEFALL_CUSTOM, 0)
    end

    if (m.input & INPUT_ABOVE_SLIDE) ~= 0 then
        return set_mario_action(m, ACT_BUTT_SLIDE, 0)
    end
    
    if (m.actionTimer >= 10 + m.actionArg) or (m.actionTimer >= 5 and check_any_input(m) == true) then
        return set_mario_action(m, ACT_IDLE, 0)
    end
    landing_step(m, CHAR_ANIM_GROUND_POUND_LANDING, ACT_BUTT_SLIDE_STOP)
    smlua_anim_util_set_animation(m.marioObj, anim)
    m.actionTimer = m.actionTimer + 1
    return false
end

-- ACTION HOOKS
hook_mario_action(ACT_ZERO_DOUBLE_JUMP, { every_frame = act_zero_double_jump})
hook_mario_action(ACT_LIGHT_ZSABER, { every_frame = act_light_zsaber})
hook_mario_action(ACT_MEDIUM_ZSABER, { every_frame = act_medium_zsaber})
hook_mario_action(ACT_HEAVY_ZSABER, { every_frame = act_heavy_zsaber})
hook_mario_action(ACT_AIR_SLASH, { every_frame = act_air_slash})
hook_mario_action(ACT_AIR_SLASH_LAND, { every_frame = act_air_slash_land})
hook_mario_action(ACT_RYUENJIN_START, { every_frame = act_ryuenjin_start})
hook_mario_action(ACT_RYUENJIN, { every_frame = act_ryuenjin})
hook_mario_action(ACT_RYUENJIN_END, { every_frame = act_ryuenjin_end})
hook_mario_action(ACT_HYOURETSUZAN, { every_frame = act_hyouretsuzan})
hook_mario_action(ACT_SHIPPUGA, { every_frame = act_shippuga}, INT_FAST_ATTACK_OR_SHELL)
hook_mario_action(ACT_SENTSUIZAN, { every_frame = act_sentsuizan})
hook_mario_action(ACT_KUENZAN, { every_frame = act_kuenzan})
hook_mario_action(ACT_RAIKOUSEN, { every_frame = act_raikousen})
hook_mario_action(ACT_ZERO_SPECIAL_LAND, { every_frame = act_zero_special_land}, INT_GROUND_POUND)


-- Used for swapping zero models (saber on his back or not)
ZSABER_TABLE = {
    [ACT_LIGHT_ZSABER] = true,
    [ACT_MEDIUM_ZSABER] = true,
    [ACT_HEAVY_ZSABER] = true,
    [ACT_AIR_SLASH] = true,
    [ACT_AIR_SLASH_LAND] = true,
    [ACT_RYUENJIN] = true,
    [ACT_HYOURETSUZAN] = true,
    [ACT_SHIPPUGA] = true,
    [ACT_SENTSUIZAN] = true,
    [ACT_KUENZAN] = true,
    [ACT_RAIKOUSEN] = true,
    [ACT_ZERO_SPECIAL_LAND] = true,
}

PONYTAIL_ANIM_TABLE = {
    [ACT_ZERO_SPECIAL_LAND] = true,
    [ACT_LIGHT_ZSABER] = true,
    [ACT_MEDIUM_ZSABER] = true,
    [ACT_HEAVY_ZSABER] = true,
    [ACT_AIR_SLASH] = true,
    [ACT_AIR_SLASH_LAND] = true,
    [ACT_RYUENJIN_START] = true,
    [ACT_RYUENJIN] = true,
    [ACT_RYUENJIN_END] = true,
    [ACT_HYOURETSUZAN] = true,
    [ACT_SHIPPUGA] = true,
    [ACT_SENTSUIZAN] = true,
    [ACT_KUENZAN] = true,
    [ACT_RAIKOUSEN] = true,
    [ACT_ZERO_DOUBLE_JUMP] = true,
    [ACT_AIR_HIT_WALL_CUSTOM] = true,
    [ACT_WARP_DOOR_SPAWN] = true,
    [ACT_READING_NPC_DIALOG] = true,
    [ACT_READING_SIGN] = true,
    [ACT_FREEFALL_CUSTOM] = true,
    [ACT_JUMP_CUSTOM] = true,
    [ACT_WALL_KICK_CUSTOM] = true,
    [ACT_FREEFALL_LAND_STOP] = true,
    [ACT_BRAKING_STOP] = true,
    [ACT_STOP_CROUCHING] = true,
    [ACT_BRAKING] = true,
    [ACT_WALL_SLIDE] = true,
    [ACT_AIR_DASH] = true,
    [ACT_DASH] = true,
    [ACT_IDLE] = true,
}

DASH_SPAWNERS = {
    [ACT_FREEFALL_CUSTOM] = true,
    [ACT_JUMP_CUSTOM] = true,
    [ACT_WALL_KICK_CUSTOM] = true,
    [ACT_WATER_JUMP] = true,
    [ACT_AIR_SLASH] = true,
    [ACT_HYOURETSUZAN] = true,
    [ACT_KUENZAN] = true,
}

---------------------------------------------------------------
--- FUNCTIONS -------------------------------------------------
---------------------------------------------------------------

function mmx_zero_apply_colors(m)
    local s = gPlayerSyncTable[m.playerIndex]
    local colors = {
        -- PANTS
        [0] = {r = 55, g = 55, b = 55},
        -- SHIRT
        [1] = {r = 255, g = 0, b = 0},
        -- GLOVES
        [2] = {r = 255, g = 255, b = 255},
        -- SHOES
        [3] = {r = 0, g = 255, b = 0},
        -- HAIR
        [4] = {r = 255, g = 255, b = 13},
        -- SKIN
        [5] = {r = 255, g = 255, b = 255},
        -- CAP
        [6] = {r = 0, g = 120, b = 255},
        -- EMBLEM
        [7] = {r = 140, g = 140, b = 140}
    }
    for i = 0, PLAYER_PART_MAX - 1 do
        local color = network_player_get_palette_color(gNetworkPlayers[m.playerIndex], i)
        if (s.enable_color and s.enable_model) then
            color = colors[i]
        end
        network_player_set_override_palette_color(gNetworkPlayers[m.playerIndex], i, color)
    end
end

----------------------------------------------------
--- LOOP -------------------------------------------
----------------------------------------------------

function zero_update_local(m)
    local s = gPlayerSyncTable[m.playerIndex]

    --- INTRO ----------------------------------------------
    mmx_update_local_intro_timer(m)

    --- AIR ------------------------------------------------
    mmx_local_update_air(m)

    --- WALL JUMPING ---------------------------------------
    mmx_local_update_walljump(m)

    --- DASHING --------------------------------------------
    if s.ground_dash_cooldown > 0 then
        s.ground_dash_cooldown = s.ground_dash_cooldown - 1
    end

    --- AIR DASHING ----------------------------------------
    if ((m.action & ACT_FLAG_AIR) == 0 or m.action == ACT_BUTT_SLIDE_AIR) and m.action ~= ACT_DASH then
        
        s.jump_dash_state = false
        s.already_airdashed = false
        s.jumped_from_ground_dash = false
        s.zero_double_jump = 0
        s.zero_dropped_from_wall = 0
        
        -- If holding Z on ground without dashing and then jumping, jump_dash_state will be set
        -- needs to be tested though
        if (m.input & INPUT_Z_DOWN) ~= 0 then
            s.jump_dash_state = true
        end
    end

end

local DEFAULTHANDS_TABLE = DEFAULTHANDS_TABLE
local GROUND_ACTIONS_TABLE = GROUND_ACTIONS_TABLE
local GROUND_HOLD_ACTIONS_TABLE = GROUND_HOLD_ACTIONS_TABLE
local AIR_ACTIONS = {
    [ACT_JUMP_CUSTOM] = true,
    [ACT_FREEFALL_CUSTOM] = true,
    [ACT_ZERO_DOUBLE_JUMP] = true,
    [ACT_WALL_KICK_CUSTOM] = true,
    [ACT_WATER_JUMP] = true,
}

function zero_update_all(m)
    local s = gPlayerSyncTable[m.playerIndex]
    local mmx = gMmxStates[m.playerIndex]
    local mGfx = m.marioObj.header.gfx
    local animFrame = mGfx.animInfo.animFrame

    if (s.enable_model) then
        if (ZSABER_TABLE[m.action]) then
            if _G.charSelectExists then
                if m.playerIndex == 0 then
                    _G.charSelect.character_edit(ZERO_CS, nil, nil, nil, nil, E_model_zero, nil, nil)
                end
            else
                gPlayerSyncTable[m.playerIndex].modelId = E_model_zero
            end
        elseif (PONYTAIL_ANIM_TABLE[m.action] 
        or ((m.action == ACT_WALKING or m.action == ACT_WALKING_CUSTOM) and m.actionTimer == 3)) 
        and not (m.action == ACT_READING_NPC_DIALOG and m.heldObj ~= nil) then
            if _G.charSelectExists then
                if m.playerIndex == 0 then
                    _G.charSelect.character_edit(ZERO_CS, nil, nil, nil, nil, E_model_zero_handle, nil, nil)
                end
            else
                gPlayerSyncTable[m.playerIndex].modelId = E_model_zero_handle
            end
        else
            if _G.charSelectExists then
                if m.playerIndex == 0 then
                    _G.charSelect.character_edit(ZERO_CS, nil, nil, nil, nil, E_model_zero_noanim, nil, nil)
                end
            else
                gPlayerSyncTable[m.playerIndex].modelId = E_model_zero_noanim
            end
        end
    end

    --------------------------------------------------------
    --- GENERAL --------------------------------------------
    --------------------------------------------------------

    mmx_update_props(m)
    mmx_resize_char(m, 0.965)

    --------------------------------------------------------
    --- IDLE -----------------------------------------------
    --------------------------------------------------------
    
    mmx_update_sleeping(m)
    mmx_update_idle(m, 0)

    --------------------------------------------------------
    --- WATER JUMP -----------------------------------------
    --------------------------------------------------------
    
    mmx_update_water_jump(m)

    --------------------------------------------------------
    --- WALKING --------------------------------------------
    --------------------------------------------------------

    mmx_update_walking(m, 0)

    --------------------------------------------------------
    --- JUMPING AND FALLING --------------------------------
    --------------------------------------------------------

    mmx_update_jump_fall(m, ZERO_MAXAIRSPEED_NODASH, ZERO_MAXAIRSPEED_DASHJUMP, ZERO_MAXAIRSPEED_HOLDDASHJUMP, 0)

    --------------------------------------------------------
    --- COLOR ----------------------------------------------
    --------------------------------------------------------

    mmx_zero_apply_colors(m)

    --------------------------------------------------------
    --- Z-SABER --------------------------------------------
    --------------------------------------------------------
    if (m.input & INPUT_B_PRESSED) ~= 0 and (GROUND_ACTIONS_TABLE[m.action] or m.action == ACT_WALKING_CUSTOM) then
        return set_mario_action(m, ACT_LIGHT_ZSABER, 0)
    end

    --------------------------------------------------------
    --- Z-SABER AIR ----------------------------------------
    --------------------------------------------------------
    if (m.input & INPUT_B_PRESSED) ~= 0 and
    (m.action == ACT_JUMP_CUSTOM or m.action == ACT_FREEFALL_CUSTOM 
    or m.action == ACT_WALL_KICK_CUSTOM or m.action == ACT_ZERO_DOUBLE_JUMP or m.action == ACT_AIR_DASH) then
        m.faceAngle.y = m.intendedYaw
        if (m.action == ACT_WALL_KICK_CUSTOM and m.actionTimer <= 7 
        and abs_angle_diff(atan2s(m.wallNormal.z, m.wallNormal.x) + 32768, m.intendedYaw) > 14000) then
            mario_set_forward_vel(m, (m.controller.stickMag / 64) * mmx.last_max_vel_wallkick)
        end
        set_mario_action(m, ACT_AIR_SLASH, 0)
    end

    --------------------------------------------------------
    --- RYUENJIN -------------------------------------------
    --------------------------------------------------------
    if (m.controller.buttonPressed & X_BUTTON) ~= 0 and (GROUND_ACTIONS_TABLE[m.action] or m.action == ACT_WALKING_CUSTOM) then
        set_mario_action(m, ACT_RYUENJIN_START, 0)
    end

    --------------------------------------------------------
    --- RAIKOUSEN ------------------------------------------
    --------------------------------------------------------
    if (m.controller.buttonPressed & X_BUTTON) ~= 0 and ( m.action == ACT_DASH) then
        set_mario_action(m, ACT_RAIKOUSEN, 0)
    end

    --------------------------------------------------------
    --- SHIPPPUGA ------------------------------------------
    --------------------------------------------------------
    if (m.controller.buttonPressed & Y_BUTTON) ~= 0 and ( m.action == ACT_DASH) then
        set_anim_to_frame(m, 0)
        play_character_sound(m, CHAR_SOUND_HOOHOO)
        set_mario_action(m, ACT_SHIPPUGA, 0)
    end

    --------------------------------------------------------
    --- KUENZAN --------------------------------------------
    --------------------------------------------------------

    if (m.controller.buttonPressed & Y_BUTTON) ~= 0 and 
    (m.action == ACT_JUMP_CUSTOM or m.action == ACT_FREEFALL_CUSTOM 
    or m.action == ACT_WALL_KICK_CUSTOM or m.action == ACT_WALL_SLIDE or m.action == ACT_ZERO_DOUBLE_JUMP
    or m.action == ACT_AIR_DASH) then
        m.faceAngle.y = m.intendedYaw
        if (m.action == ACT_WALL_KICK_CUSTOM and m.actionTimer <= 7 
        and abs_angle_diff(atan2s(m.wallNormal.z, m.wallNormal.x) + 32768, m.intendedYaw) > 14000) then
            mario_set_forward_vel(m, (m.controller.stickMag / 64) * mmx.last_max_vel_wallkick)
        end
        set_mario_action(m, ACT_KUENZAN, 0)
    end

    --------------------------------------------------------
    --- DASHING --------------------------------------------
    --------------------------------------------------------
    if ((m.input & INPUT_Z_PRESSED) ~= 0)
    and (GROUND_ACTIONS_TABLE[m.action] or m.action == ACT_RIDING_SHELL_GROUND or GROUND_HOLD_ACTIONS_TABLE[m.action] or m.action == ACT_WALKING_CUSTOM) 
    and s.ground_dash_cooldown == 0
        then
        m.faceAngle.y = m.intendedYaw
        --spawn_non_sync_object(id_bhvDashFx, E_model_zero_dash_fx, m.pos.x, m.pos.y, m.pos.z, function(o)
        --    o.parentObj = m.marioObj
        --    o.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
        --end)
        set_anim_to_frame(m, 0)
        set_mario_action(m, ACT_DASH, 0)
    end

    --------------------------------------------------------
    --- AIR DASHING ----------------------------------------
    --------------------------------------------------------
    if (m.input & INPUT_Z_PRESSED) ~= 0 and (m.action ~= ACT_BUBBLED) and ((m.action == ACT_JUMP_CUSTOM 
    or m.action == ACT_FREEFALL_CUSTOM 
    or m.action == ACT_WATER_JUMP or m.action == ACT_ZERO_DOUBLE_JUMP))
    and s.jump_dash_state == false and s.already_airdashed == false and s.zero_double_jump == 0 then
        m.vel.y = 0
        m.faceAngle.y = m.intendedYaw
        set_anim_to_frame(m, 0)
        set_mario_action(m, ACT_AIR_DASH, 0)
    end

    -- Trail spawning
    if (s.jump_dash_state == true or s.already_airdashed == true) and DASH_SPAWNERS[m.action] then
        spawn_non_sync_object(id_bhvTrail, E_model_zero_animated_alpha, mGfx.pos.x , mGfx.pos.y , mGfx.pos.z , function (obj)
            obj.oMoveAngleYaw = m.faceAngle.y
            obj.oOwner = gNetworkPlayers[m.playerIndex].globalIndex
        end)
    end

    --------------------------------------------------------
    --- AIR DASHING ----------------------------------------
    --------------------------------------------------------
    if m.action == ACT_FREEFALL_CUSTOM and (m.input & INPUT_A_PRESSED) ~= 0
     and s.zero_double_jump == 0 and s.already_airdashed == false and s.jump_dash_state == false then
        if s.zero_dropped_from_wall == 1 then
            if m.actionTimer > 12 then
                m.vel.y = 30
            else
                m.vel.y = m.actionTimer
            end
        else
            m.vel.y = 30
        end
        return set_mario_action(m, ACT_ZERO_DOUBLE_JUMP, 0)
    end

    --------------------------------------------------------
    --- LANDING --------------------------------------------
    --------------------------------------------------------

    mmx_update_landing(m, 0)

    --------------------------------------------------------
    --- BRAKE STOP -----------------------------------------
    --------------------------------------------------------

    mmx_update_brake_stop(m)

    -- Special zero brake
    if (m.action == ACT_BRAKING) and s.character ~= 'none' then
        set_anim_to_frame(m, 1)
        smlua_anim_util_set_animation(m.marioObj, s.character .. "_brake_stop")
    end

    --------------------------------------------------------
    --- STOP CROUCH ----------------------------------------
    --------------------------------------------------------

    mmx_update_stop_crouch(m)

    --------------------------------------------------------
    --- BUTT SLIDE -----------------------------------------
    --------------------------------------------------------

    mmx_update_butt_slide(m)

    --------------------------------------------------------
    --- PUNCHING -------------------------------------------
    --------------------------------------------------------

    mmx_update_punching(m, 0)

    --------------------------------------------------------
    --- HYOURETSUZAN ---------------------------------------
    --------------------------------------------------------

    if (m.controller.buttonPressed & X_BUTTON) ~= 0 and 
    (AIR_ACTIONS[m.action] or m.action == ACT_FLYING) then
        if m.action == ACT_FLYING and m.playerIndex == 0 then
            set_camera_mode(m.area.camera, m.area.camera.defMode, 1)
        end
        set_mario_action(m, ACT_HYOURETSUZAN, 0)
    end


    --------------------------------------------------------
    --- SENTSUIZAN -----------------------------------------
    --------------------------------------------------------
    if ( m.action == ACT_AIR_DASH) and (m.controller.buttonPressed & X_BUTTON) ~= 0 then
        set_mario_action(m, ACT_SENTSUIZAN, 0)
    end

    --------------------------------------------------------
    --GROUND TURNAROUND-------------------------------------
    --------------------------------------------------------
    
    mmx_update_turnaround(m, 0)

    --------------------------------------------------------
    --ROLLOUT-----------------------------------------------
    --------------------------------------------------------
    mmx_update_rollout(m)
end
