-- name: \\#5B83B5\\Mega Man \\#EFC600\\X \\#AAAAAA\\v1.2.3\\#FFFFFF\\
-- description: Mega Man X v1.2.3

-----------------------------------------------------------------
----- LOCALIZED FUNCTIONS ---------------------------------------
-----------------------------------------------------------------
local set_mario_y_vel_based_on_fspeed, mmx_play_sound, set_mario_action, vile_meter_render, render_hud_mario_lives,
mmx_play_sound = 
set_mario_y_vel_based_on_fspeed, mmx_play_sound, set_mario_action, vile_meter_render, render_hud_mario_lives,
mmx_play_sound

local defaultFixCollisionBugs = gLevelValues.fixCollisionBugs
local defaultFixCollisionBugsRoundedCorners = gLevelValues.fixCollisionBugsRoundedCorners
local defaultFixCollisionBugsPickBestWall = gLevelValues.fixCollisionBugsPickBestWall
local pauseExited = false

x_hud_icon = get_texture_info("mmx_x_hud")
x_lightarmor_hud_icon = get_texture_info("mmx_x_lightarmor_hud")
x_gigaarmor_hud_icon = get_texture_info("mmx_x_gigaarmor_hud")
vile_hud_icon = get_texture_info("mmx_vile_hud")
zero_hud_icon = get_texture_info("mmx_zero_hud_big")

-- Character Select Support
if _G.charSelectExists then


    local X_DESC = {
        "-B: X-Buster",
        "-Z: Dash",
        "-Y (Ground): Punch",
        "-Y (Air): Ground pound",
        "",
        "Current Armor: None"
    }
    local X_LIGHTARMOR_DESC = {
        "-B: X-Buster",
        "-Z: Dash",
        "-Y (Ground): Punch",
        "-Y (Air): Ground pound",
        "",
        "Current Armor: First Armor"
    }
    local X_GIGAARMOR_DESC = {
        "-B: X-Buster",
        "-Z: Dash",
        "-Y (Ground): Punch",
        "-Y (Air): Ground pound",
        "",
        "Current Armor: Second Armor"
    }
    local ZERO_DESC = {
        "-B (Ground): Triple Z-Saber combo",
        "-B (Air): Air slash",
        "-Z: Dash",
        "-Y (Ground): Punch",
        "-Dash (Ground) + Y: Shippuga",
        "-Y (Air): Kuuenzan",
        "-X (Ground): Ryuenjin",
        "-Dash (Ground) + X: Raikousen",
        "-X (Air): Hyouretsuzan",
        "-Dash (Air) + X: Sentsuizan"
    }
    local VILE_DESC = {
        "-B: Vulcan (Cherry Blast)",
        "-Z (Ground): Dash Attack (Grab OK)",
        "-Z (Air): Ground pound",
        "-Y: Napalm (Bumpity Boom)",
        "-X: Cannon (Front Runner)"
    }

    -- Character Initialize
    X_CS = _G.charSelect.character_add("[MMX] X", X_DESC, "ganewatch", {r = 39, g = 95, b = 216}, E_model_x, CT_MARIO, x_hud_icon)
    ZERO_CS = _G.charSelect.character_add("[MMX] Zero", ZERO_DESC, "ganewatch", {r = 39, g = 95, b = 216}, E_model_zero, CT_MARIO, zero_hud_icon)
    VILE_CS = _G.charSelect.character_add("[MMX] Vile", VILE_DESC, "ganewatch", {r = 39, g = 95, b = 216}, E_model_vile, CT_MARIO, vile_hud_icon)


    -- Add Voices and Palette
    _G.charSelect.character_add_voice(E_model_x, X_CUSTOM_VOICETABLE)
    _G.charSelect.character_add_voice(E_model_x_lightarmor, X_CUSTOM_VOICETABLE)
    _G.charSelect.character_add_voice(E_model_x_gigaarmor, X_CUSTOM_VOICETABLE)
    _G.charSelect.character_add_voice(E_model_zero, ZERO_CUSTOM_VOICETABLE)
    _G.charSelect.character_add_voice(E_model_zero_handle, ZERO_CUSTOM_VOICETABLE)
    _G.charSelect.character_add_voice(E_model_zero_noanim, ZERO_CUSTOM_VOICETABLE)
    _G.charSelect.character_add_voice(E_model_vile, VILE_CUSTOM_VOICETABLE)
    _G.charSelect.character_add_voice(E_model_vile_defaulthands, VILE_CUSTOM_VOICETABLE)
    _G.charSelect.character_add_voice(E_model_vile_knee, VILE_CUSTOM_VOICETABLE)
    _G.charSelect.character_add_voice(E_model_vile_cannon, VILE_CUSTOM_VOICETABLE)

    -- Update Voicelines
    local character_get_voice, update_sound = _G.charSelect.character_get_voice, _G.charSelect.voice.sound
    local function character_sounds(m, sound)
        local v = _G.charSelect.character_get_voice(m)
        if v == X_CUSTOM_VOICETABLE or v == ZERO_CUSTOM_VOICETABLE or v == VILE_CUSTOM_VOICETABLE
        then
            return update_sound(m, sound)
        end
    end

    hook_event(HOOK_CHARACTER_SOUND, character_sounds)



    --------------------------------------------
    --- Alt Costume code from Paper Partners ---
    --- By Squishy ---
    --------------------------------------------

    local character_edit = _G.charSelect.character_edit
    local character_get_current_number = _G.charSelect.character_get_current_number
    local character_get_current_table = _G.charSelect.character_get_current_table
    local get_options_status = _G.charSelect.get_options_status
    local get_menu_color = _G.charSelect.get_menu_color
    local hook_render_in_menu = _G.charSelect.hook_render_in_menu

    local table_insert = table.insert
    local play_sound = play_sound
    local djui_hud_get_screen_width = djui_hud_get_screen_width
    local djui_hud_measure_text = djui_hud_measure_text
    local djui_hud_set_color = djui_hud_set_color
    local djui_hud_set_resolution = djui_hud_set_resolution
    local djui_hud_set_rotation = djui_hud_set_rotation
    local djui_hud_set_font = djui_hud_set_font
    local djui_hud_print_text = djui_hud_print_text
    local djui_hud_render_rect = djui_hud_render_rect
    local maxf = maxf
    local math_min = math.min
    local math_max = math.max
    local math_sin = math.sin

    local x_armors = {
        [X_CS] = {
            currSkin = 1,
            {name = "None", model = E_model_x, value = 0, desc = X_DESC, icon = x_hud_icon},
            {name = "First Armor", model = E_model_x_lightarmor, value = 1, desc = X_LIGHTARMOR_DESC, icon = x_lightarmor_hud_icon},
            {name = "Second Armor", model = E_model_x_gigaarmor, value = 2, desc = X_GIGAARMOR_DESC, icon = x_gigaarmor_hud_icon},
        },
    }

    local function update_character_skin(currChar, currAlt)
        local currSkin = x_armors[currChar][currAlt]
        if x_armors[currChar].desc == nil then
            x_armors[currChar].desc = character_get_current_table().description
        end
        character_edit(currChar, nil, currSkin.desc, nil, nil, currSkin.model, nil, currSkin.icon)
        local s = gPlayerSyncTable[0]
        s.x_armor = currSkin.value
        local cameraToObject = gMarioStates[0].marioObj.header.gfx.cameraToObject
        play_sound(SOUND_MENU_MESSAGE_NEXT_PAGE, cameraToObject)
    end

    local inputLockTimer = 0
    local buttonAnimTimer = 0

    local MATH_DIVIDE_320 = 1/320

    local latencyValueTable = {12, 6, 3}

    local function hud_render()
        local width = djui_hud_get_screen_width() + 1.4
        local widthScale = maxf(width, 321.4) * MATH_DIVIDE_320
        local currChar = character_get_current_number()
        local charColors = character_get_current_table().color
        
        -- Mimick button swaying, which is missing from the paper code
        local buttonAnim = 0
        local charSelectAnim = get_options_status(_G.charSelect.optionTableRef.anims)
        if charSelectAnim > 0 then
            buttonAnimTimer = buttonAnimTimer + 1
            buttonAnim = math_sin(buttonAnimTimer * 0.05) * 2.5 + 5
        else
            buttonAnim = 10
        end

        local inputLockTimerTo = latencyValueTable[get_options_status(_G.charSelect.optionTableRef.inputLatency) + 1]

        if x_armors[currChar] ~= nil then
            -- Render Mod Variond under CS version
            local menuColor = get_menu_color()
            djui_hud_set_color(menuColor.r, menuColor.g, menuColor.b, 255)
            djui_hud_set_font(FONT_TINY)
            local string = 'Mega Man X v1.2.3'
            djui_hud_print_text(string, width - 5 - djui_hud_measure_text(string)*0.5, 3, 0.5)

            ---@type Controller
            local c = _G.charSelect.controller
            local currAlts = x_armors[currChar]

            djui_hud_set_font(FONT_NORMAL)
            djui_hud_set_resolution(RESOLUTION_N64)
            local inputLockTimerAnim = 0

            local buttonX = 20 * widthScale + buttonAnim
            local x1 = buttonX - 4
            local x2 = x1 + 73
            local y = 97

            if charSelectAnim > 0 then
                inputLockTimerAnim = inputLockTimer/inputLockTimerTo * 3
                x1 = x1 + math_min(inputLockTimerAnim, 0)
                x2 = x2 + math_max(inputLockTimerAnim, 0)
            end
            -- Left Arrow
            if currAlts.currSkin > 1 then
                djui_hud_set_color(charColors.r, charColors.g, charColors.b, 255)
                djui_hud_set_rotation(0x2000, 0.5, 0.5)
                djui_hud_render_rect(x1, y, 5, 5)
                djui_hud_set_color(0, 0, 0, 255)
                djui_hud_set_rotation(0x0000, 0.5, 0.5)
                djui_hud_render_rect(x1 + 2.5, y - 2, 6, 8)
                djui_hud_set_color(charColors.r, charColors.g, charColors.b, 255)
                djui_hud_render_rect(buttonX, y - 3, 1, 10)

                if inputLockTimer == 0 and (c.buttonDown & L_JPAD ~= 0 or c.stickX < -0.5) then
                    currAlts.currSkin = math_max(currAlts.currSkin - 1, 1)
                    update_character_skin(currChar, currAlts.currSkin)
                    inputLockTimer = -inputLockTimerTo
                end
            end
            -- Right Arrow
            if currAlts.currSkin < #currAlts then
                -- Changed arrows to mimick the ones seen in the options menu
                djui_hud_set_color(charColors.r, charColors.g, charColors.b, 255)
                djui_hud_set_rotation(0x2000, 0.5, 0.5)
                djui_hud_render_rect(x2, y, 5, 5)
                djui_hud_set_color(0, 0, 0, 255)
                djui_hud_set_rotation(0x0000, 0.5, 0.5)
                djui_hud_render_rect(x2 - 3.5, y - 2, 6, 8)
                djui_hud_set_color(charColors.r, charColors.g, charColors.b, 255)
                djui_hud_render_rect(buttonX + 69, y - 3, 1, 10)

                if inputLockTimer == 0 and (c.buttonDown & R_JPAD ~= 0 or c.stickX > 0.5) then
                    currAlts.currSkin = currAlts.currSkin + 1
                    update_character_skin(currChar, currAlts.currSkin)
                    inputLockTimer = inputLockTimerTo
                end
            end
            -- use an input lock to prevent cycling too fast
            if inputLockTimer > 0 then
                inputLockTimer = inputLockTimer - 1
            elseif inputLockTimer < 0 then
                inputLockTimer = inputLockTimer + 1
            end
        end
    end

    hook_render_in_menu(hud_render)

end

local function character_select_update()
    local s = gPlayerSyncTable[0]
    if X_CS == _G.charSelect.character_get_current_number() then
        s.character = 'x'
    elseif ZERO_CS == _G.charSelect.character_get_current_number() then
        s.character = 'zero'
    elseif VILE_CS == _G.charSelect.character_get_current_number() then
        s.character = 'vile'
    else
        s.character = 'none'
    end
end

local ALLOWED_FIX_COLLISION_BUGS_ACTIONS = {
    [ACT_WALKING_CUSTOM] = true,
    [ACT_FREEFALL_CUSTOM] = true,
    [ACT_WATER_JUMP] = true,
    [ACT_JUMP_CUSTOM] = true,
    [ACT_ZERO_DOUBLE_JUMP] = true,
    [ACT_WALL_KICK_CUSTOM] = true,
    [ACT_WALL_SLIDE] = true,
    [ACT_AIR_HIT_WALL_CUSTOM] = true,
    [ACT_DASH] = true,
    [ACT_AIR_DASH] = true,
    [ACT_VILE_DASH] = true
}

function mario_update(m)
    local s = gPlayerSyncTable[m.playerIndex]
    local mmx = gMmxStates[m.playerIndex]

    if _G.charSelectExists then
        character_select_update()
    end

    if (s.character == 'x') then
        if m.playerIndex == 0 then
            x_update_local(m)
        end
        if active_player(m) then
            x_update_all(m)
        end
    elseif (s.character == 'zero') then
        if m.playerIndex == 0 then
            zero_update_local(m)
        end
        if active_player(m) then
            zero_update_all(m)
        end
    elseif (s.character == 'vile') then
        if m.playerIndex == 0 then
            vile_update_local(m)
        end
        if active_player(m) then
            vile_update_all(m)
        end
    end

    if m.playerIndex == 0 then
        if (s.character ~= 'x' or s.x_armor ~= 2) and s.x_doubleshot == 1 then
            mmx.x_right_hand_shot = false
            s.x_doubleshot = 0
        end
    end

    if (s.palette_reset_signal) then
        network_player_reset_override_palette(gNetworkPlayers[m.playerIndex])
        if (m.playerIndex == 0) then
            s.palette_reset_signal = false
        end
    end

    if (s.character ~= 'none') then
        if ALLOWED_FIX_COLLISION_BUGS_ACTIONS[m.action] and pauseExited == false then
            gLevelValues.fixCollisionBugs = 1
            gLevelValues.fixCollisionBugsRoundedCorners = 0
            gLevelValues.fixCollisionBugsPickBestWall = 1
            if mmx.can_restore_glevelvalue == 0 then
                mmx.can_restore_glevelvalue = 1
            end
        elseif mmx.can_restore_glevelvalue == 1 then
            gLevelValues.fixCollisionBugs = defaultFixCollisionBugs
            gLevelValues.fixCollisionBugsRoundedCorners = defaultFixCollisionBugsRoundedCorners
            gLevelValues.fixCollisionBugsPickBestWall = defaultFixCollisionBugsPickBestWall
            mmx.can_restore_glevelvalue = 0
        end
        mmx.dPrevPos = {
            x = m.pos.x - mmx.prevPos.x,
            y = m.pos.y - mmx.prevPos.y,
            z = m.pos.z - mmx.prevPos.z
        }
        mmx.prevPos = { x = m.pos.x, y = m.pos.y, z = m.pos.z}

        -- This momentarily swaps to the vanilla walking action upon interacting with doors
        -- Because the code that handles door interaction is hardwired to ACT_WALKING
        if (m.marioObj.collidedObjInteractTypes & (INTERACT_WARP_DOOR | INTERACT_DOOR | INTERACT_KOOPA_SHELL) ~= 0 
        and m.action == ACT_WALKING_CUSTOM) then
            if (m.playerIndex == 0) then
                s.execute_walking = true
            end
            set_mario_action(m, ACT_WALKING, 0)
        elseif m.action == ACT_WALKING then
            if (m.playerIndex == 0) then
                s.execute_walking = false
            end
            set_mario_action(m, ACT_WALKING, 0)
        end
    elseif mmx.can_restore_glevelvalue == 1 then
        gLevelValues.fixCollisionBugs = defaultFixCollisionBugs
        gLevelValues.fixCollisionBugsRoundedCorners = defaultFixCollisionBugsRoundedCorners
        gLevelValues.fixCollisionBugsPickBestWall = defaultFixCollisionBugsPickBestWall
        mmx.can_restore_glevelvalue = 0
    end
end

-------------------------------------
---- Before set action functions ----
-------------------------------------

-- ACT_DIVE
function before_act_dive(m, incomingAct)
    local mmx = gMmxStates[m.playerIndex]
    if (m.action & ACT_FLAG_AIR) == 0 then
        if (mmx.execute_punch) then
            return ACT_MOVE_PUNCHING
        end
    end
    mmx.smoothContinuityFlag = true
    return 1
end

-- ACT_CROUCH_SLIDE
function before_act_crouch_slide(m, incomingAct)
    if (m.playerIndex == 0) then
        m.marioObj.header.gfx.pos.y = m.pos.y
    end
    return 1
end

-- ACT_FREEFALL_LAND_STOP
-- ACT_FREEFALL_LAND
-- ACT_JUMP_LAND
function before_general_act_land(m, incomingAct)
    local s = gPlayerSyncTable[m.playerIndex]
    local mmx = gMmxStates[m.playerIndex]
    if (m.playerIndex == 0) then
        if s.character == 'x' then
            mmx_play_sound(SOUND_X_LAND, m.pos, 0.6)
        elseif s.character == 'zero' then
            mmx_play_sound(SOUND_ZERO_LAND, m.pos, 0.4)
        elseif s.character == 'vile' then
            mmx_play_sound(SOUND_VILE_STEP, m.pos, 0.35)
        end
    end
    mmx.land_timer = 0
    return ACT_FREEFALL_LAND_STOP
end

-- ACT_JUMP_KICK
-- ACT_LEDGE_GRAB
-- ACT_LEDGE_CLIMB_DOWN
-- ACT_LEDGE_CLIMB_FAST
function before_several_act_unused_smooth(m, incomingAct)
    local mmx = gMmxStates[m.playerIndex]
    mmx.smoothContinuityFlag = true
    if (m.action == ACT_HOLD_JUMP or m.action == ACT_HOLD_FREEFALL) then
        return ACT_FREEFALL_CUSTOM
    end
    return 1
end 

function before_several_act_jump_kick(m, incomingAct)
    return ACT_PUNCHING
end 

-- ACT_WALKING
-- ACT_FINISH_TURNING_AROUND
function before_act_walking(m, incomingAct)
    local s = gPlayerSyncTable[m.playerIndex]
    if (incomingAct == ACT_WALKING) then
        if (s.execute_walking) then
            return incomingAct
        end
        local floorClass = mario_get_floor_class(m)
        if (floorClass ~= SURFACE_CLASS_VERY_SLIPPERY) then
            local mag = math.min(m.intendedMag, 8)
            if (0.0 <= m.forwardVel and m.forwardVel < mag) then
                m.forwardVel = mag
            end
        end
        m.marioObj.oMarioWalkingPitch = 0
    end
    return ACT_WALKING_CUSTOM
end

-- ACT_MOVE_PUNCHING
function before_act_move_punching(m, incomingAct)
    local mmx = gMmxStates[m.playerIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    if (mmx.execute_punch) then
        return incomingAct
    end
    mmx.smoothContinuityFlag = true
    return 1
end

-- ACT_PUNCHING
function before_act_punching(m, incomingAct)
    local mmx = gMmxStates[m.playerIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    if (mmx.execute_punch) then
        return incomingAct
    end
    -- Just this line is enough, we don't need to smooth the continuity because the character is stationary
    m.marioObj.header.gfx.pos.y = m.pos.y
    return 1
end

-- ACT_FREEFALL
function before_act_freefall(m, incomingAct)
    return ACT_FREEFALL_CUSTOM
end

-- ACT_JUMP
-- ACT_STEEP_JUMP
-- ACT_DOUBLE_JUMP
-- ACT_BACKFLIP
-- ACT_SIDE_FLIP
function before_act_general_jump(m, incomingAct)
    local s = gPlayerSyncTable[m.playerIndex]
    -- Offset the jump so the player model doesn't slightly clip into the ground right after jumps
    m.pos.y = m.pos.y + MODEL_Y_OFFSET
    -- This code was found in the set_mario_action for ACT_JUMP
    m.marioObj.header.gfx.animInfo.animID = -1;
    set_mario_y_vel_based_on_fspeed(m, 43.0, 0.25);
    m.forwardVel = m.forwardVel * 0.8;
    if (s.character == 'x') then
        if s.x_shooting > 0 and m.playerIndex == 0 then
            s.x_shooting = 0
        end
        mmx_play_sound(SOUND_X_JUMP, m.pos, 0.3)
    elseif (s.character == 'vile') then
        mmx_play_sound(SOUND_VILE_JUMP, m.pos, 0.4)
    elseif (s.character == 'zero') then
        mmx_play_sound(SOUND_ZERO_JUMP, m.pos, 0.6)
    end
    return ACT_JUMP_CUSTOM
end

-- ACT_WATER_JUMP
function before_act_water_jump(m, incomingAct)
    if (m.playerIndex == 0) then
        set_camera_mode(m.area.camera, m.area.camera.defMode, 1)
    end
    return incomingAct
end

-- ACT_WALL_KICK_AIR
-- ACT_TOP_OF_POLE_JUMP
function before_act_pole_jump(m, incomingAct)
    -- Offset the jump so the player model doesn't slightly clip into the ground right after jumps
    m.pos.y = m.pos.y + MODEL_Y_OFFSET
    -- This code was found in the set_mario_action for ACT_JUMP
    m.marioObj.header.gfx.animInfo.animID = -1;
    set_mario_y_vel_based_on_fspeed(m, 65.0, 0.25);
    m.forwardVel = m.forwardVel * 0.8;
    return ACT_JUMP_CUSTOM
end

-- ACT_IDLE
function before_act_idle(m, incomingAct)
    set_anim_to_frame(m, 1)
    return incomingAct
end

-- ACT_AIR_HIT_WALL
function before_act_air_hit_wall(m, incomingAct)
    return ACT_AIR_HIT_WALL_CUSTOM
end

-- ACT_GROUND_POUND
function before_act_ground_pound(m, incomingAct)
    local s = gPlayerSyncTable[m.playerIndex]
    if (s.character == 'zero') then
        return ACT_HYOURETSUZAN
    else
        return incomingAct
    end
end

local convert_actions = {
    [ACT_WALKING] = before_act_walking,
    [ACT_DIVE] = before_act_dive,
    [ACT_CROUCH_SLIDE] = before_act_crouch_slide,
    [ACT_FREEFALL_LAND_STOP] = before_general_act_land,
    [ACT_FREEFALL_LAND] = before_general_act_land,
    [ACT_JUMP_LAND] = before_general_act_land,
    [ACT_JUMP_KICK] = before_several_act_jump_kick,
    [ACT_LEDGE_GRAB] = before_several_act_unused_smooth,
    [ACT_LEDGE_CLIMB_DOWN] = before_several_act_unused_smooth,
    [ACT_LEDGE_CLIMB_FAST] = before_several_act_unused_smooth,
    [ACT_FINISH_TURNING_AROUND] = before_act_walking,
    [ACT_MOVE_PUNCHING] = before_act_move_punching,
    [ACT_PUNCHING] = before_act_punching,
    [ACT_FREEFALL] = before_act_freefall,
    [ACT_JUMP] = before_act_general_jump,
    [ACT_WALL_KICK_AIR] = before_act_pole_jump,
    [ACT_TOP_OF_POLE_JUMP] = before_act_pole_jump,
    [ACT_STEEP_JUMP] = before_act_general_jump,
    [ACT_DOUBLE_JUMP] = before_act_general_jump,
    [ACT_BACKFLIP] = before_act_general_jump,
    [ACT_SIDE_FLIP] = before_act_general_jump,
    [ACT_WATER_JUMP] = before_act_water_jump,
    [ACT_IDLE] = before_act_idle,
    [ACT_AIR_HIT_WALL] = before_act_air_hit_wall,
    [ACT_GROUND_POUND] = before_act_ground_pound
}

local before_set_mario_action = function(m, incomingAct)
    if (m.action) == ACT_RAIKOUSEN and incomingAct == ACT_IDLE then
        m.marioObj.oIntangibleTimer = 0
        m.marioObj.header.gfx.node.flags = m.marioObj.header.gfx.node.flags &~ GRAPH_RENDER_INVISIBLE
    end
    local s = gPlayerSyncTable[m.playerIndex]
    if active_player(m) and s.character ~= 'none' then
        if convert_actions[incomingAct] then
            return convert_actions[incomingAct](m, incomingAct)
        end
        return incomingAct
    end
end

local on_receive_spawn_data = function(table)
    local np = network_player_from_global_index(table.m)
    local m = gMarioStates[np.localIndex]
    if (active_player(m)) then
        if (table.type == 'shot_sound') then
            if (table.shot_idx == 1) then
                mmx_play_sound(SOUND_X_SHOT1, m.pos, table.intensity)
            elseif (table.shot_idx == 2) then
                mmx_play_sound(SOUND_X_SHOT2, m.pos, table.intensity)
            elseif (table.shot_idx == 3) then
                mmx_play_sound(SOUND_X_SHOT3, m.pos, table.intensity)
            elseif (table.shot_idx == 4) then
                mmx_play_sound(SOUND_X_SHOT_MAX, m.pos, table.intensity)
            end
        elseif (table.type == 'napalm') then
            spawn_napalm(m, table.grounded)
        elseif (table.type == 'charge') then
            spawn_charge(m, table.chargeLevel)
        elseif (table.type == 'charge_sound') then
            local soundtable = {
                [1] = SOUND_X_CHARGE_BEGIN,
                [2] = SOUND_X_CHARGE_LOOP,
                [3] = SOUND_X_CHARGE_MAX_BEGIN,
                [4] = SOUND_X_CHARGE_MAX_LOOP,
                [5] = SOUND_X_GIGA_CHARGE_HOLD
            }
            mmx_play_sound(soundtable[table.chargeLevel], m.pos, table.intensity)
        end
    end
end

hook_event(HOOK_ON_PACKET_RECEIVE, on_receive_spawn_data)

hook_event(HOOK_MARIO_UPDATE, mario_update)
hook_event(HOOK_BEFORE_SET_MARIO_ACTION, before_set_mario_action)


hook_event(HOOK_ON_HUD_RENDER_BEHIND, function()
    djui_hud_set_resolution(RESOLUTION_N64)
    djui_hud_set_font(FONT_HUD)
    djui_hud_set_color(255, 255, 255, 255)
    local m = gMarioStates[0]
    local s = gPlayerSyncTable[m.playerIndex]
    if (m.action ~= ACT_END_PEACH_CUTSCENE and m.action ~= ACT_END_WAVING_CUTSCENE and (m.action ~= ACT_INTRO_CUTSCENE or introTimer >= 1195)) then
        if (s.character == 'vile') then
            vile_meter_render()
        end
        if (s.character ~= 'none') then
            render_hud_mario_lives()
        else    
            hud_set_value(HUD_DISPLAY_FLAGS, hud_get_value(HUD_DISPLAY_FLAGS) | HUD_DISPLAY_FLAG_LIVES)
        end
    end
end)

hook_event(HOOK_ON_LEVEL_INIT, function()
    --djui_chat_message_create(tostring(gLevelValues.fixCollisionBugs))
    pauseExited = false
    defaultFixCollisionBugs = gLevelValues.fixCollisionBugs
    defaultFixCollisionBugsRoundedCorners = gLevelValues.fixCollisionBugsRoundedCorners
    defaultFixCollisionBugsPickBestWall = gLevelValues.fixCollisionBugsPickBestWall
end)

hook_event(HOOK_ON_PAUSE_EXIT, function()
    pauseExited = true
end)

local on_interact = function(m, o, intType)
    local s = gPlayerSyncTable[m.playerIndex]
    if (s.character == 'none') then
        return
    end
    if (m.action == ACT_VILE_DASH or m.action == ACT_SHIPPUGA) then
        if (intType & (INTERACT_GRABBABLE) ~= 0) and o.oInteractionSubtype & (INT_SUBTYPE_NOT_GRABBABLE) == 0 then
            m.interactObj = o
            m.input = m.input | INPUT_INTERACT_OBJ_GRABBABLE
            if o.oSyncID ~= 0 then
                network_send_object(o, true)
            end
        end
    end
end

hook_event(HOOK_ALLOW_INTERACT, on_interact)