local sins, coss, cur_obj_hide, smlua_model_util_get_id, spawn_non_sync_object, cur_obj_unhide, hook_behavior, obj_get_nearest_object_with_behavior_id,
network_player_from_global_index, obj_set_model_extended, baseDeleteConditionTable, calculate_yaw, obj_check_overlap_with_hitbox_params,
obj_check_hitbox_overlap, network_init_object
= sins, coss, cur_obj_hide, smlua_model_util_get_id, spawn_non_sync_object, cur_obj_unhide, hook_behavior, obj_get_nearest_object_with_behavior_id,
network_player_from_global_index, obj_set_model_extended, baseDeleteConditionTable, calculate_yaw, obj_check_overlap_with_hitbox_params,
obj_check_hitbox_overlap, network_init_object

-- Debug model
-- hitboxes are cylinders in mario 64
E_model_hitcylinder = smlua_model_util_get_id('hitcylinder_geo')

zsaber_active_hits = {}
zsaber_active_cooldown = {}
zsaber_time_stopped = {}
zsaber_time_stop_cooldown = {}


-----------------------------------------------------------------
-----------------------------------------------------------------
----- INTERACTIONS ----------------------------------------------
-----------------------------------------------------------------
-----------------------------------------------------------------

function spawn_slash_fx(o, saber_pos, clank)
    if (clank == 1) then
        mmx_play_sound(SOUND_CLANK_HIT, {x = o.oPosX, y = o.oPosY, z = o.oPosZ}, 0.4)  
    else
        mmx_play_sound(SOUND_ZERO_SABER_HIT, {x = o.oPosX, y = o.oPosY, z = o.oPosZ}, 0.5)
    end
    local posx = saber_pos.x - (saber_pos.x - o.oPosX) / 2
    local posy = saber_pos.y - (saber_pos.y - o.oPosY) / 2
    local posz = saber_pos.z - (saber_pos.z - o.oPosZ) / 2
    spawn_non_sync_object(id_bhvWallspark, E_model_saber_dmg, posx , posy, posz, function (obj)
        obj.oMoveAngleYaw = calculate_yaw(saber_pos, {x = o.oPosX, y = o.oPosY, z = o.oPosZ})
    end)
end

function spawn_destroy_zero_explosion(o, size)
    spawn_non_sync_object(id_bhvWhitePuffSmoke2, E_MODEL_EXPLOSION, o.oPosX , o.oPosY + 20 * size, o.oPosZ , function(obj)
        obj_scale(obj, size)
    end)
    mmx_play_sound(SOUND_ZERO_SABER_DESTROY, {x = o.oPosX, y = o.oPosY, z = o.oPosZ}, 0.9)
end

-------------------
--GENERAL ENEMIES--
-------------------

function saber_interact_srnormal(o, saber_syncid, saber_dmg, saber_pos, playerIndex)
    if (o.oInteractStatus == ATTACK_FAST_ATTACK | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED) then
        return false
    end
    spawn_slash_fx(o, saber_pos, 0)
    if zsaber_active_hits[saber_syncid] ~= nil and not zsaber_active_hits[saber_syncid][o.oSyncID] then
        zsaber_active_hits[saber_syncid][o.oSyncID] = true
    end
    o.oInteractStatus = ATTACK_PUNCH | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED
    return true
end

function saber_interact_normal(o, saber_syncid, saber_dmg, saber_pos, playerIndex)
    if (o.oInteractStatus == ATTACK_FAST_ATTACK | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED) then
        return false
    end
    spawn_slash_fx(o, saber_pos, 0)
    if zsaber_active_hits[saber_syncid] ~= nil and not zsaber_active_hits[saber_syncid][o.oSyncID] then
        zsaber_active_hits[saber_syncid][o.oSyncID] = true
    end
    o.oInteractStatus = ATTACK_PUNCH | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED
    if o.oSyncID ~= 0 then
        network_send_object(o, false)
    end
    return true
end

function saber_interact_chuckya(o, saber_syncid, saber_dmg, saber_pos, playerIndex)
    if playerIndex == 0 then o.oMmxHealth = o.oMmxHealth - saber_dmg end
    spawn_slash_fx(o, saber_pos, 0)
    if zsaber_active_hits[saber_syncid] ~= nil and not zsaber_active_hits[saber_syncid][o.oSyncID] then
        zsaber_active_hits[saber_syncid][o.oSyncID] = true
    end
    if (o.oMmxHealth <= 0) then
        spawn_destroy_zero_explosion(o, 1.2)
        o.usingObj = nil
        obj_mark_for_deletion(o)
        obj_spawn_loot_yellow_coins(o, 5, 20.0)
        spawn_mist_particles_with_sound(SOUND_OBJ_CHUCKYA_DEATH)
    end
    if o.oSyncID ~= 0 then
        network_send_object(o, false)
    end
    return true
end

function saber_interact_enemygeneral(o, saber_syncid, saber_dmg, saber_pos, playerIndex)
    if (o.oMmxHealth <= 0) or (o.oInteractStatus == ATTACK_FAST_ATTACK | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED) then
        return false
    end
    if playerIndex == 0 then o.oMmxHealth = o.oMmxHealth - saber_dmg end
    spawn_slash_fx(o, saber_pos, 0)
    if zsaber_active_hits[saber_syncid] ~= nil and not zsaber_active_hits[saber_syncid][o.oSyncID] then
        zsaber_active_hits[saber_syncid][o.oSyncID] = true
    end
    if (o.oMmxHealth <= 0) then
        spawn_destroy_zero_explosion(o, 1)
        o.oInteractStatus = ATTACK_GROUND_POUND_OR_TWIRL | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED
    end
    if o.oSyncID ~= 0 then
        network_send_object(o, false)
    end
    return true
end

function saber_interact_bigenemygeneral(o, saber_syncid, saber_dmg, saber_pos, playerIndex)
    if (o.oMmxHealth <= 0) or (o.oInteractStatus == ATTACK_FAST_ATTACK | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED) then
        return false
    end
    if playerIndex == 0 then o.oMmxHealth = o.oMmxHealth - saber_dmg end
    spawn_slash_fx(o, saber_pos, 0)
    if zsaber_active_hits[saber_syncid] ~= nil and not zsaber_active_hits[saber_syncid][o.oSyncID] then
        zsaber_active_hits[saber_syncid][o.oSyncID] = true
    end
    if (o.oMmxHealth <= 0) then
        spawn_destroy_zero_explosion(o, 1.2)
        o.oMmxHealth = o.oMmxInitialHealth
        o.oInteractStatus = ATTACK_GROUND_POUND_OR_TWIRL | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED
    end
    if o.oSyncID ~= 0 then
        network_send_object(o, false)
    end
    return true
end

-----------------------
--BOB-OMB BATTLEFIELD--
-----------------------

function saber_interact_koopa(o, saber_syncid, saber_dmg, saber_pos, playerIndex)
    if (o.oMmxHealth <= 0) or (o.oInteractStatus == ATTACK_FAST_ATTACK | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED)
    or o.oKoopaMovementType >= KOOPA_BP_KOOPA_THE_QUICK_BASE then
        return false
    end
    if playerIndex == 0 then o.oMmxHealth = o.oMmxHealth - saber_dmg end
    spawn_slash_fx(o, saber_pos, 0)
    if zsaber_active_hits[saber_syncid] ~= nil and not zsaber_active_hits[saber_syncid][o.oSyncID] then
        zsaber_active_hits[saber_syncid][o.oSyncID] = true
    end
    if (o.oMmxHealth <= 0) then
        spawn_destroy_zero_explosion(o, 1)
        o.oMmxHealth = o.oMmxInitialHealth
        o.oInteractStatus = ATTACK_GROUND_POUND_OR_TWIRL | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED
    end
    if o.oSyncID ~= 0 then
        network_send_object(o, false)
    end
    return true
end

function saber_interact_bobomb(o, saber_syncid, saber_dmg, saber_pos, playerIndex)
    if o.oAction == BOBOMB_ACT_EXPLODE then
        return false
    end
    if playerIndex == 0 then o.oMmxHealth = o.oMmxHealth - saber_dmg end
    spawn_slash_fx(o, saber_pos, 0)
    if zsaber_active_hits[saber_syncid] ~= nil and not zsaber_active_hits[saber_syncid][o.oSyncID] then
        zsaber_active_hits[saber_syncid][o.oSyncID] = true
    end
    if (o.oMmxHealth <= 0) then
        spawn_destroy_zero_explosion(o, 1)
        o.oAction = BOBOMB_ACT_EXPLODE
        o.oMmxHealth = o.oMmxInitialHealth
    end
    if o.oSyncID ~= 0 then
        network_send_object(o, false)
    end
    return true
end

function saber_interact_chainchomp(o, saber_syncid, saber_dmg, saber_pos, playerIndex)
    if playerIndex == 0 then o.oMmxHealth = o.oMmxHealth - saber_dmg end
    spawn_slash_fx(o, saber_pos, 0)
    if zsaber_active_hits[saber_syncid] ~= nil and not zsaber_active_hits[saber_syncid][o.oSyncID] then
        zsaber_active_hits[saber_syncid][o.oSyncID] = true
    end
    if (o.oMmxHealth <= 0) then
        spawn_destroy_zero_explosion(o, 2)
        spawn_mist_particles_with_sound(SOUND_GENERAL_WALL_EXPLOSION)
        spawn_triangle_break_particles(20, 138, 3, 4);
        obj_mark_for_deletion(o)
    end
    if o.oSyncID ~= 0 then
        network_send_object(o, false)
    end
    return true
end

function saber_interact_waterbomb(o, saber_syncid, saber_dmg, saber_pos, playerIndex)
    if playerIndex == 0 then o.oMmxHealth = o.oMmxHealth - saber_dmg end
    spawn_slash_fx(o, saber_pos, 0)
    if zsaber_active_hits[saber_syncid] ~= nil and not zsaber_active_hits[saber_syncid][o.oSyncID] then
        zsaber_active_hits[saber_syncid][o.oSyncID] = true
    end
    if (o.oMmxHealth <= 0) then
        spawn_destroy_zero_explosion(o, 1)
        o.oAction = WATER_BOMB_ACT_EXPLODE
    end
    if o.oSyncID ~= 0 then
        network_send_object(o, false)
    end
    return true
end

function saber_interact_kingbobomb(o, saber_syncid, saber_dmg, saber_pos, playerIndex)
    if (o.oFlags & OBJ_FLAG_HOLDABLE) == 0 or o.oAction == 8 or o.oAction == 7 then
        return false
    end
    if playerIndex == 0 then o.oMmxHealth = o.oMmxHealth - saber_dmg end
    spawn_slash_fx(o, saber_pos, 0)
    if zsaber_active_hits[saber_syncid] ~= nil and not zsaber_active_hits[saber_syncid][o.oSyncID] then
        zsaber_active_hits[saber_syncid][o.oSyncID] = true
    end
    if (o.oMmxHealth <= 0) then
        spawn_destroy_zero_explosion(o, 1.5)
        o.oAction = 7
    end
    if o.oSyncID ~= 0 then
        network_send_object(o, false)
    end
    return true
end

function saber_interact_breakablebox(o, saber_syncid, saber_dmg, saber_pos, playerIndex)
    if playerIndex == 0 then o.oMmxHealth = o.oMmxHealth - saber_dmg end
    spawn_slash_fx(o, saber_pos, 0)
    if zsaber_active_hits[saber_syncid] ~= nil and not zsaber_active_hits[saber_syncid][o.oSyncID] then
        zsaber_active_hits[saber_syncid][o.oSyncID] = true
    end
    if ((o.oMmxHealth <= 0 and playerIndex == 0) or (playerIndex ~= 0 and o.oMmxHealth <= saber_dmg)) then
        spawn_destroy_zero_explosion(o, 1.2)
        o.oInteractStatus =  ATTACK_PUNCH | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED
    end
    if o.oSyncID ~= 0 then
        network_send_object(o, false)
    end
    return true
end

function saber_interact_breakableboxsmall(o, saber_syncid, saber_dmg, saber_pos, playerIndex)
    if playerIndex == 0 then o.oMmxHealth = o.oMmxHealth - saber_dmg end
    spawn_slash_fx(o, saber_pos, 0)
    if zsaber_active_hits[saber_syncid] ~= nil and not zsaber_active_hits[saber_syncid][o.oSyncID] then
        zsaber_active_hits[saber_syncid][o.oSyncID] = true
    end
    if (o.oMmxHealth <= 0) then
        spawn_destroy_zero_explosion(o, 1)
        o.oInteractStatus = ATTACK_KICK_OR_TRIP | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED | INT_STATUS_STOP_RIDING
    end
    if o.oSyncID ~= 0 then
        network_send_object(o, false)
    end
    return true
end

function saber_interact_exclamationbox(o, saber_syncid, saber_dmg, saber_pos, playerIndex)
    if o.oAction == 5 or o.oAction == 6 or o.oAction == 3 or o.oAction == 1 then
        return false
    end
    if playerIndex == 0 then o.oMmxHealth = o.oMmxHealth - saber_dmg end
    spawn_slash_fx(o, saber_pos, 0)
    if zsaber_active_hits[saber_syncid] ~= nil and not zsaber_active_hits[saber_syncid][o.oSyncID] then
        zsaber_active_hits[saber_syncid][o.oSyncID] = true
    end
    if (o.oMmxHealth <= 0) then
        spawn_destroy_zero_explosion(o, 1)
        o.oInteractStatus = ATTACK_KICK_OR_TRIP | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED
        o.oMmxHealth = o.oMmxInitialHealth
    end
    if o.oSyncID ~= 0 then
        network_send_object(o, false)
    end
    return true
end

--------------------
--WHOMP'S FORTRESS--
--------------------

function saber_interact_breakablewall(o, saber_syncid, saber_dmg, saber_pos, playerIndex)
    if o.oMmxHealth <= 0 then
        return false
    end
    if playerIndex == 0 then o.oMmxHealth = o.oMmxHealth - saber_dmg end
    spawn_slash_fx(o, saber_pos, 0)
    if zsaber_active_hits[saber_syncid] ~= nil and not zsaber_active_hits[saber_syncid][o.oSyncID] then
        zsaber_active_hits[saber_syncid][o.oSyncID] = true
    end
    if (o.oMmxHealth <= 0) then
        spawn_destroy_zero_explosion(o, 1.5)
        spawn_mist_particles_with_sound(SOUND_GENERAL_WALL_EXPLOSION)
        --obj_explode_and_spawn_coins(80, 0)
        obj_mark_for_deletion(o)
    end
    if o.oSyncID ~= 0 then
        network_send_object(o, false)
    end
    return true
end

function saber_interact_bridge(o, saber_syncid, saber_dmg, saber_pos, playerIndex)
    if not (o.oFaceAnglePitch > -0x4000) then
        return false
    end
    if playerIndex == 0 then o.oMmxHealth = o.oMmxHealth - saber_dmg end
    spawn_slash_fx(o, saber_pos, 0)
    if zsaber_active_hits[saber_syncid] ~= nil and not zsaber_active_hits[saber_syncid][o.oSyncID] then
        zsaber_active_hits[saber_syncid][o.oSyncID] = true
    end
    if (o.oMmxHealth <= 0) then
        spawn_destroy_zero_explosion(o, 1.2)
        o.oAction = 2
    end
    if o.oSyncID ~= 0 then
        network_send_object(o, false)
    end
    return true
end

function saber_interact_whomp(o, saber_syncid, saber_dmg, saber_pos, playerIndex)
    if playerIndex == 0 then o.oMmxHealth = o.oMmxHealth - saber_dmg end
    spawn_slash_fx(o, saber_pos, 0)
    if zsaber_active_hits[saber_syncid] ~= nil and not zsaber_active_hits[saber_syncid][o.oSyncID] then
        zsaber_active_hits[saber_syncid][o.oSyncID] = true
    end
    if (o.oMmxHealth <= 0) then
        spawn_destroy_zero_explosion(o, 1.2)
        o.oNumLootCoins = 5
        obj_spawn_loot_yellow_coins(o, 5, 20.0)
        o.oAction = 8
    end
    if o.oSyncID ~= 0 then
        network_send_object(o, false)
    end
    return true
end

function saber_interact_whompking(o, saber_syncid, saber_dmg, saber_pos, playerIndex)
    if o.oAction == 8 or o.oAction == 0 or o.oAction == 9 then
        return false
    end
    if playerIndex == 0 then o.oMmxHealth = o.oMmxHealth - saber_dmg end
    spawn_slash_fx(o, saber_pos, 0)
    if zsaber_active_hits[saber_syncid] ~= nil and not zsaber_active_hits[saber_syncid][o.oSyncID] then
        zsaber_active_hits[saber_syncid][o.oSyncID] = true
    end
    if (o.oMmxHealth <= 0) then
        spawn_destroy_zero_explosion(o, 2)
        play_sound(SOUND_OBJ2_WHOMP_SOUND_SHORT, o.header.gfx.cameraToObject)
        play_sound(SOUND_OBJ_KING_WHOMP_DEATH, o.header.gfx.cameraToObject)
        o.oHealth = 0
        o.oAction = 8
    end
    if o.oSyncID ~= 0 then
        network_send_object(o, false)
    end
    return true
end

function saber_interact_piranhaplant(o, saber_syncid, saber_dmg, saber_pos, playerIndex)
    if o.oAction == PIRANHA_PLANT_ACT_SHRINK_AND_DIE 
    or o.oAction == PIRANHA_PLANT_ACT_ATTACKED or o.oAction == PIRANHA_PLANT_ACT_WAIT_TO_RESPAWN then
        return false
    end
    if playerIndex == 0 then o.oMmxHealth = o.oMmxHealth - saber_dmg end
    spawn_slash_fx(o, saber_pos, 0)
    if zsaber_active_hits[saber_syncid] ~= nil and not zsaber_active_hits[saber_syncid][o.oSyncID] then
        zsaber_active_hits[saber_syncid][o.oSyncID] = true
    end
    if (o.oMmxHealth <= 0) then
        spawn_destroy_zero_explosion(o, 1)
        stop_secondary_music(50)
        o.oAction = PIRANHA_PLANT_ACT_ATTACKED
        o.oMmxHealth = o.oMmxInitialHealth
    end
    if o.oSyncID ~= 0 then
        network_send_object(o, false)
    end
    return true
end

function saber_interact_bulletbill(o, saber_syncid, saber_dmg, saber_pos, playerIndex)
    if o.oAction == 3 or o.oAction == 4 then
        return false
    end
    if playerIndex == 0 then o.oMmxHealth = o.oMmxHealth - saber_dmg end
    spawn_slash_fx(o, saber_pos, 0)
    if zsaber_active_hits[saber_syncid] ~= nil and not zsaber_active_hits[saber_syncid][o.oSyncID] then
        zsaber_active_hits[saber_syncid][o.oSyncID] = true
    end
    if (o.oMmxHealth <= 0) then
        spawn_destroy_zero_explosion(o, 1.2)
        o.oAction = 3
        spawn_non_sync_object(id_bhvExplosion, E_MODEL_EXPLOSION, o.oPosX, o.oPosY, o.oPosZ, nil)
        o.oMmxHealth = o.oMmxInitialHealth
    end
    if o.oSyncID ~= 0 then
        network_send_object(o, false)
    end
    return true
end

----------------------
--COOL COOL MOUNTAIN--
----------------------

function saber_interact_mrblizzard(o, saber_syncid, saber_dmg, saber_pos, playerIndex)
    if o.oAction == MR_BLIZZARD_ACT_DEATH then
        return false
    end
    if playerIndex == 0 then o.oMmxHealth = o.oMmxHealth - saber_dmg end
    spawn_slash_fx(o, saber_pos, 0)
    if zsaber_active_hits[saber_syncid] ~= nil and not zsaber_active_hits[saber_syncid][o.oSyncID] then
        zsaber_active_hits[saber_syncid][o.oSyncID] = true
    end
    if (o.oMmxHealth <= 0) then
        spawn_destroy_zero_explosion(o, 1)
        o.oAction = MR_BLIZZARD_ACT_DEATH
        o.oMmxHealth = o.oMmxInitialHealth
    end
    if o.oSyncID ~= 0 then
        network_send_object(o, false)
    end
    return true
end

----------------------
--BIG BOO'S HUNT------
----------------------
function saber_interact_boo(o, saber_syncid, saber_dmg, saber_pos, playerIndex)
    if (o.oMmxHealth <= 0) or (o.oInteractStatus == ATTACK_FAST_ATTACK | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED) then
        return false
    end
    if playerIndex == 0 then o.oMmxHealth = o.oMmxHealth - saber_dmg end
    spawn_slash_fx(o, saber_pos, 0)
    if zsaber_active_hits[saber_syncid] ~= nil and not zsaber_active_hits[saber_syncid][o.oSyncID] then
        zsaber_active_hits[saber_syncid][o.oSyncID] = true
    end
    if (o.oMmxHealth <= 0) then
        spawn_destroy_zero_explosion(o, 1)
        if o.oHealth > 1 then
            o.oMmxHealth = o.oMmxInitialHealth
        end
        o.oAction = 3
    end
    if o.oSyncID ~= 0 then
        network_send_object(o, false)
    end
    return true
end

----------------------
--SHIFTING SAND LAND--
----------------------
function saber_interact_klepto(o, saber_syncid, saber_dmg, saber_pos, playerIndex)
    if o.oInteractStatus == ATTACK_FROM_ABOVE | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED | INT_STATUS_STOP_RIDING then
        return false
    end
    if playerIndex == 0 then o.oMmxHealth = o.oMmxHealth - saber_dmg end
    spawn_slash_fx(o, saber_pos, 0)
    if zsaber_active_hits[saber_syncid] ~= nil and not zsaber_active_hits[saber_syncid][o.oSyncID] then
        zsaber_active_hits[saber_syncid][o.oSyncID] = true
    end
    if (o.oMmxHealth <= 0) then
        spawn_destroy_zero_explosion(o, 1)
        o.oInteractStatus = ATTACK_FROM_ABOVE | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED | INT_STATUS_STOP_RIDING
        o.oMmxHealth = o.oMmxInitialHealth
    end
    if o.oSyncID ~= 0 then
        network_send_object(o, false)
    end
    return true
end

function saber_interact_jumping_box(o, saber_syncid, saber_dmg, saber_pos, playerIndex)
    if playerIndex == 0 then o.oMmxHealth = o.oMmxHealth - saber_dmg end
    spawn_slash_fx(o, saber_pos, 0)
    if zsaber_active_hits[saber_syncid] ~= nil and not zsaber_active_hits[saber_syncid][o.oSyncID] then
        zsaber_active_hits[saber_syncid][o.oSyncID] = true
    end
    if (o.oMmxHealth <= 0) then
        spawn_destroy_zero_explosion(o, 1)
        o.oInteractStatus = INT_STATUS_STOP_RIDING
    end
    if o.oSyncID ~= 0 then
        network_send_object(o, false)
    end
    return true
end

function saber_interact_eyerokhand(o, saber_syncid, saber_dmg, saber_pos, playerIndex)
    if o.oAction == EYEROK_HAND_ACT_DIE or o.oAction == EYEROK_HAND_ACT_DEAD then
        return false
    end
    if playerIndex == 0 then o.oMmxHealth = o.oMmxHealth - saber_dmg end
    spawn_slash_fx(o, saber_pos, 0)
    if zsaber_active_hits[saber_syncid] ~= nil and not zsaber_active_hits[saber_syncid][o.oSyncID] then
        zsaber_active_hits[saber_syncid][o.oSyncID] = true
    end
    if (o.oMmxHealth <= 0) then
        spawn_destroy_zero_explosion(o, 1)
        o.oInteractStatus = INT_STATUS_STOP_RIDING
        o.parentObj.oEyerokBossNumHands = o.parentObj.oEyerokBossNumHands - 1
        o.oAction = EYEROK_HAND_ACT_DIE
    end
    if o.oSyncID ~= 0 then
        network_send_object(o, false)
    end
    return true
end

--------------------
--LETHAL LAVA LAND--
--------------------
function saber_interact_mri(o, saber_syncid, saber_dmg, saber_pos, playerIndex)
    if o.oAction == 3 then
        return false
    end
    if playerIndex == 0 then o.oMmxHealth = o.oMmxHealth - saber_dmg end
    spawn_slash_fx(o, saber_pos, 0)
    if zsaber_active_hits[saber_syncid] ~= nil and not zsaber_active_hits[saber_syncid][o.oSyncID] then
        zsaber_active_hits[saber_syncid][o.oSyncID] = true
    end
    if (o.oMmxHealth <= 0) then
        spawn_destroy_zero_explosion(o, 1)
        o.oAction = 3
        o.oTimer = 104
    end
    if o.oSyncID ~= 0 then
        network_send_object(o, false)
    end
    return true
end

function saber_interact_bully(o, saber_syncid, saber_dmg, saber_pos, playerIndex)
    o.oMoveAngleYaw = calculate_yaw(saber_pos, {x = o.oPosX, y = o.oPosY, z = o.oPosZ})
    spawn_slash_fx(o, saber_pos, 1)
    if zsaber_active_hits[saber_syncid] ~= nil and not zsaber_active_hits[saber_syncid][o.oSyncID] then
        zsaber_active_hits[saber_syncid][o.oSyncID] = true
    end
    o.oInteractStatus = ATTACK_FAST_ATTACK | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED
    o.oForwardVel = 35
    if o.oSyncID ~= 0 then
        network_send_object(o, false)
    end
    return true
end

---------------------
---TINY HUGE ISLAND--
---------------------

function saber_interact_spiny(o, saber_syncid, saber_dmg, saber_pos, playerIndex)
    if playerIndex == 0 then o.oMmxHealth = o.oMmxHealth - saber_dmg end
    spawn_slash_fx(o, saber_pos, 0)
    if zsaber_active_hits[saber_syncid] ~= nil and not zsaber_active_hits[saber_syncid][o.oSyncID] then
        zsaber_active_hits[saber_syncid][o.oSyncID] = true
    end
    if (o.oMmxHealth <= 0) then
        spawn_destroy_zero_explosion(o, 1)
        spawn_mist_particles()
        play_sound(SOUND_OBJ_DEFAULT_DEATH, o.header.gfx.cameraToObject)
        o.oNumLootCoins = 1
        obj_spawn_loot_yellow_coins(o, 1, 20.0);
        obj_mark_for_deletion(o)
    end
    if o.oSyncID ~= 0 then
        network_send_object(o, false)
    end
    return true
end

function saber_interact_firepiranhaplant(o, saber_syncid, saber_dmg, saber_pos, playerIndex)
    if o.oAction == FIRE_PIRANHA_PLANT_ACT_HIDE then
        return false
    end
    if playerIndex == 0 then o.oMmxHealth = o.oMmxHealth - saber_dmg end
    spawn_slash_fx(o, saber_pos, 0)
    if zsaber_active_hits[saber_syncid] ~= nil and not zsaber_active_hits[saber_syncid][o.oSyncID] then
        zsaber_active_hits[saber_syncid][o.oSyncID] = true
    end
    if (o.oMmxHealth <= 0) then
        spawn_destroy_zero_explosion(o, 1)
        o.oInteractStatus = ATTACK_FAST_ATTACK | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED
        o.oMmxHealth = o.oMmxInitialHealth
    end
    if o.oSyncID ~= 0 then
        network_send_object(o, false)
    end
    return true
end

function saber_interact_wigglerhead(o, saber_syncid, saber_dmg, saber_pos, playerIndex)
    if o.oIntangibleTimer < 0 then
        return false
    end
    if playerIndex == 0 then o.oMmxHealth = o.oMmxHealth - saber_dmg end
    spawn_slash_fx(o, saber_pos, 0)
    if zsaber_active_hits[saber_syncid] ~= nil and not zsaber_active_hits[saber_syncid][o.oSyncID] then
        zsaber_active_hits[saber_syncid][o.oSyncID] = true
    end
    if (o.oMmxHealth <= 0) then
        spawn_destroy_zero_explosion(o, 1)
        o.oInteractStatus = ATTACK_FROM_ABOVE | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED | INT_STATUS_STOP_RIDING
        o.oMmxHealth = o.oMmxInitialHealth
    end
    if o.oSyncID ~= 0 then
        network_send_object(o, false)
    end
    return true
end

------------------------
---TALL TALL MOUNTAIN---
------------------------

function saber_interact_monty_mole(o, saber_syncid, saber_dmg, saber_pos, playerIndex)
    if o.oAction == MONTY_MOLE_ACT_SELECT_HOLE and 
    o.oInteractStatus == ATTACK_FAST_ATTACK | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED then
        return false
    end
    if playerIndex == 0 then o.oMmxHealth = o.oMmxHealth - saber_dmg end
    spawn_slash_fx(o, saber_pos, 0)
    if zsaber_active_hits[saber_syncid] ~= nil and not zsaber_active_hits[saber_syncid][o.oSyncID] then
        zsaber_active_hits[saber_syncid][o.oSyncID] = true
    end
    if (o.oMmxHealth <= 0) then
        spawn_destroy_zero_explosion(o, 1)
        o.oInteractStatus = ATTACK_FAST_ATTACK | INT_STATUS_INTERACTED | INT_STATUS_WAS_ATTACKED
        o.oMmxHealth = o.oMmxInitialHealth
    end
    if o.oSyncID ~= 0 then
        network_send_object(o, false)
    end
    return true
end

----------------------------
--BOWSER IN THE DARK WORLD--
----------------------------

function saber_interact_bowser(o, saber_syncid, saber_dmg, saber_pos, playerIndex)
    if o.oAction == 19 or o.oAction == 4 or o.oAction == 1 then
        return false
    end
    if playerIndex == 0 then o.oMmxHealth = o.oMmxHealth - saber_dmg end
    spawn_slash_fx(o, saber_pos, 0)
    if zsaber_active_hits[saber_syncid] ~= nil and not zsaber_active_hits[saber_syncid][o.oSyncID] then
        zsaber_active_hits[saber_syncid][o.oSyncID] = true
    end
    if (o.oMmxHealth <= 0) then
        o.oHealth = o.oHealth - 1
        spawn_destroy_zero_explosion(o, 1.8)
        if o.oHealth <= 0 then
            o.oAction = 4
        else
            o.oMmxHealth = o.oMmxInitialHealth
            o.oAction = 12
        end
        o.oMoveFlags = 0
        o.oForwardVel = 0
    end
    if o.oSyncID ~= 0 then
        network_send_object(o, false)
    end
    return true
end

function saber_interact_bowser_bomb(o, saber_syncid, saber_dmg, saber_pos, playerIndex)
    if playerIndex == 0 then o.oMmxHealth = o.oMmxHealth - saber_dmg end
    spawn_slash_fx(o, saber_pos, 0)
    if zsaber_active_hits[saber_syncid] ~= nil and not zsaber_active_hits[saber_syncid][o.oSyncID] then
        zsaber_active_hits[saber_syncid][o.oSyncID] = true
    end
    if (o.oMmxHealth <= 0) then
        spawn_non_sync_object(id_bhvExplosion, E_MODEL_EXPLOSION, o.oPosX, o.oPosY, o.oPosZ, nil)
        obj_mark_for_deletion(o)
    end
    if o.oSyncID ~= 0 then
        network_send_object(o, false)
    end
    return true
end


-----------------------------------------------------------------
-----------------------------------------------------------------
----- INTERACTIONS HANDLING -------------------------------------
-----------------------------------------------------------------
-----------------------------------------------------------------

saberhurtableenemy = {
    -- BOB
    [id_bhvGoomba] = saber_interact_enemygeneral, 
    [id_bhvKoopa] = saber_interact_koopa,
    [id_bhvBobomb] = saber_interact_bobomb,
    [id_bhvChainChomp] = saber_interact_chainchomp,
    [id_bhvChainChompGate] = saber_interact_chainchomp,
    [id_bhvWaterBomb] = saber_interact_waterbomb,
    [id_bhvKingBobomb] = saber_interact_kingbobomb,
    [id_bhvBreakableBox] = saber_interact_breakablebox,
    [id_bhvBreakableBoxSmall] = saber_interact_breakableboxsmall,
    [id_bhvExclamationBox] = saber_interact_exclamationbox,
    [id_bhvBowlingBall] = saber_interact_chainchomp,
    [id_bhvPitBowlingBall] = saber_interact_chainchomp,
    [id_bhvFreeBowlingBall] = saber_interact_chainchomp,
    -- WF
    [id_bhvKickableBoard] = saber_interact_bridge,
    [id_bhvWfBreakableWallLeft] = saber_interact_breakablewall,
    [id_bhvWfBreakableWallRight] = saber_interact_breakablewall,
    [id_bhvSmallWhomp] = saber_interact_whomp,
    [id_bhvWhompKingBoss] = saber_interact_whompking,
    [id_bhvPiranhaPlant] = saber_interact_piranhaplant,
    [id_bhvBulletBill] = saber_interact_bulletbill,
    -- CM
    [id_bhvSpindrift] = saber_interact_enemygeneral,
    [id_bhvMrBlizzard] = saber_interact_mrblizzard,
    -- BBH
    [id_bhvBoo] = saber_interact_boo,
    [id_bhvGhostHuntBoo] = saber_interact_boo,
    [id_bhvFlyingBookend] = saber_interact_enemygeneral,
    [id_bhvHauntedChair] = saber_interact_enemygeneral,
    [id_bhvBooWithCage] = saber_interact_boo,
    [id_bhvBookSwitch] = saber_interact_normal,
    [id_bhvMerryGoRoundBoo] = saber_interact_boo,
    [id_bhvBalconyBigBoo] = saber_interact_boo,
    [id_bhvGhostHuntBigBoo] = saber_interact_boo,
    [id_bhvMerryGoRoundBigBoo] = saber_interact_boo,
    [id_bhvMadPiano] = saber_interact_chainchomp,
    -- LLL
    [id_bhvMrI] = saber_interact_mri,
    [id_bhvSmallBully] = saber_interact_bully,
    [id_bhvBigBully] = saber_interact_bully,
    [id_bhvBigBullyWithMinions] = saber_interact_bully,
    -- SSL
    [id_bhvPokey] = saber_interact_enemygeneral,
    [id_bhvPokeyBodyPart] = saber_interact_enemygeneral,
    [id_bhvKlepto] = saber_interact_klepto,
    [id_bhvFlyGuy] = saber_interact_enemygeneral,
    [id_bhvEyerokHand] = saber_interact_eyerokhand,
    [id_bhvJumpingBox] = saber_interact_jumping_box,
    -- HMC
    [id_bhvScuttlebug] = saber_interact_enemygeneral,
    [id_bhvSnufit] = saber_interact_enemygeneral,
    [id_bhvSwoop] = saber_interact_enemygeneral,
    [id_bhvBigBoulder] = saber_interact_chainchomp,
    -- THI
    [id_bhvFirePiranhaPlant] = saber_interact_firepiranhaplant,
    [id_bhvChuckya] = saber_interact_chuckya,
    [id_bhvEnemyLakitu] = saber_interact_enemygeneral,
    [id_bhvSpiny] = saber_interact_spiny,
    [id_bhvWigglerHead] = saber_interact_wigglerhead,
    -- TTM
    [id_bhvMontyMole] = saber_interact_monty_mole,
    -- WDW
    [id_bhvSkeeter] = saber_interact_enemygeneral,
    -- SL
    [id_bhvSmallChillBully] = saber_interact_bully,
    [id_bhvBigChillBully] = saber_interact_bully,
    [id_bhvMoneybag] = saber_interact_enemygeneral,
    -- BOWSER
    [id_bhvBowser] = saber_interact_bowser,
    [id_bhvBowserBomb] = saber_interact_bowser_bomb,
}

function saberattack(obj, saber_dmg, saber_pos, is_multi_hit, playerIndex)
    local hurtenemy = false
    local enemyobj

    local actualtable = saberhurtableenemy
    -- Detect if SR enemies are present
    if (bhvSMSRShyGuy) then
        actualtable[bhvSMSRSmallBee] = saber_interact_srnormal
        actualtable[bhvSMSRShyGuy] = saber_interact_srnormal
    end
    
    for key,value in pairs(actualtable) do --actualtable is a table of enemies that can be hurt by sabers with each enemy stored by behaviorid
        enemyobj = obj_get_nearest_object_with_behavior_id(obj,key) --get nearest hitable obj
        for i = obj.oFurthestHitbox, 1, -1 do
            local chargeIndex = i
            local hitboxX = obj.parentObj.oPosX + sins(obj.parentObj.oMoveAngleYaw) * coss(obj.parentObj.oMoveAnglePitch) * obj.hitboxRadius * 2 * chargeIndex
            local hitboxY = obj.parentObj.oPosY - sins(obj.parentObj.oMoveAnglePitch) * obj.hitboxHeight * chargeIndex - obj.hitboxDownOffset * 2
            local hitboxZ =  obj.parentObj.oPosZ + coss(obj.parentObj.oMoveAngleYaw) * coss(obj.parentObj.oMoveAnglePitch) * obj.hitboxRadius * 2 * chargeIndex
            if obj_check_overlap_with_hitbox_params(enemyobj, hitboxX, hitboxY, hitboxZ, obj.hitboxHeight, obj.hitboxRadius, obj.hitboxDownOffset) then
                if actualtable[key] and (is_multi_hit == 1 or (zsaber_active_hits[obj.oSyncID] ~= nil and not zsaber_active_hits[obj.oSyncID][enemyobj.oSyncID])) then
                    hurtenemy = actualtable[key](enemyobj, obj.oSyncID, saber_dmg, saber_pos, playerIndex)
                    break
                end
            end
        end
    end
    return hurtenemy
end




-----------------------------------------------------------------
-----------------------------------------------------------------
----- HITBOX BEHAVIOR -------------------------------------------
-----------------------------------------------------------------
-----------------------------------------------------------------

function zsaber_hitbox_init(o)
    network_init_object(o, true, { 'oSyncID', 'oBehParams2ndByte' })
    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]
    if m.playerIndex == 0 then
        local s = gPlayerSyncTable[0]
        s.zero_hit_stop = 0
    end
    if (o.oSaberIndex == o.oFurthestHitbox) then
        --djui_chat_message_create(tostring(m.playerIndex))
        zsaber_active_hits[o.oSyncID] = {}
        o.oBehParams2ndByte = 0
        zsaber_time_stopped[o.oSyncID] = 0
        zsaber_time_stop_cooldown[o.oSyncID] = 3
    end
    o.oFlags = OBJ_FLAG_UPDATE_GFX_POS_AND_ANGLE
    obj_set_model_extended(o, E_model_hitcylinder)
    cur_obj_hide()
    if (m.playerIndex ~= 0) then
        if gServerSettings.playerInteractions ~= PLAYER_INTERACTIONS_NONE then
            o.oInteractType = INTERACT_DAMAGE
            o.oIntangibleTimer = 0
            if gServerSettings.playerInteractions == PLAYER_INTERACTIONS_PVP then
                o.oDamageOrCoinValue = 2
            end
        end
    end
    --o.hitboxRadius            = 70
    --o.hitboxHeight            = 140
    --o.hitboxDownOffset        = 70
    
    -- oSaberIndex refers to how many chained hitboxes are there
    --if (o.oSaberIndex > 1) then
    --    spawn_sync_object(id_bhvZsaberHitBox, E_MODEL_NONE, o.oPosX, o.oPosY, o.oPosZ, function(obj)
    --        obj.parentObj = o.parentObj
    --        obj.oBehParams = o.oBehParams
    --        obj.oOwner = o.oOwner
    --        obj.oSaberIndex = o.oSaberIndex - 1
    --        obj.hitboxRadius = o.hitboxRadius
    --        obj.hitboxHeight = o.hitboxHeight
    --        obj.hitboxDownOffset = o.hitboxDownOffset
    --    end)
    --end
    --network_init_object(o, false, nil)
end

function zsaber_hitbox_loop(o)
    --disable_time_stop()
    --disable_time_stop_including_mario()
    
    
    local np = network_player_from_global_index(o.oOwner)
    local m = gMarioStates[np.localIndex]
    local s = gPlayerSyncTable[m.playerIndex]
    if s.zero_hit_stop > 0 then
        o.oTimer = o.oTimer - 1
    end
    if (o.oTimer > 0) then
        if (o.oTimer == 1) then
            --obj_scale_xyz(o, o.hitboxRadius / 50, o.hitboxHeight / 100, o.hitboxRadius / 50)
            --cur_obj_unhide()
        end
        if (o.oSaberIndex == o.oFurthestHitbox) then
            if o.oBehParams2ndByte == 0 and saberattack(o, o.oMmxAtkDmg, {x = o.oPosX, y = o.oPosY, z = o.oPosZ}, o.oIsMultiHit, m.playerIndex) then
                if (o.oBehParams ~= 12) then
                    if m.playerIndex == 0 and s.zero_hit_stop == 0 then
                        s.zero_hit_stop = 3
                    end
                    o.oBehParams2ndByte = 3
                end
            end
        end
    end
    
    local isHeavySlash = 0
    -- heavy zsaber
    if o.oBehParams == 3 then
        isHeavySlash = 1
        if o.oTimer > 5 then
            o.hitboxRadius = 37.5 - (o.oTimer - 6) * 7
        end
    end
    -- Follows the base of the zsaber beam
    -- Offset by the rotation of the zsaber at all steps
    -- oMoveAngleRoll hardly matters
    o.oPosX = o.parentObj.oPosX + sins(o.parentObj.oMoveAngleYaw) * coss(o.parentObj.oMoveAnglePitch) * o.hitboxRadius * 2 * o.oSaberIndex
    o.oPosY = o.parentObj.oPosY - sins(o.parentObj.oMoveAnglePitch) * o.hitboxHeight * o.oSaberIndex - o.hitboxDownOffset * 2
    o.oPosZ = o.parentObj.oPosZ + coss(o.parentObj.oMoveAngleYaw) * coss(o.parentObj.oMoveAnglePitch) * o.hitboxRadius * 2 * o.oSaberIndex
    
    local firstHitboxDelay = 0

    -- Hit stop
    if (o.oSaberIndex == o.oFurthestHitbox and o.oBehParams ~= 12) then
        if (m.playerIndex == 0) then
            if (s.zero_hit_stop == 3) then
                enable_time_stop_including_mario()
            end
    
            if s.zero_hit_stop > 0 then
                s.zero_hit_stop = s.zero_hit_stop - 1
            end
            
            if (s.zero_hit_stop == 0) then
                if o.activeFlags & ACTIVE_FLAG_INITIATED_TIME_STOP ~= 0 then
                    disable_time_stop_including_mario()
                    --djui_chat_message_create('resume time')
                end
            end
        end

        if (o.oBehParams2ndByte ~= nil and o.oBehParams2ndByte > 0) then
            o.oBehParams2ndByte = o.oBehParams2ndByte - 1
        end
    end

    if (baseDeleteConditionTable[o.oBehParams](m, o.oTimer + isHeavySlash) ~= false or not obj_has_behavior_id(o.parentObj, id_bhvSaber)) then
        if (o.oSaberIndex == o.oFurthestHitbox and o.oBehParams ~= 12) then
            zsaber_active_hits[o.oSyncID] = nil
            o.oBehParams2ndByte = 0
            if m.playerIndex == 0 then
                s.zero_hit_stop = 0
                if o.activeFlags & ACTIVE_FLAG_INITIATED_TIME_STOP ~= 0 then
                    disable_time_stop_including_mario()
                    --djui_chat_message_create('reset resume time')
                end
            end
        end
        o.oInteractType = 0
        if m.playerIndex == 0 then
            obj_mark_for_deletion(o)
        end
    end

    -- Failsafe in case a player disconnects while having a hitbox out
    if o.oTimer > 75 then
        obj_mark_for_deletion(o)
    end
end

id_bhvZsaberHitBox = hook_behavior(nil, OBJ_LIST_GENACTOR, false, zsaber_hitbox_init, zsaber_hitbox_loop)